<?php
//error_reporting(E_ALL);
##############################################################################
#                                                                            #
#      This file is part of IXPRIM CMS - Content Management System           #
#                       <http:#www.ixprim-cms.org/>                          #
#                                                                            #
#   Copyright (c) 2006 Christophe Deltheil <aka trollix> and contributors.   #
#                      All rights reserved.                                  #
# -------------------------------------------------------------------------- #
# ideas come from :                                                          #
# POSTNUKE Web Portal System - http://postnuke.org/                          #
# XOOPS Web Portal System - http://xoops.org/                                #
# myPHPNUKE Web Portal System - http://myphpnuke.com/                        #
# PHP-NUKE Web Portal System - http://phpnuke.org/                           #
# Thatware - http://thatware.org/                                            #
# dotclear Blog System - http://dotclear.net/                                #
# -------------------------------------------------------------------------- #
#  Ixprim CMS is free software; you can redistribute it and/or modify        #
#  it under the terms of the GNU General Public License as published by      #
#  the Free Software Foundation; either version 2 of the License, or         #
#  (at your option) any later version.                                       #
#                                                                            #
#  Ixprim CMS is distributed in the hope that it will be useful,             #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of            #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
#  GNU General Public License for more details.                              #
#                                                                            #
#  You should have received a copy of the GNU General Public License         #
#  along with this program; if not, write to the Free Software               #
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA  #
##############################################################################
class ixpModuleAdmin extends ixpModule {

	var $initmodconf = "'a:3:{s:17:\"moduleThemeLayout\";s:7:\"default\";s:10:\"indexcache\";s:1:\"0\";s:11:\"indexlayout\";s:1:\"0\";}'";
	var $adminmenu = array();

	//--------------------------------------------------------------------
	// getHasModRewriteList: liste des modules actifs avec modrewrite
	//--------------------------------------------------------------------
	function getHasModRewriteList($aslist = true) {

		global $ixpdb;

		$ret = array();
		$result = $ixpdb->sql_query("SELECT mid,name from ".TBL_MODULES." WHERE isactive=1 AND hasmodrewrite=1 ORDER BY weight, name ASC");
		
		while ( $myrow=$ixpdb->sql_fetchrow($result) ) { //fetchArray
			if ($aslist) {
				$ret[$myrow['mid']] = $myrow['name'];
			} else {
				$ret[] = $myrow['mid'];
			}
		}

		$ixpdb->sql_freeresult($result);
		return $ret;
	}

	//--------------------------------------------------------------------
	// get_module_htaccess_file_content_str: fabrique la partie htaccess
    // du modrewrite pour tous les modules avec modrewrite
	//--------------------------------------------------------------------
    function get_module_htaccess_file_content_str() 
    {
	    $content_htacces = "# Rewrite Rules\nRewriteEngine On\n";
	    $mids = ixpModuleAdmin::getHasModRewriteList(false); //liste des modules ayant hasadmin==1

	    foreach ( $mids as $mid ) { //parcours en boucle de cette liste

		    $mod = new ixpModuleAdmin($mid);

		    if (!empty($mod->modinfo2['rewrite']['rules'])) {
			
			    $content_htacces = $content_htacces."\n\n# Module: ".$mod->dirname()."\n";
			    foreach ( $mod->modinfo2['rewrite']['rules'] as $item ) {
				    $content_htacces = $content_htacces.$item."\n";
			    }
		    }
	    }
	    return $content_htacces;
    }

	function getByDirname($dirname)
	{
		global $ixpdb; // A voir pour mettre dans $GLOBAL

		$ret = false;
		if (!empty($dirname)) {

			$sql = "SELECT * FROM ".TBL_MODULES." WHERE dirname = '".trim($dirname)."'";
			if ( $result = $ixpdb->sql_query($sql) ) {
				$count = $ixpdb->sql_numrows($result);
				if ( $count == 1 ) {
					$arr = $ixpdb->sql_fetchrow($result);
					$ret = new ixpModuleAdmin($arr);//print_r($ret);
				}
				$ixpdb->sql_freeresult($result);
			}
		}
		return $ret;
	}

	//--------------------------------------------------------------------
	//  activate()
	//--------------------------------------------------------------------
	function activate() {

		if (!isset($this->weight) || !is_numeric($this->weight)) {
			$this->weight = 0;
		}
		$sql = "UPDATE ".TBL_MODULES." SET last_update=".time().", weight=".$this->weight.", isactive=1 WHERE mid=".$this->mid."";
		if (!$result = $this->db->sql_query($sql)) {
			array_push($this->errors,"Could not update modules table");
			return false;
		}
		$sql = "UPDATE ".$this->db->prefix("ixpblocks")." SET isactive=1 WHERE mid=".$this->mid."";
		if ( !$result = $this->db->sql_query($sql) ) {
			array_push($this->errors,$this->db->sql_error());
			return false;
		}
		return true;
	}

	//--------------------------------------------------------------------
	// deactivate
	//--------------------------------------------------------------------
	function deactivate(){

		if ( !isset($this->weight) || !is_numeric($this->weight) ) {
			$this->weight = 0;
		}
		$sql = "UPDATE ".TBL_MODULES." SET last_update=".time().", weight=".$this->weight.", isactive=0 WHERE mid=".$this->mid."";
		if ( !$result = $this->db->sql_query($sql) ) {
			array_push($this->errors,$this->db->sql_error());
			return false;
		}
		$sql = "UPDATE ".$this->db->prefix("ixpblocks")." SET isactive=0 WHERE mid=".$this->mid."";
		if ( !$result = $this->db->sql_query($sql) ) {
			array_push($this->errors,$this->db->sql_error());
			return false;
		}
		return true;
	}

	//--------------------------------------------------------------------
   	// Install a module
	// If the module has blocks, insert blocks info in blocks table
	//--------------------------------------------------------------------
	function install($create_tbl=true) {
		global $ixpdbConfig;

		$error = false;
		if ($create_tbl != false) 
		{
			if ( !empty($this->modinfo2['sqlfile']) && is_array($this->modinfo2['sqlfile']) ) 
			{
				$sql_file_path = IXP_ROOT_PATH."/mod/".$this->dirname()."/".$this->modinfo2['sqlfile'][$ixpdbConfig['database']];
				if ( !file_exists($sql_file_path) ) 
				{
					array_push($this->errors,"SQL file not found at $sql_file_path!");
					$error = true;
				} 
				else 
				{
					$sql_query = fread(fopen($sql_file_path, 'r'), filesize($sql_file_path));
        			if (get_magic_quotes_runtime() == 1) 
					{
        				$sql_query = stripslashes($sql_query);
					}
					$sql_query = trim($sql_query);
					splitSqlFile($pieces, $sql_query);
					$created_tables = array();
					
					foreach ( $pieces as $piece ) {

						// [0] contains the prefixed query
						// [4] contains unprefixed table name
						$prefixed_query = prefixQuery($piece, $this->db->prefix());
						// check if the table name is reserved 
						if ( !$prefixed_query ) {
							array_push($this->errors,"$piece is not a valid SQL!");
							$error = true;
							break;
						}
						// check if the table name is reserved 
						if ( !in_array($prefixed_query[4], $this->reservedTables) ) {
							// not reserved, so try to create one
							if ( !$this->db->sql_query($prefixed_query[0]) ) {
								array_push($this->errors,$this->db->sql_error());
								$error = true;
								break;
							} else {
								if ( !in_array($prefixed_query[4], $created_tables) ) {
									$created_tables[] = $prefixed_query[4];
								}
							}
						} else {
							// the table name is reserved, so halt the installation
							array_push($this->errors,$prefixed_query[4]." is a reserved table!");
							$error = true;
							break;
						}
					}
					// if there was an error, delete the tables created so far, so the next installation will not fail
					if ( $error == true ) {
						foreach ($created_tables as $ct) {
							//echo $ct;
							$this->db->sql_query("DROP TABLE ".$this->db->prefix($ct)."");
						}
					}
				}
			}
		}

		// if no error, save the module info and blocks info associated with it
		if ( !$error ) {
            
			$modconf_conf_array = array();
			$newmid = $this->db->sql_genId($this->db->prefix("modules")."_mid_seq");
			
			if (!isset($this->modinfo2['hasAdmin']) || $this->modinfo2['hasAdmin'] != 1) {
				$this->modinfo2['hasAdmin'] = 0;
			}
			
			if (!isset($this->modinfo2['hasMain']) || $this->modinfo2['hasMain'] != 1) {
				$this->modinfo2['hasMain'] = 0;
			}
			
			if (!isset($this->modinfo2['hasSearch']) || $this->modinfo2['hasSearch'] != 1) {
				$this->modinfo2['hasSearch'] = 0;
			}

			// Teste si ce module a l'option waiting (lien dans le bloc admin)
			if (!isset($this->modinfo2['hasWaiting']) || $this->modinfo2['hasWaiting'] != 1) {
				$this->modinfo2['hasWaiting'] = 0;
			}

			// Teste si ce module a l'option xml rss, pda ...
			if (!isset($this->modinfo2['hasXml']) || $this->modinfo2['hasXml'] != 1) {
				$this->modinfo2['hasXml'] = 0;
                $modconf_conf_array['options']['hasXml']='0';
			} else {
                $modconf_conf_array['options']['hasXml']='1';
            }


			// Teste si ce module a l'option hasUserfields (champs dans la table users)
			if (!isset($this->modinfo2['hasUserfields']) || $this->modinfo2['hasUserfields'] != 1) {
				$this->modinfo2['hasUserfields'] = 0;
			}

			// Teste si ce module a l'option waiting (lien dans le bloc admin)
			if (!isset($this->modinfo2['hasUserconf']) || $this->modinfo2['hasUserconf'] != 1) {
				$this->modinfo2['hasUserconf'] = 0;
			}

			// Teste si ce module a l'option mod_rewrite (rcriture des liens)
			if (!isset($this->modinfo2['hasModRewrite']) || $this->modinfo2['hasModRewrite'] != 1) {
				$this->modinfo2['hasModRewrite'] = 0;
			}


			if (!isset($this->weight) || !is_numeric($this->weight)) {	
				$this->weight = 1;
			}

			if (isset($this->modinfo2['weight']) && is_numeric($this->modinfo2['weight'])) {	
				$this->weight = $this->modinfo2['weight'];
			}

			if (isset($this->modinfo2['installforall']) && is_numeric($this->modinfo2['installforall'])) {	
				$this->installforall = $this->modinfo2['installforall'];
			}

            // Mise  jour du tableau modconf_conf_array
            $modconf_conf_array_serialized = addslashes(serialize($modconf_conf_array));

			$version = $this->modinfo2['version'] * 100;
			$sql = "INSERT INTO ".$this->db->prefix("modules")." (mid, name, dirname, version, last_update, weight, isactive, hasmain, hasadmin, hassearch, haswaiting, hasuserconf, hasuserfields, hasmodrewrite, modconf, modconf_mod, install_time) VALUES ($newmid, '".addslashes($this->modinfo2['name'])."', '".addslashes($this->modinfo2['dirname'])."', ".$version.", ".time().", ".$this->weight.", 1, ".$this->modinfo2['hasMain'].", ".$this->modinfo2['hasAdmin'].", ".$this->modinfo2['hasSearch'].", ".$this->modinfo2['hasWaiting'].", ".$this->modinfo2['hasUserconf'].", ".$this->modinfo2['hasUserfields'].", ".$this->modinfo2['hasModRewrite'].", ".$this->initmodconf.", '".$modconf_conf_array_serialized."', ".time()." )";
			
			if (!$this->db->sql_query($sql)) {
				array_push($this->errors, $sql);
				foreach ($created_tables as $ct) {
					//echo $ct;
					$this->db->sql_query("DROP TABLE ".$this->db->prefix($ct)."");
				}
				return false;
			} else {
				
				if (empty($newmid)) {
					$newmid = $this->db->sql_nextid();
				}
				//foreach ( $created_tables as $ct ) {
				//	$sql = "INSERT INTO ".$this->db->prefix("module_tables")." (mid, table) VALUES ($newmid, '$ct')";
				//	$this->db->sql_query($sql);
				//}

				// si $modinfo['blocks'] est initialis (il y a au moins un bloc)
				if ( isset($this->modinfo2['blocks']) ) {

					$i = 1;
					foreach ( $this->modinfo2['blocks'] as $block ) {
						$options = "";
						if ( isset($block['options']) && $block['options']!= "" ) {
							$options = $block['options'];
						}
						$newbid = $this->db->sql_genId($this->db->prefix("blocks")."_bid_seq");
						$sql = "INSERT INTO ".$this->db->prefix("ixpblocks")." (bid, mid, func_num, options, name, position, title, content, side, weight, visible, type, isactive) VALUES ($newbid, $newmid, $i,'$options','".addslashes($block['name'])."',0,'','',0,0,0,'M',1)";
						if ( !$this->db->sql_query($sql) ) {
							array_push($this->errors,$this->db->sql_error());
						}
						$i++;
					}
				}
			}

		// ici on ajoute dans la base de donnes les champs supplmentaires
		if ( isset($this->modinfo2['fields']) ) {
			$i = 1;
			foreach ( $this->modinfo2['fields'] as $field ) {
				$options = "";
				if ( isset($field['options']) && $field['options']!= "" ) {
					$options = $field['options'];
				}
				$newbid = $this->db->sql_genId($this->db->prefix("blocks")."_bid_seq2");
				
				$sql = "INSERT INTO ".$this->db->prefix("users_more_config")." (field, fieldname, required, type, length, hidden_in_profile, module, valuedefault) VALUES ('".$this->dirname().'_'.$field['fieldname']."', '".$field['fieldnamedisplayed']."', '".$field['required']."', '".$field['fieldtype']."', '".$field['fieldlength']."', '".$field['hidden_in_profile']."', '".$this->dirname()."', '".$field['default']."')";
					
				if (!$this->db->sql_query($sql)) {
					array_push($this->errors,$this->db->sql_error());
				}

				$sql = "ALTER TABLE  `".$this->db->prefix("users")."` ADD `".$this->dirname().'_'.$field['fieldname']."`  ".$field['fieldtype']."( ".$field['fieldlength']." ) DEFAULT '".$field['default']."' NOT NULL";
						
				if (!$this->db->sql_query($sql)) {
					array_push($this->errors,$this->db->sql_error());
				}
				$i++;
			}
		}
		
			
		return $newmid;
		} 
		
		else {
			return false;
		}
	}


    //-----------------------------------------------------------------------
	// Dsinstallation du module											 
    //-----------------------------------------------------------------------
	function uninstall()
	{
		
		// Suppression des tables du module
		$sql = "DELETE FROM ".$this->db->prefix("modules")." WHERE mid=".$this->mid."";
		if ( !$this->db->sql_query($sql) ) {
			array_push($this->errors, $this->db->sql_error());
			return false;
		}

		// Supression des champs user si ncessaire
		if ( isset($this->modinfo2['fields']) ) {
			$i = 1;
			foreach ( $this->modinfo2['fields'] as $field ) {
				$sql = "DELETE FROM ".$this->db->prefix("users_more_config")." WHERE module like '".$this->dirname()."'";
				if ( !$this->db->sql_query($sql) ) {
					array_push($this->errors,$this->db->sql_error());
				}

				$sql = "ALTER TABLE  ".$this->db->prefix("users")." DROP `".$this->dirname().'_'.$field['fieldname']."`";
				if (!$this->db->sql_query($sql)) {
					array_push($this->errors,$this->db->sql_error());
				}

				$i++;
			}
		}

		// Suppression des liens depuis la table des modules
		$sql = "DELETE FROM ".TBL_GROUPS_MODULES_LINK." WHERE mid=".$this->mid."";
		if ( !$this->db->sql_query($sql) ) {
			array_push($this->errors, $this->db->sql_error());
		}
		
		$block_arr = ixpBlock::getByModule($this->mid);
		foreach ( $block_arr as $block ) {
			if ( !$block->delete() ) {
				array_push($this->errors, "Could not delete block. Block name: ".$block->name()." Block ID: ".$block->bid());
			}
		}

		if ( !empty($this->modinfo2['tables']) && is_array($this->modinfo2['tables']) ) {
			foreach ( $this->modinfo2['tables'] as $table ) {
				// prevent deletion of reserved core tables!
				if ( !in_array($table, $this->reservedTables) ) {
					$sql = "DROP TABLE ".$this->db->prefix($table)."";
					if ( !$this->db->sql_query($sql) ) {
						array_push($this->errors, "Could not delete table ".$this->db->prefix($table)."");
					}
				} else {
					array_push($this->errors, "Not allowed to delete table ".$this->db->prefix($table)."!");
				}
			}
		}

		if ( count($this->errors) > 0 ) {
			return false;
		}
		return true;
	}

	//-----------------------------------------------------------------------
   	// Updates module info in module table and blocks info in blocks table.
	// It is generally used when blocks are added or modified.
	// Or to change the block title in blocks admin menu.
	// This does not change the actual block contents in DB
	//-----------------------------------------------------------------------
	function update( $option='update') {

        // Mise  jour de modconf_conf_array par lecture de la BD champ modconf_conf
        // qui est un tableau srialis
        $sql = "SELECT modconf_mod FROM ".$this->db->prefix("modules")."  WHERE mid=".$this->mid."";
        $result = $this->db->sql_query( $sql );
        list( $modconf_conf_array ) = $this->db->sql_fetchrow( $result );
        $modconf_conf_array = unserialize( stripslashes( $modconf_conf_array ) );

		if ( !isset($this->modinfo2['hasAdmin']) || $this->modinfo2['hasAdmin'] != 1 ) {
			$this->modinfo2['hasAdmin'] = 0;
		}
		if ( !isset($this->modinfo2['hasMain']) || $this->modinfo2['hasMain'] != 1 ) {
			$this->modinfo2['hasMain'] = 0;
		}
		
		if ( !isset($this->modinfo2['hasSearch']) || $this->modinfo2['hasSearch'] != 1 ) {
			$this->modinfo2['hasSearch'] = 0;
		}

		if ( !isset($this->modinfo2['hasWaiting']) || $this->modinfo2['hasWaiting'] != 1 ) {
			$this->modinfo2['hasWaiting'] = 0;
		}

		if ( !isset($this->modinfo2['hasXml']) || $this->modinfo2['hasXml'] != 1 ) {
			$this->modinfo2['hasXml'] = 0;
            $modconf_conf_array['options']['hasXml']='0';
		}
        else {
            $modconf_conf_array['options']['hasXml']='1';
        }

		if ( !isset($this->modinfo2['hasUserconf']) || $this->modinfo2['hasUserconf'] != 1 ){
			$this->modinfo2['hasUserconf'] = 0;
		}

		if ( !isset($this->modinfo2['hasUserfields']) || $this->modinfo2['hasUserfields'] != 1 ) {
			$this->modinfo2['hasUserfields'] = 0;
		}

		if ( !isset($this->modinfo2['hasModRewrite']) || $this->modinfo2['hasModRewrite'] != 1 ) {
				$this->modinfo2['hasModRewrite'] = 0;
		}

		if ( !isset($this->weight) || !is_numeric($this->weight) ) {
			$this->weight = 0;
		}
		if (isset($this->modinfo2['weight'])){
			$this->weight = $this->modinfo2['weight'];
		}
		if (isset($this->modinfo2['installforall'])){
			$this->installforall = $this->modinfo2['installforall'];
		}
        
        // Mise  jour du tableau modconf_conf_array
        $modconf_conf_array_serialized = addslashes(serialize($modconf_conf_array));

		$version = floor($this->modinfo2['version'] * 100);
		$sql = "UPDATE ".$this->db->prefix("modules")." SET name='".addslashes($this->modinfo2['name'])."', dirname='".addslashes($this->modinfo2['dirname'])."', version=".$version.", last_update=".time().", weight=".$this->weight.", hasmain=".$this->modinfo2['hasMain'].", hasadmin=".$this->modinfo2['hasAdmin'].", hassearch=".$this->modinfo2['hasSearch'].", haswaiting=".$this->modinfo2['hasWaiting'].", hasuserconf=".$this->modinfo2['hasUserconf'].", hasuserfields=".$this->modinfo2['hasUserfields'].", hasmodrewrite=".$this->modinfo2['hasModRewrite'].", modconf_mod='".$modconf_conf_array_serialized."' WHERE mid=".$this->mid."";
		
		if (!$result = $this->db->sql_query($sql)) {
			array_push($this->errors,$this->db->sql_error());
		}
		

		// ici on ajoute dans la base de donnes les champs supplmentaires
		if ( isset($this->modinfo2['fields']) ) {
			$i = 1;
			foreach ( $this->modinfo2['fields'] as $field ) {
				$options = "";
				if ( isset($field['options']) && $field['options']!= "" ) {
					$options = $field['options'];
				}
				$newbid = $this->db->sql_genId($this->db->prefix("blocks")."_bid_seq2");
				
				$sql = "REPLACE INTO ".$this->db->prefix("users_more_config")." (field, fieldname, required, type, length, hidden_in_profile, module, valuedefault) VALUES ('".$this->dirname().'_'.$field['fieldname']."', '".$field['fieldnamedisplayed']."', '".$field['required']."', '".$field['fieldtype']."', '".$field['fieldlength']."', '".$field['hidden_in_profile']."', '".$this->dirname()."', '".$field['default']."')";
					
				if ( !$this->db->sql_query($sql) ) {
					array_push($this->errors,$this->db->sql_error());
				}

				$sql = "ALTER TABLE  ".$this->db->prefix("users")." CHANGE `".$this->dirname().'_'.$field['fieldname']."` `".$this->dirname().'_'.$field['fieldname']."` ".$field['fieldtype']."(".$field['fieldlength'].") NOT NULL";
				if ( !$this->db->sql_query($sql) ) {
					array_push($this->errors,$this->db->sql_error());
				}
				$i++;
			}
		}


	
        if ($option=='reinit') {

		if ( isset($this->modinfo2['blocks']) ) {
			$i = 0;
			foreach ( $this->modinfo2['blocks'] as $block ) {
				$i++;
				$options = "";
				
				if ( isset($block['options']) && $block['options']!= "" ) {
					$options = $block['options'];
				}
				
				#TiX: COUNT (*) by COUNT(bid)
				$sql = "SELECT COUNT(bid) FROM ".$this->db->prefix("ixpblocks")." WHERE mid=".$this->mid." AND func_num=".$i."";
				list($count) = $this->db->sql_fetchrow($this->db->sql_query($sql)); //fetchRow
				
				if ( $count > 0 ) {
					$sql = "UPDATE ".$this->db->prefix("ixpblocks")." SET options='".$options."', name='".addslashes($block['name'])."' WHERE mid=".$this->mid." AND func_num=".$i."";
				} 
                else {
					$newbid = $this->db->sql_genId($this->db->prefix("blocks")."_bid_seq");
					$sql = "INSERT INTO ".$this->db->prefix("ixpblocks")." (bid, mid, func_num, options, name, position, title, content, side, weight, visible, type, isactive) VALUES (".$newbid.", ".$this->mid.", ".$i.",'".$options."','".addslashes($block['name'])."',0,'','',0,0,0,'M',1)";
				}
				if ( !$result = $this->db->sql_query($sql) ) {
					array_push($this->errors,"Could not update ".$block['name']."");
				}
			}

			#TiX: COUNT (*) by COUNT(bid)
			$sql = "SELECT COUNT(bid) FROM ".$this->db->prefix("ixpblocks")." WHERE mid=".$this->mid."";
			list($count) = $this->db->sql_fetchrow($this->db->sql_query($sql)); //fetchRow
			if ( $count > $i ) {
				for ( $j = $i + 1; $j <= $count; $j++ ) {
					$sql = "DELETE FROM ".$this->db->prefix("ixpblocks")." WHERE mid=".$this->mid." AND func_num=".$j."";
					$this->db->sql_query($sql);
				}
			}
		}
        }
		if ( count($this->errors) > 0 ) {
			return false;
		}
		return true;
	}

	//-----------------------------------------------------------------------
	// changeOrder
	//-----------------------------------------------------------------------
	function changeOrder($order){
		if ( empty($order) || !is_numeric($order) ) {
			$order = 0;
		}
		$sql = "UPDATE ".TBL_MODULES." SET weight=".$order." WHERE mid=".$this->mid."";
		if ( !$this->db->sql_query($sql) ) {
			array_push($this->errors,$this->db->sql_error());
			return false;
		}
		return true;
	}

	function getActiveModules($with_ixp_system=false, $asobject=true)
	{
		global $ixpdb;

		$ret = array();
		
		if ($with_ixp_system) {
			$sql = "SELECT * from ".TBL_MODULES." WHERE isactive=1 ORDER BY weight, hasmain, name";
		}
		else {
			$sql = "SELECT * from ".TBL_MODULES." WHERE isactive=1 and mid<>1 ORDER BY weight, hasmain, name";
		}

		$result = $ixpdb->sql_query($sql);
		while ( $myrow = $ixpdb->sql_fetchrow($result) ) //fetchArray
		{
			if ( $asobject == true ) {
				$ret[] = new ixpModuleAdmin($myrow);
			} else {
				$ret[] = $myrow['mid'];
			}
		}
		$ixpdb->sql_freeresult($result);
		return $ret;
	}

	//-----------------------------------------------------------------------
	// installforall
	//-----------------------------------------------------------------------
	function installforall(){
		return $this->installforall;
	}

	//-----------------------------------------------------------------------
	// mainLink2
	//-----------------------------------------------------------------------
	function mainLink2() {	#Tix: Traduction
		if ($this->hasMain()) {
			return('<a class="mainmenulink" href="'.IXP_MAINMENULINK_PREFIX.'/ixm_'.$this->dirname().'.php">'.$this->mainmenu_name().'</a>');
		}
		return false;
	}

	//-----------------------------------------------------------------------
	// subLink2
	//-----------------------------------------------------------------------
	function subLink2( $p_user=0 ) {

		$ret = array();
		if (isset($this->modinfo2['sub']) && is_array($this->modinfo2['sub'])) {

			foreach ($this->modinfo2['sub'] as $submenu) {
							
				if ($p_user==3) {	// Si user est anonyme (key:3)
	
					// on checke. cas ou on affiche ou pas le sublink (cas archives oui, proposer:non )
					if ($submenu['anonpost_check']){
						if (IXPGLOBAL___anonpost) {	// si le post des anonymes est autoris
						  $ret[] .= '<a class="mainsubmenulink" href="'.IXP_MAINMENULINK_PREFIX.'/'.$submenu['url'].'">'.$submenu['name'].'</a>';
						}
					} else {
						$ret[] .= '<a class="mainsubmenulink" href="'.IXP_MAINMENULINK_PREFIX.'/'.$submenu['url'].'">'.$submenu['name'].'</a>';
					}						 

				} else {	// non anonyme - On affiche le sous lien
					$ret[] .= '<a class="mainsubmenulink" href="'.IXP_MAINMENULINK_PREFIX.'/'.$submenu['url'].'">'.$submenu['name'].'</a>';
				}

				
			}
			return $ret;
		}
		return false;
	}

	//-----------------------------------------------------------------------
	// getByRight
	//-----------------------------------------------------------------------
	function getByRight($groupid, $right="R") {
		
		global $ixpdb;

        // kana suggestion to have alphabetical order on menu
        $sql = "SELECT DISTINCT gml.mid FROM ".TBL_GROUPS_MODULES_LINK." as gml LEFT JOIN ".TBL_MODULES." as m ON m.mid = gml.mid WHERE type='".$right."'"; 


		if ( is_array($groupid) ) {
			$sql .= " AND (gml.groupid=".$groupid[0]."";
			$size = sizeof($groupid);
			if ( $size  > 1 ) {
				for ( $i = 1; $i < $size; $i++ ) {
					$sql .= " OR gml.groupid=".$groupid[$i]."";
				}
			}
			$sql .= ")";
		} else {
			$sql .= " AND gml.groupid=".$groupid."";
		}

        $sql .= " ORDER BY m.hasmain, m.weight, m.name"; 

		$result = $ixpdb->sql_query($sql);
		$mids = array();
		while ( $myrow = $ixpdb->sql_fetchrow($result) ) {	//fetchArray
			$mids[] = $myrow['mid'];
		}
		$ixpdb->sql_freeresult($result);
		return $mids;
	}

	//-----------------------------------------------------------------------
	// getBlocsOnModule
	//-----------------------------------------------------------------------
	function getBlocsOnModule($mid) {

		global $ixpdb;

		$ret = array();
		$sql = "SELECT blockstodisplay from ".TBL_MODULES." WHERE mid=".$mid." ORDER BY weight,hasmain ";
		$result = $ixpdb->sql_query($sql);
		$myrow = $ixpdb->sql_fetchrow($result, MYSQL_ASSOC); //fetchArray
		$ret = unserialize(stripslashes($myrow['blockstodisplay']));
		$ixpdb->sql_freeresult($result);
		return $ret;
	}

	//-----------------------------------------------------------------------
	// addBlocsOnModule
	//-----------------------------------------------------------------------
	function addBlocsOnModule( $mid, $blockToAdd ) {
		
		global $ixpdb;
		
		//$blockToAdd = (!empty($blockToAdd)) ? array_filter( $blockToAdd, 'notnull' ) : array();
		$blockToAdd = addslashes(serialize($blockToAdd));
		$sql = "UPDATE ".TBL_MODULES." SET blockstodisplay='".$blockToAdd."' WHERE mid=".$mid."";
		$result = $ixpdb->sql_query($sql);

		return $result;
	}


	//-----------------------------------------------------------------------
	// addBlocsOnModule: Get all php scripts in /modname/main
	//-----------------------------------------------------------------------
	function getAllMainPhpScripts() {
		return ixpLists::getPHPListAsArray( IXP_ROOT_PATH.'/mod/'.$this->dirname().'/main');
	}


	//-----------------------------------------------------------------------
	// getInstalledModulesWithMain
	//-----------------------------------------------------------------------
	function getInstalledModulesWithMain($hasmain=1, $asobject=true) {
		
		global $ixpdb;

		$ret = array();
		$sql = "SELECT * from ".TBL_MODULES." WHERE hasmain=".$hasmain." ORDER BY weight,hasmain ";
		$result = $ixpdb->sql_query($sql);
		
		while ($myrow = $ixpdb->sql_fetchrow($result)) {	//fetchArray
			if ( $asobject == true )	{ 
				$ret[] = new ixpModuleAdmin($myrow);
			} else { 
				$ret[] = $myrow['mid'];
			}
		}
		$ixpdb->sql_freeresult($result);
		return $ret;
	}



	//---------------------------------------------------------------------------
	// Function system menu
	//---------------------------------------------------------------------------
	function system_menu() {
	  
		$this->getAdminMenu();
		$seeonsite = $this->modinfo2['hasMain'] ? '<span class="atext-small">'
				.'[&nbsp;<a class="atext-small" href="'.IXP_ROOT_WEB.'/ixm_'.$this->dirname().'.php">'._SEEONSITE
				.'&nbsp;<img align="bottom" src="'.IXP_ROOT_WEB.'/images/target_no.gif" alt="Down" /></a>'
				.'&nbsp;<a href="'.IXP_ROOT_WEB.'/ixm_'.$this->dirname().'.php" target="_blank">'
				.'<img src="'.IXP_ROOT_WEB.'/images/target_blank.gif" align="bottom" alt="Up" /></a>'
				.'&nbsp;]</span>' : '';

		OpenBlock();
		OpenFieldset( _GALAD_MODULE.':&nbsp;&nbsp;'.$this->name2(), 'module', 'module' );
	  
		echo '<table width="100%">'
		.'<tr><td valign="top" width="150">'
		.'<a href="'.IXP_URL.'/mod/'.$this->dirname().'/admin/index.php" alt="'.$this->name2().'" title="'.$this->name2().'"><img src="'.IXP_ROOT_WEB.'/mod/'.$this->dirname().'/'.$this->modinfo2['image'].'" /></a><br /><br />'.$seeonsite.'</td>'
		.'<td valign="top" align="left">';
		echo '<ul type="square">';
	
		foreach( $this->adminmenu as $key ) {
			if (isset($key['login'])) {
				$key['link'] = str_replace( 'http://', 'http://'.$key['login'].'@', $key['link'] );
			}
			if ( isset($key['target']) ) {
				echo '<li><a href="'.$key['link'].'" target="'.$key['target'].'">'.$key['title'].'</a></li>'."\n";
			} else {
				echo '<li><a href="'.$key['link'].'">'.$key['title'].'</a></li>'."\n";
			}
		}
	
		echo '</ul>';
		echo '</td></tr></table>';
	
		CloseFieldset();
		CloseBlock();
    }

	//---------------------------------------------------------------------------
	// Function getAdminMenu
	//---------------------------------------------------------------------------
	function getAdminMenu() {
		$this->loadAdminMenu();
		return $this->adminmenu;
	}

	//---------------------------------------------------------------------------
	// Function getAdminMenu
	//---------------------------------------------------------------------------
	function loadAdminMenu() {
		
        global $ixpdbConfig;

		if ( isset($this->modinfo2['adminmenu']) && $this->modinfo2['adminmenu'] != "" && file_exists(IXP_ROOT_PATH."/mod/".$this->dirname()."/".$this->modinfo2['adminmenu']) ) {
			include_once(IXP_ROOT_PATH."/mod/".$this->dirname()."/language/".IXPGLOBAL___current_language."/admin.php");
			include_once(IXP_ROOT_PATH."/mod/".$this->dirname()."/".$this->modinfo2['adminmenu']);
			$this->adminmenu = $adminmenu;
		}
	}


	//---------------------------------------------------------------------------
	// Function mainmenu_name
	//---------------------------------------------------------------------------
	function mainmenu_name() {	#TiX: POur la traduction
	
		if ( isset($this->modinfo2['mainmenu']) ) {
			return $this->modinfo2['mainmenu'];
		} else {
			if ( isset($this->modinfo2['name']) ) {
				return $this->modinfo2['name'];
			} else {
				return false;
			}
		}
	}

	//---------------------------------------------------------------------------
	// Function load_admin_language
	//---------------------------------------------------------------------------
	function load_admin_language() {
		
		global $ixpUser;
	  
		if ( $ixpUser ) {
			if (!$ixpUser->isAdmin($this->mid())) { 
				redirect_header(IXP_ROOT_WEB.'/', 3, _NOPERM);;
				exit();
			}
		} else {
			redirect_header(IXP_ROOT_WEB.'/', 3, _NOPERM);
			exit();
		}

		if (file_exists(IXP_ROOT_PATH.'/mod/'.$this->dirname().'/language/'.IXPGLOBAL___current_language.'/admin.php') )  {
			include(IXP_ROOT_PATH.'/mod/'.$this->dirname().'/language/'.IXPGLOBAL___current_language.'/admin.php');
			include(IXP_ROOT_PATH.'/language/'.IXPGLOBAL___current_language.'/admin.php');
		} else {
			include(IXP_ROOT_PATH.'/mod'.$this->dirname().'/language/french/admin.php');
			include(IXP_ROOT_PATH.'/language/french/admin.php');
		}

	}

	//---------------------------------------------------------------------------
	// indexfile
	//---------------------------------------------------------------------------
	function indexfile(){
		
		if ( isset($this->modinfo2['indexfile']) ) {

			foreach( $this->modinfo2['indexfile'] as $item ) {
				$tab[ $item ] = $item ;
			}
			return $tab;
		} 
		else {
			return array('index'=>'index');
		}
	}

	//----------------------------------------------------------------------------
	// Configuration automatique des option administrateur et utilisateur
	//  mettre dans classe commune user/administration
	//----------------------------------------------------------------------------
	function config_param_admin($tabparam, $mode='SQL') {
		return $this->common_config_param($tabparam, $this->modconf(), 'index.php', $mode ) ;
	}

	function config_param_user($tabparam, $ixpUserConfig, $index, $mode='SQL') {
		return $this->common_config_param($tabparam, $ixpUserConfig, $index, $mode ) ;
	}

	function common_config_param($tabparam, $ixp_ixpModuleConfig, $index='index.php', $mode='SQL') {
        
		if ($mode=='SQL') {
			$hidden = "<input type='hidden' name='op' value='ixpModuleConfigSaveSQL' />";
		} elseif($mode=='FILE')	{
			$hidden = "<input type='hidden' name='op' value='ixpModuleConfigSaveFile' />";
		}

		$new_action_script_name = '';
		$l_str = '<table width="100%" border="0">';
		$submit_by_param=false;  // le submit n'est pas initialis par le tabparam (ie dans cp_functions)

		foreach($tabparam as $key)  {

		switch($key['type']) {
			case 'select_theme_layouts':
				$form_item = new ixpFormSelectThemeLayouts(_US_THEME, $key['field'], $ixp_ixpModuleConfig[ $key['key'] ]) ;
				break;
			case 'select_themes_blocks':
				$form_item = new ixpFormSelectThemesBlocks(_US_THEME, $key['field'], $ixp_ixpModuleConfig[ $key['key'] ]) ;
				break;
			case 'select_themes_news':
				$key['dir'] = ($key['dir']=='') ? 'ixpnews' : $key['dir'];
				$form_item = new ixpFormSelectThemesNews( _US_THEME, $key['field'], $ixp_ixpModuleConfig[ $key['key']], 1, $key['dir']) ;
				break;
			case 'text':
				$form_item = new ixpFormText(_US_THEME, $key['field'], $key['option'], 254, $ixp_ixpModuleConfig[ $key['key'][0] ][ $key['key'][1] ] ) ;
				break;
			case 'text_simple_int':
				$initvalue = empty($key['initvalue']) ? 0 : $key['initvalue'];
				$param = empty($ixp_ixpModuleConfig[ $key['key'] ]) ? $initvalue : $ixp_ixpModuleConfig[ $key['key'] ];
				$form_item = new ixpFormText(_US_THEME, $key['field'], $key['option'], 100, $param ) ;
				break;
			case 'text_simple_str':
				$initvalue = empty($key['initvalue']) ? '' : $key['initvalue'];
				$param = empty($ixp_ixpModuleConfig[ $key['key'] ]) ? $initvalue : $ixp_ixpModuleConfig[ $key['key'] ];
				$form_item = new ixpFormText(_US_THEME, $key['field'], $key['option'], 254, $param ) ;
				break;
			case 'select_layouts':
				$form_item = new ixpFormSelect(_US_THEME, $key['field'], $ixp_ixpModuleConfig[ $key['key'][0] ][ $key['key'][1] ]) ;
				$form_item->addOptionArray($key['option']);
				break;
			case 'select_simple':
				$initvalue = ($key['initvalue']=='') ? '' : $key['initvalue'];
				$param = ($ixp_ixpModuleConfig[ $key['key'] ] == '') ? $initvalue : $ixp_ixpModuleConfig[ $key['key'] ];
				$form_item = new ixpFormSelect(_US_THEME, $key['field'], $param ) ;
				$form_item->addOptionArray($key['option']);
				break;
			case 'radio_yn':
				$initvalue = ( $ixp_ixpModuleConfig[ $key['key'] ] == '' ) ? $key['initvalue'] : $ixp_ixpModuleConfig[ $key['key'] ] ;
				$form_item = new ixpFormRadioYN(_US_THEME, $key['field'], $initvalue, $key['option'][0], $key['option'][1]);
				break;
			case 'radio_simple':
				$form_item = new ixpFormRadio(_US_THEME, $key['field'], $ixp_ixpModuleConfig[ $key['key'] ], $key['option'][0], $key['option'][1]);
				$form_item->addOptionArray($key['option']);
				break;
			case 'hidden':
				$form_item = new ixpFormHidden( $key['field'], $key['value']);
				break;
			case 'button':
				$form_item_submit = new ixpFormButton($key['caption'], $key['key'], $key['value'], $key['subtype']);
				$submit_by_param=true;
				break;
			// Nom personnalis du script.php action
			case 'action':
				$new_action_script_name = $key['value'];
				break;
			}

			$l_str .= "<tr><td class='nw'>" . $key['label'] . "</td><td>";
			$l_str .=  ($submit_by_param) ? '' : $form_item->render();
			$l_str .=  "</td></tr>";

		}
		$l_str .=  "</table>";
		$l_str .=  '<br /><br/>';
		$l_str .=  $hidden;
		$l_str .=  ($submit_by_param) ? $form_item_submit->render() : "<input type='submit' value='"._GALAD_SAVECHANGE."' />";
		$l_str .=  "&nbsp;<input type='button' value='"._CANCEL."' onclick='javascript:history.go(-1)' />";
		$l_str .=  "</form>";
    
		// Ajout du script du formulaire
		if($new_action_script_name!='') {
			$l_str = '<form action="'.$new_action_script_name.'" method="post">'.$l_str;
		} else {
			$l_str = '<form action="'.$index.'" method="post">'.$l_str;
		}
		
		return $l_str;
	}


	// Renvoie la liste des modules dans lesquels le block $bid est autoris de s'afficher
	function BlockAllowedlistOfModules($bid) 
	{
		global $ixpdb;

		$allModulesWithMain = ixpModule::getHasMainModulesList();

		foreach ( $allModulesWithMain as $mid=>$modulename ) {
			$btd = ixpModuleAdmin::getBlocsOnModule($mid);
			if (in_array($bid, $btd)) {
				$ret[$mid] = $modulename;
			}
		}
		return $ret;
	}


}