<?php
//error_reporting(E_ALL);
##############################################################################
#                                                                            #
#      This file is part of IXPRIM CMS - Content Management System           #
#                       <http:#www.ixprim-cms.org/>                          #
#                                                                            #
#   Copyright (c) 2006 Christophe Deltheil <aka trollix> and contributors.   #
#                      All rights reserved.                                  #
# -------------------------------------------------------------------------- #
# ideas come from :                                                          #
# POSTNUKE Web Portal System - http://postnuke.org/                          #
# XOOPS Web Portal System - http://xoops.org/                                #
# myPHPNUKE Web Portal System - http://myphpnuke.com/                        #
# PHP-NUKE Web Portal System - http://phpnuke.org/                           #
# Thatware - http://thatware.org/                                            #
# dotclear Blog System - http://dotclear.net/                                #
# -------------------------------------------------------------------------- #
#  Ixprim CMS is free software; you can redistribute it and/or modify        #
#  it under the terms of the GNU General Public License as published by      #
#  the Free Software Foundation; either version 2 of the License, or         #
#  (at your option) any later version.                                       #
#                                                                            #
#  Ixprim CMS is distributed in the hope that it will be useful,             #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of            #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
#  GNU General Public License for more details.                              #
#                                                                            #
#  You should have received a copy of the GNU General Public License         #
#  along with this program; if not, write to the Free Software               #
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA  #
##############################################################################

include_once( IXP_ROOT_PATH.'/kernel/class/ixplists.class.php' );
//include_once( IXP_ROOT_PATH.'/kernel/class/i xpregistry.class.php' );
include_once( IXP_ROOT_PATH.'/kernel/class/files.class.php' );
include_once( IXP_ROOT_PATH.'/kernel/class/ixpblocks.class.php' );

class a_ixpts extends ixpts
{

	var $theme;
	var $ixp_root_path;
	var $ixp_root_web;
			
	/*
	* Constructor of this class
	*/
	function a_ixpts( $p_theme = '' ){
		if ($p_theme=='') {
			$this->theme = ixpts::get_default_theme();
		}
		else {
			$this->theme = $p_theme;
		}
		$this->root_path = IXP_ROOT_PATH;
		$this->root_web = IXP_ROOT_WEB;
	}

	function set_root_path( $p_root_path ) {
		$this->root_path = $p_root_path;
	}

	function set_root_web( $p_root_web ) {
		$this->root_web = $p_root_web;
	}

	function &getInstance()
	{
		if ( isset($GLOBALS['a_ixpts']) && strtolower(get_class($GLOBALS['a_ixpts'])) == "a_ixpts" ) {
			return $GLOBALS['a_ixpts'];
		}
		$toto = new a_ixpts();
		return $toto;
	}

	// in parent function get_default_theme() 
	function delete_module_specific_cache( $module_name )
	{
		# Effacer les blocks 'central-bas',  'central-gauche', 'central-droite', 'central-haut'
		files::delete( $this->root_path.'/cache', $module_name.'.');
	}
	
	function delete_module_specific_cache_dir( $dir )
	{
		# Effacer les blocks 'central-bas',  'central-gauche', 'central-droite', 'central-haut'
		files::delete( $this->root_path.'/cache/'.$dir );
	}

	function delete_blocks_cache()
	{
		# Effacer les blocks 'central-bas',  'central-gauche', 'central-droite', 'central-haut'
		files::delete( $this->root_path.'/cache', 'cblocksbottom.');
		files::delete( $this->root_path.'/cache', 'sidebarleft.');
		files::delete( $this->root_path.'/cache', 'sidebarright.');
		files::delete( $this->root_path.'/cache', 'cblockstop.');
		files::delete( $this->root_path.'/cache', 'freeblock');
	}

	function refresh_all_static_cache() 
	{
		//---------------------------------
		// Raffraichir c'est :
		//---------------------------------
		
		# Effacer les blocks 'central-bas',  'central-gauche', 'central-droite', 'central-haut'
		$this->delete_blocks_cache();

		# Regnrer les caches statiques des templates
		$this->create_static_cache_layouts();

		# Regnrer les caches statiques des blocs
		$l_active_blocks_list = ixpBlock::getAllBlocks();
		foreach( $l_active_blocks_list as $block ) {
			$array_of_active_blocks[] = $block->getVar('themeblock');	
		}
		unset( $l_active_blocks_list );
		$array_of_active_blocks = array_unique( $array_of_active_blocks );
		foreach( $array_of_active_blocks as $theme_to_cache_layout ) {
			$this->creer_block_layout( $theme_to_cache_layout );
		}
		unset( $array_of_active_blocks );

		# Rgnrer les blocs utiliss par le systme
		$this->creer_block_layout( 'sys_title_br_content' );
		$this->creer_block_layout( 'sys_div_title_br_content' );
		$this->creer_block_layout( 'sys_default' );
		$this->creer_block_layout( 'sys_content' );

		# Regnrer les caches statiques des templates de news (si ce module est actif)
		$mid = ixpModule::mid_by_dirname('ixpnews');
		if ($mid) {
			$tab_config = ixpModule::getModuleConfSQL( $mid );

			$this->creer_block_layout( $tab_config['blockthemenews'] );
		
			$this->creer_block_layout_module_tpl( $tab_config['centralthemenewsindex'], 'ixpnews', 'index.html' );
			$this->creer_block_layout_module_tpl( $tab_config['centralthemenewsindex'], 'ixpnews', 'article.1.html' );
			$this->creer_block_layout_module_tpl( $tab_config['centralthemenewsindex'], 'ixpnews', 'article.0.html' );
			$this->creer_block_layout_module_tpl( $tab_config['centralthemenewsindex'], 'ixpnews', 'reply.html' );
			$this->creer_block_layout_module_tpl( $tab_config['centralthemenewsindex'], 'ixpnews', 'block.html' );
		
			$this->creer_block_layout_module_tpl( $tab_config['centralthemenewsstory'], 'ixpnews', 'index.html' );
			$this->creer_block_layout_module_tpl( $tab_config['centralthemenewsstory'], 'ixpnews', 'article.1.html' );
			$this->creer_block_layout_module_tpl( $tab_config['centralthemenewsstory'], 'ixpnews', 'article.0.html' );
		}

	}


	function create_static_cache_layouts() 
	{
		global $myts;

		$llists = new ixpLists;
		$p_theme = $myts->oopsStripSlashesGPC( $this->theme );

		if ( ixpts::is_multilingual() != 0) {
			$languagelist = $llists->getLangList();
		}
		else {
			$languagelist = array(IXPGLOBAL___current_language=>IXPGLOBAL___current_language);
		}

		$layoutslist = $llists->getLayoutsBlocksList( $this->theme );


		foreach(  $languagelist as $keylang ) {

			foreach(  $layoutslist as $keylayout ) {

                // will be deprecated -> defines are now in global.php
                if (file_exists($this->root_path.'/themes/main/'.$this->theme.'/language/'.$keylang.'/layout.php')) {
                    include_once( $this->root_path.'/themes/main/'.$this->theme.'/language/'.$keylang.'/layout.php' );
                }

				//---------------------------------------------------------
				// Traitement des LAYOUTS
				$this->_traitementLayout( $this->theme, $keylayout, $keylang, '0');
				$this->_traitementLayout( $this->theme, $keylayout, $keylang, '1');
				$this->_traitementLayout( $this->theme, $keylayout, $keylang, '2');
				$this->_traitementLayout( $this->theme, $keylayout, $keylang, '3');

				// Traitement des CSS
				$this->_traitementCSS( $this->theme, $keylayout, $keylang, 'style.css' );
				// Fin Traitement
			}
		}

	}

//----------------------------------------------------------------------------
// Fonction de traitement des Layout
//
// Mise en cache  partir du template
// Mise en place des paths corrects
//----------------------------------------------------------------------------
function _evalThemeLayoutLang($toto)
{
	return $toto;
}

function _traitementLayout( $p_default_theme, $p_keylayout, $p_keylang, $p_type_layout)
{
   
  $l_fileLayoutSrc  = $this->root_path.'/themes/main/'.$p_default_theme.'/layouts/'.$p_keylayout.'/layout'.$p_type_layout.'.html';
  
  if (! file_exists($l_fileLayoutSrc)) { // si n'existe pas on met le left-top-right
    $l_fileLayoutSrc  = $this->root_path.'/themes/main/'.$p_default_theme.'/layouts/'.$p_keylayout.'/layout3.html';
  }

  $l_fileLayoutDest = $this->root_path.'/cache/themes/'.$p_keylang.'.'.$p_keylayout.'.layout'.$p_type_layout.'.html';
  $l_pathimg		= $this->root_web.'/themes/main/'.$p_default_theme.'/layouts/'.$p_keylayout;


  $l_search  = array( 
		'/{(_THL_[A-Z_]+)}/e'
	  );

  $l_replace = array( 
		$this->_evalThemeLayoutLang('$1'.'_'.$p_keylang)
	   );

  $l_varblock = file_get_contents($l_fileLayoutSrc);
  $l_varblock = preg_replace( $l_search, $l_replace, $l_varblock );

  $l_pathCache = $this->root_web. '/cache/themes/layout.'.$p_keylayout.'.';

  $this->make_cache_layout_bycontent($l_varblock, $l_fileLayoutDest, $l_pathimg, $l_pathCache);

}

function _traitementCSS( $p_default_theme, $p_keylayout, $p_keylang, $p_type_css, $p_type='layout' )
{
    
  $l_fileLayoutSrc  = $this->root_path.'/themes/main/'.$p_default_theme.'/layouts/'.$p_keylayout.'/'.$p_type_css;
  $l_fileLayoutDest = $this->root_path.'/cache/themes/'.$p_type.'.'.$p_keylayout.'.'.$p_type_css;
  $l_pathimg		= $this->root_web. '/themes/main/'.$p_default_theme.'/layouts/'.$p_keylayout;

  if (! file_exists( $l_fileLayoutSrc ) ) {
      $l_fileLayoutSrc  = $this->root_path.'/themes/main/'.$p_default_theme.'/layouts/default/'.$p_type_css;
  }

  $l_search  = array( 
		'/{(_THL_[A-Z_]+)}/e'
	  );

  $l_replace = array( 
		$this->_evalThemeLayoutLang('$1'.'_'.$p_keylang)
	   );

  $l_varblock = file_get_contents($l_fileLayoutSrc);
  $l_varblock = preg_replace( $l_search, $l_replace, $l_varblock );
  

  $this->make_cache_layout_bycontent($l_varblock, $l_fileLayoutDest, $l_pathimg);

}


  function make_cache_layout_bycontent($fileLayoutSrcContent, $fileLayoutDest, $pathimg, $pathCache ='')
  {

    // gestion des ../../rep 
	// ex de pathimg: /ixprimtest/themes/main/ixprim_portail_soft/layouts/articles
	// enlever les deux derniers repertoires du $pathimg pour mettre  la place de ../../rep

	$pathimg2points = preg_match( '/(.+)((\/[a-z_.]+){2})/i', $pathimg, $bibi );

	$search  = array( 
		//"'([\r\n])[\s]+'",  // Supprime les espaces
		"'([\r])'",  // Supprime les espaces
		

		'/src="\.\.\/\.\.\/([a-z_.]+?\/)/i',
		'/background="\.\.\/\.\.\/([a-z_.]+?\/)/i',
		'/media="all" href="\.\.\/\.\.\/([a-z_.]+?)\/([a-z_.]+?)/i',
		'/url\("\.\.\/\.\.\/([a-z_.]+?\/)/i',
			
		'/="{IXP_ROOT_WEB}/i',		//isoler les tags ixprim {IXP_ROOT_WEB} et {IXP_URL}
		'/src="http/i',	//isoler le src="http
		'/src="/i',
		'/url\("/i',
		'/background="/',
		'/media="all" href="/i',
		'/background:url\(/i',

		'/srctemp/',
		'/backgroundtemp/',
		'/mediatemp/',
		'/urltemp/',

		'/__SRCHTTP__/',	// on repasse dans l'autre sens
		'/__EGALE_IXP_ROOT_WEB__/',	// on repasse dans l'autre sens

		);

	$replace = array( 
		'',
		
	    'srctemp="'.$bibi[1]."/\$1",
		'backgroundtemp="'.$bibi[1]."/\$1",
		//
        'mediatemp="all" href="'.$pathCache."\$2",
		'urltemp("'.$bibi[1]."/\$1",

		'__EGALE_IXP_ROOT_WEB__',
		'__SRCHTTP__',		// en le remplaant par un tag
		'src="'.$pathimg.'/',
		'url("'.$pathimg.'/',
		'background="'.$pathimg.'/',
		'media="all" href="'.$pathCache,
		'background:url('.$pathimg.'/',

		'src',
		'background',
		'media',
		'url',

		'src="http',	// on repasse dans l'autre sens
		'="'.IXP_ROOT_WEB,		// on repasse dans l'autre sens
		);

	$contentfile = preg_replace( $search, $replace, $fileLayoutSrcContent );
	/*
    if ((strpos($contentfile, '{IXP_TAG}')<=0) && (strpos($fileLayoutDest, '.css')<=0)) { // pas de tag IXP_TAG dans le layout
        $contentfile = $contentfile.'{IXP_TAG}';
    }
	*/
	if ($file = fopen($fileLayoutDest, "w")) {
		fwrite($file, $contentfile);
		fclose($file);
	}
  }


  function make_cache_layout( $p_layoutfile_src, $p_layoutfile_dest, $p_images_path)
  {

	$l_search  = array( 
		
		'/="{IXP_ROOT_WEB}/i',		//isoler les tags ixprim {IXP_ROOT_WEB} et {IXP_URL}
		'/="{IXP_ROOT_THISBLOCK}/i',		//isoler les tags ixprim {IXP_ROOT_WEB} et {IXP_URL}
		'/src="http/i',		//isoler le src="http
		
		'/src="/i', 
		'/url\("/i',
		'/background="/i',
		'/media="all" href="/i',
		'/background:url\(/i',

		'/__SRCHTTP__/',	// on repasse dans l'autre sens
		'/__IXP_ROOT_THISBLOCK__/',	// on repasse dans l'autre sens
		'/__EGALE_IXP_ROOT_WEB__/',	// on repasse dans l'autre sens

		);
	$l_replace = array( 
		
		'__EGALE_IXP_ROOT_WEB__',
		'__IXP_ROOT_THISBLOCK__',
		'__SRCHTTP__',		// en le remplaant par un tag
		
		'src="'.$p_images_path.'/',
		'url("'.$p_images_path.'/',
		'background="'.$p_images_path.'/',
		'media="all" href="'.$p_images_path.'/',
		'background:url('.$p_images_path.'/',

		'src="http',		// on repasse dans l'autre sens
		'="'.$p_images_path.'/',		// on repasse dans l'autre sens
		'="'.IXP_ROOT_WEB,		// on repasse dans l'autre sens
		);

	//$contentfile = implode('',file($fileLayoutSrc));
	$l_contentfile = implode('', files::get_file_in_array( $p_layoutfile_src )); 
	$l_contentfile = preg_replace( $l_search, $l_replace, $l_contentfile );

	if ( file_exists($p_layoutfile_src) ) {
		if ($l_file = fopen($p_layoutfile_dest, "w")) {
			fwrite($l_file, $l_contentfile);
			fclose($l_file);
		}
	}

  }


	// Fonction creation des layouts
	function creer_block_layout( $p_themeblock='sys_default' )
	{

		// TiX: Make cache block layout
		if (file_exists( IXP_ROOT_PATH.'/themes/main/'.$this->theme.'/blocks/'.$p_themeblock.'/index.html' )) {
			$l_layoutfile_src	= IXP_ROOT_PATH.'/themes/main/'.$this->theme.'/blocks/'.$p_themeblock.'/index.html';
			$l_layoutfile_dest	= IXP_ROOT_PATH.'/cache/themes/' .$p_themeblock.'.index.html';
			$l_images_path		= IXP_ROOT_WEB.'/themes/main/'.$this->theme.'/blocks/' .$p_themeblock;
		}
		elseif (file_exists( IXP_ROOT_PATH.'/themes/tpl_default/system_blocks/'.$p_themeblock.'/index.html' )) {
			$l_layoutfile_src	= IXP_ROOT_PATH.'/themes/tpl_default/system_blocks/'.$p_themeblock.'/index.html';
			$l_layoutfile_dest	= IXP_ROOT_PATH.'/cache/themes/' .$p_themeblock.'.index.html';
			$l_images_path		= IXP_ROOT_WEB.'/themes/tpl_default/system_blocks/' .$p_themeblock;
		}
		else {
			$l_layoutfile_src	= IXP_ROOT_PATH.'/themes/tpl_default/system_blocks/sys_default/index.html';
			$l_layoutfile_dest	= IXP_ROOT_PATH.'/cache/themes/sys_default.index.html';
			$l_images_path		= IXP_ROOT_WEB.'/themes/tpl_default/system_blocks/sys_default';
		}

		$this->make_cache_layout($l_layoutfile_src, $l_layoutfile_dest, $l_images_path);
	}

	// Fonction creation des layouts
	function creer_block_layout_module_tpl( $p_themeblock='default', $module='ixpnews', $_typefile='index.html' )
	{
        $p_themeblock = ($p_themeblock=='') ? 'default' : $p_themeblock;

		// On bypasse le thme du core par un thme personnalis s'il existe
		if (is_dir(IXP_ROOT_PATH.'/themes/main/'.IXPGLOBAL___default_theme.'/mod/'.$module)) {
			$l_layoutfile_src	= IXP_ROOT_PATH.'/themes/main/'.IXPGLOBAL___default_theme.'/mod/'.$module.'/'.$p_themeblock.'/'.$_typefile;
			$l_layoutfile_dest	= IXP_ROOT_PATH.'/cache/themes/'.$module.'.'.$p_themeblock.'.'.$_typefile;
			$l_images_path		= IXP_ROOT_WEB.'/themes/main/'.IXPGLOBAL___default_theme.'/mod/'.$module.'/'.$p_themeblock;
		} else {
			$l_layoutfile_src	= IXP_ROOT_PATH.'/mod/'.$module.'/tpl/main/'.$p_themeblock.'/'.$_typefile;
			$l_layoutfile_dest	= IXP_ROOT_PATH.'/cache/themes/'.$module.'.'.$p_themeblock.'.'.$_typefile;
			$l_images_path		= IXP_ROOT_WEB.'/mod/'.$module.'/tpl/main/'.$p_themeblock;
		}

		$this->make_cache_layout( $l_layoutfile_src, $l_layoutfile_dest, $l_images_path);		
	}


	function how_many_freeblocks()
	{
		$llists = new ixpLists;
		$layoutslist = $llists->getLayoutsBlocksList( $this->theme );

		$str = '';

		foreach( $layoutslist as $layout ) {
			if ($layout!='loginform') {
				for($i=0 ; $i<=3; $i++) {
					$str .= file_get_contents( $this->root_path.'/themes/main/'.$this->theme.'/layouts/'.$layout.'/layout'.$i.'.html' );
				}
			}
		}
		# ici str contient tous le raw des layouts - a analyser pour trouver le nb de freeblocks
		if ( preg_match_all('/({FREEBLOCKS([\d]+)})/', $str, $out )) {
			return max($out[2]);
		}
		else {
			return 0;
		}
		
	}

	function how_many_bannertags()
	{
		$llists = new ixpLists;
		$layoutslist = $llists->getLayoutsBlocksList( $this->theme );

		$str = '';

		foreach( $layoutslist as $layout ) {
			if ($layout!='loginform') {
				for($i=0 ; $i<=3; $i++) {
					$str .= file_get_contents( $this->root_path.'/themes/main/'.$this->theme.'/layouts/'.$layout.'/layout'.$i.'.html' );
				}
			}
		}
		# ici str contient tous le raw des layouts - a analyser pour trouver le nb de freeblocks
		if ( preg_match_all('/({BANNER([\d]+)})/', $str, $out )) {
			return max($out[2]);
		}
		else {
			return 0;
		}
		
	}

	function is_theme_in_ixpblocks_themes( $p_themename )
	{
		global $ixpdb;

		$sql  = "SELECT theme FROM ". $ixpdb->prefix( 'ixpblocks_themes' ) ." WHERE theme = '".$p_themename."'";
		$result = $ixpdb->sql_query( $sql );

		if ($ixpdb->sql_numrows($result)>0){
			return true;
		}
		else {
			return false;
		}
	}

function synchronize_themesblocks( $p_default_theme ) {

	global $ixpdb, $myts;
  
	$sql = "SELECT settings FROM ".$ixpdb->prefix("ixpblocks_themes")." WHERE theme='".$p_default_theme."'";
	$result = $ixpdb->sql_query( $sql );
	if ($ixpdb->sql_numrows($result)>0) {
		
		list($settings) = $ixpdb->sql_fetchrow($result); //fetchRow
		$tab_themeblock = unserialize( stripslashes($settings) );

		foreach( $tab_themeblock as $elem ) {
			#print $elem['bid']."-".$elem['themeblock']."-".$elem['weightblock'].'<br />';
			$ixpdb->sql_query("UPDATE ".$ixpdb->prefix("ixpblocks")." SET themeblock='".$elem['themeblock']."', weightblock='".$elem['weightblock']."' , spaceblock='".$elem['spaceblock']."' WHERE bid='".$elem['bid']."'");
		}
	} else {	//  Le theme n'a pas t utilis, on met  "default", la table ixpblocks_themes pour ce theme
  
		$sql = "SELECT bid FROM ".$ixpdb->prefix("ixpblocks");
		$result = $ixpdb->sql_query( $sql );
		while( list($bid) = $ixpdb->sql_fetchrow($result) ) {	//fetchRow
			$ixpdb->sql_query("UPDATE ".$ixpdb->prefix("ixpblocks")." SET themeblock='_default_', weightblock='100%' , spaceblock='1 0 1 0' WHERE bid='".$bid."'");
		}
	}

}




function create_cache_themesblocks($p_default_theme) {

	global $ixpdb, $myts;
	
	$tab_themeblock = array();
	
	$a = & a_ixpts::getInstance();
	$a->theme = $p_default_theme;

 	$sql = "SELECT bid, themeblock, weightblock, spaceblock, cachetime FROM ".$ixpdb->prefix("ixpblocks");
	$result = $ixpdb->sql_query( $sql );
	while(list($bid, $themeblock, $weightblock, $spaceblock, $cachetime) = $ixpdb->sql_fetchrow($result) ) {	//fetchRow
	
		$tab_themeblock[$bid]['bid'] = $bid;
		$tab_themeblock[$bid]['themeblock'] = $themeblock;
		$tab_themeblock[$bid]['weightblock'] = $weightblock;
		$tab_themeblock[$bid]['spaceblock'] = $spaceblock;
		$tab_themeblock[$bid]['cachetime'] = $cachetime;

		// TiX: Make cache block layout
		$a->creer_block_layout( $themeblock );
	}

}

// End class		
}
?>