<?php
//error_reporting(E_ALL);
##############################################################################
#                                                                            #
#      This file is part of IXPRIM CMS - Content Management System           #
#                       <http:#www.ixprim-cms.org/>                          #
#                                                                            #
#   Copyright (c) 2006 Christophe Deltheil <aka trollix> and contributors.   #
#                      All rights reserved.                                  #
# -------------------------------------------------------------------------- #
# ideas come from :                                                          #
# POSTNUKE Web Portal System - http://postnuke.org/                          #
# XOOPS Web Portal System - http://xoops.org/                                #
# myPHPNUKE Web Portal System - http://myphpnuke.com/                        #
# PHP-NUKE Web Portal System - http://phpnuke.org/                           #
# Thatware - http://thatware.org/                                            #
# dotclear Blog System - http://dotclear.net/                                #
# -------------------------------------------------------------------------- #
#  Ixprim CMS is free software; you can redistribute it and/or modify        #
#  it under the terms of the GNU General Public License as published by      #
#  the Free Software Foundation; either version 2 of the License, or         #
#  (at your option) any later version.                                       #
#                                                                            #
#  Ixprim CMS is distributed in the hope that it will be useful,             #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of            #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
#  GNU General Public License for more details.                              #
#                                                                            #
#  You should have received a copy of the GNU General Public License         #
#  along with this program; if not, write to the Free Software               #
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA  #
##############################################################################
class ixpUserAdmin extends ixpUser {

    // calcule une liste des users suivant le crire
    // 
	function getAllUsersList($criteria=array(), $orderby="uid ASC", $limit=0, $start=0)
	{
		global $ixpdb, $myts;

		$myts =& MyTextSanitizer::getInstance();
		$ret = array();
		$where_query = "";
		if ( is_array($criteria) && count($criteria) > 0 ) {
			$where_query = " WHERE";
			foreach ( $criteria as $c ) {
				$where_query .= " $c AND";
			}
			$where_query = substr($where_query, 0, -4);
		}
		$sql = "SELECT uid, uname FROM ".$ixpdb->prefix("users")."".$where_query." ORDER BY $orderby";
		$result = $ixpdb->sql_query($sql,$limit,$start);
		while ( $myrow = $ixpdb->sql_fetchrow($result) ) //fetchArray
		{
			$ret[$myrow['uid']] = $myts->makeTboxData4Show($myrow['uname']);
		}
		return $ret;
	}


    // calcule la liste de tous les non membres d'un groupe, si exclusion contient les membres
	function getAllUsersListWithoutMembers($criteria=array(), $orderby="uid ASC", $exclusionArray=array(), $limit=0, $start=0)
	{
		global $ixpdb, $myts;

		$ret = array('uid'=>array(), 'uname'=>array(), 'email'=>array());

		$where_query = "";
		if ( is_array($criteria) && count($criteria) > 0 ) {
			$where_query = " WHERE";
			foreach ( $criteria as $c ) {
				$where_query .= " $c AND";
			}
			$where_query = substr($where_query, 0, -4);
		}
		$sql = "SELECT uid, uname, email FROM ".$ixpdb->prefix("users")."".$where_query." ORDER BY $orderby";
		$result = $ixpdb->sql_query($sql,$limit,$start);
		while ( $myrow = $ixpdb->sql_fetchrow($result) ) { //fetchArray
		
            if (!in_array($myrow['uid'], $exclusionArray)) {
			    $ret['uid'][] = $myrow['uid'];
                $ret['uname'][] = $myts->makeTboxData4Show($myrow['uname']);
                $ret['email'][] = $myts->makeTboxData4Show($myrow['email']);
            }
		}
		return $ret;
	}

    //------------------------------------------------------------------------
    // Calcule la liste de tous les membres (OK)
    //------------------------------------------------------------------------
	function getAllUsersListComplete($p_group, $p_orderby="uname ASC", $limit=0, $start=0) {

        global $ixpdb, $myts;

		$ret = array('uid'=>array(), 'uname'=>array(), 'email'=>array());

	    $sql = "SELECT u.uid, u.uname, u.email FROM ".$ixpdb->prefix("users")." u ORDER BY $p_orderby";
	    $result = $ixpdb->sql_query($sql, $limit, $start);

	    while($myrow = $ixpdb->sql_fetchrow($result)) {
		    $ret['uid'][] = $myrow['uid'];
		    $ret['uname'][] = $myts->makeTboxData4Show($myrow['uname']);
            $ret['email'][] = $myts->makeTboxData4Show($myrow['email']);
	    }
        return $ret;
	}

    //------------------------------------------------------------------------
    // Calcule la liste de tous les membres d'un groupe $p_group (OK)
    //------------------------------------------------------------------------
	function getAllUsersListMembersOfGroup($p_group, $p_orderby="uname ASC", $limit=0, $start=0) {
    
        global $ixpdb, $myts;

		$ret = array('uid'=>array(), 'uname'=>array(), 'email'=>array());

	    $sql = "SELECT l.uid, u.uname, u.email FROM ".$ixpdb->prefix("groups_users_link")." l, ".$ixpdb->prefix("users")." u WHERE l.groupid = ".$p_group." AND l.uid=u.uid ORDER BY $p_orderby";
	    $result = $ixpdb->sql_query($sql, $limit, $start);

	    while($myrow = $ixpdb->sql_fetchrow($result)) {
		    $ret['uid'][] = $myrow['uid'];
		    $ret['uname'][] = $myts->makeTboxData4Show($myrow['uname']);
            $ret['email'][] = $myts->makeTboxData4Show($myrow['email']);
	    }

        return $ret;
    }
    
    //------------------------------------------------------------------------
    // Calcule le nombre de tous les membres d'un groupe $p_group (OK)
    //------------------------------------------------------------------------
	function getAllUsersNumberMembersOfGroup($p_group, $p_orderby="uname ASC", $limit=0, $start=0) {
        
        global $ixpdb, $myts;

		$ret = 0;
	    $sql = "SELECT count(l.uid) FROM ".$ixpdb->prefix("groups_users_link")." l, ".$ixpdb->prefix("users")." u WHERE l.groupid = ".$p_group." AND l.uid=u.uid ORDER BY $p_orderby";
	    $result = $ixpdb->sql_query($sql, $limit, $start);
        list($ret) = $ixpdb->sql_fetchrow($result);
        return $ret;
    }

    //------------------------------------------------------------------------
    // Calcule la diffrence de deux array (OK)
    //------------------------------------------------------------------------
	function getDifference($array_all, $array_inside) {
        
        $ret['uid']   = array_diff($array_all['uid'],   $array_inside ['uid']);
        $ret['uname'] = array_diff($array_all['uname'], $array_inside ['uname']);
        $ret['email'] = array_diff($array_all['email'], $array_inside ['email']);

        return $ret;
    }

/*
    // calcule la liste de tous les NON-membres d'un groupe
	function getAllUsersListNotMembersOfGroup($p_group, $p_orderby="uname ASC", $limit=0, $start=0) {
        global $ixpdb, $myts;

		$ret = array('uid'=>array(), 'uname'=>array(), 'email'=>array());

	    $sql = "SELECT l.uid, u.uname, u.email FROM ".$ixpdb->prefix("users")." u LEFT JOIN ".$ixpdb->prefix("groups_users_link")." l ON l.uid=u.uid WHERE ( ISNULL(l.groupid) OR l.groupid <> ".$p_group.") ORDER BY $p_orderby";
	    $result = $ixpdb->sql_query($sql, $limit, $start);

	    while($myrow = $ixpdb->sql_fetchrow($result)) {

            if(!in_array($myrow['uid'], $ret['uid'])) {  // vrif des doublons
		        $ret['uid'][$myrow['uid']] = $myrow['uid'];
		        $ret['uname'][$myrow['uid']] = $myts->makeTboxData4Show($myrow['uname']);
                $ret['email'][$myrow['uid']] = $myts->makeTboxData4Show($myrow['email']);
            }
	    }

        return $ret;
    }
*/

    // calcule la liste de tous les NON-membres d'un groupe
	function getAllUsersListNotMembersOfGroup($p_group, $p_orderby="uname ASC", $limit=0, $start=0) {

        global $ixpdb, $myts;

		$ret = array('uid'=>array(), 'uname'=>array(), 'email'=>array());

	    $sql = "SELECT u.uid, u.uname, u.email FROM ".$ixpdb->prefix("users")." u ORDER BY $p_orderby";
	    $result = $ixpdb->sql_query($sql);
        
	    while($myrow = $ixpdb->sql_fetchrow($result)) {

            // ce user 'uid' est-il membre du groupe 'groupid'
            $sql = "SELECT COUNT(uid) FROM ".$ixpdb->prefix("groups_users_link")." WHERE uid='".$myrow['uid']."' AND groupid='".$p_group."'"; 
            $result2 = $ixpdb->sql_query($sql);
            list($count) = $ixpdb->sql_fetchrow($result2);

            if($count==0) {
                $ret['uid'][] = $myrow['uid'];
		        $ret['uname'][] = $myts->makeTboxData4Show($myrow['uname']);
                $ret['email'][] = $myts->makeTboxData4Show($myrow['email']);
            }
	    }
        return $ret;

    }



    // calcule le nombre des NON-membres d'un groupe
	function getAllUsersNumberNotMembersOfGroup($p_group, $p_orderby="uname ASC", $limit=0, $start=0)
	{
        global $ixpdb;

		$ret = 0;

        $sql = "SELECT DISTINCT u.uid FROM ".$ixpdb->prefix("users")." u LEFT JOIN ".$ixpdb->prefix("groups_users_link")." l ON l.uid=u.uid WHERE ( ISNULL(l.groupid) OR l.groupid <> ".$p_group.") ORDER BY $p_orderby";
	    $result = $ixpdb->sql_query($sql, $limit, $start);
        $ret = $ixpdb->sql_numrows($result); echo $ret;
        return $ret;
    }

    // Ddoublonnage de la table groups_users_link 
	function dedoublonner_groups_users_link()
	{
        global $ixpdb;

		$ret = array();

        $sql = "SELECT * FROM ".$ixpdb->prefix("groups_users_link");
	    $result = $ixpdb->sql_query($sql);

        while($myrow = $ixpdb->sql_fetchrow($result)) {

            if(!array_key_exists($myrow['uid'], $ret)) {  // vrif des doublons
                $ret[$myrow['uid']] = $myrow['groupid'];
            } else {
                //On efface -> ventuellement enlve les doublons
                $sql = "DELETE FROM ".$ixpdb->prefix("groups_users_link")." WHERE uid=".$myrow['uid']." AND groupid=".$myrow['groupid']."";
				$ixpdb->sql_query($sql);
                // 2) On ajoute
				$sql = "INSERT INTO ".$ixpdb->prefix("groups_users_link")." (groupid, uid) VALUES (".$myrow['groupid'].",".$myrow['uid'].")";
				$ixpdb->sql_query($sql);	
            }
        }
    }

}