<?php
//error_reporting(E_ALL);
// ------------------------------------------------------------------------- //
//                IXPRIM CMS - Content Management System - by trollix        //
//                <http://www.ixprim-cms.org/>									 //
// ------------------------------------------------------------------------- //
// Based on:                                                                 //
// PostNuke - http://postnuke.org/                                           //
// Xoops - http://xoops.org/                                                 //
// myPHPNUKE Web Portal System - http://myphpnuke.com/                       //
// PHP-NUKE Web Portal System - http://phpnuke.org/                          //
// Thatware - http://thatware.org/                                           //
// ------------------------------------------------------------------------- //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
// ------------------------------------------------------------------------- //
// Author of File: 							                                 //
// This file is part of DotClear.
// Copyright (c) 2004 Olivier Meunier and contributors. All rights
// reserved.
//
// DotClear is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// ------------------------------------------------------------------------- //
class files
{
	function get_dir_list( $dir, $selector='', $order=0)
	{
		$exclude_list = array('.','..','.htaccess', 'index.html');
		
		$res = array();
		if (($dh = @opendir($dir)) !== false) {

			while (($file = readdir($dh)) !== false) {

				if ( (!in_array($file, $exclude_list)) && (!is_dir( $dir.'/'.$file ))) {
					
					if ( $selector != '' )
					{
						if (stristr( $file, $selector )) {
							$res[] = $file;
						}
					}
					else {
						$res[] = $file;
					}

				}
			}
			closedir($dh);
			
			sort($res);
			if ($order == 1) {
				rsort($res);
			}
			
			return $res;
		}
		else {
			return false;
		}
	}
	
	function delete( $dir, $selector='', $exclude_list = array('.','..','.htaccess', 'index.html') )
	{
		$res = array();
		if (($dh = @opendir($dir)) !== false) {

			while (($file = readdir($dh)) !== false) {

				if ( (!in_array($file, $exclude_list)) && (!is_dir( $dir.'/'.$file ))) {
					
					if ( $selector != '' )
					{
						if (stristr( $file, $selector )) {
							@unlink( $dir.'/'.$file );
						}
					}
					else {
						@unlink( $dir.'/'.$file );
					}

				}
			}
			closedir($dh);
						
			return $res;
		}
		else {
			return false;
		}
	}

    // ex: glob_delete("/path/*.doc");
	// ex: glob_delete("/path/to/images/{*.jpg,*.JPG}", GLOB_BRACE);
	function glob_delete( $mask )
	{
		foreach (glob( $mask ) as $filename) {
			@unlink( $filename );
		}
	}

	
	function get_file_in_array( $FTR ) // FTR: File To Read
	{
		if (file_exists( $FTR )) {
			$fd = fopen ( $FTR , "r");
			while (!feof ($fd)) 
			{
				$buffer = fgets($fd, 4096);
				$lines[] = $buffer;
			}
			fclose ($fd);
		}
		else {
			die( 'Error Open '.$FTR );
		}
		return $lines;
	}

	function get_file_in_string( $FTR ) // FTR: File To Read
	{
		$fd = fopen ( $FTR , "r");
		while (!feof ($fd)) 
		{
			$buffer = fgets($fd, 4096);
			$lines .= $buffer;
		}
		fclose ($fd);
		return $lines;
	}


	function isDeletable($f)
	{
		if (is_file($f)) {
			return is_writable(dirname($f));
		} elseif (is_dir($f)) {
			return (is_writable(dirname($f)) && count(files::get_dir_list($f)) <= 2);
		}
	}
	
	# Suppression rcursive d'un rpertoire (rm -rf)
	function deltree($dir)
	{
		$current_dir = opendir($dir);
		while($entryname = readdir($current_dir))
		{
			if (is_dir($dir.'/'.$entryname) and ($entryname != '.' and $entryname!='..'))
			{
				if (!files::deltree($dir.'/'.$entryname)) {
					return false;
				}
			}
			elseif ($entryname != '.' and $entryname!='..')
			{
				if (!@unlink($dir.'/'.$entryname)) {
					return false;
				}
			}
		}
		closedir($current_dir);
		return @rmdir($dir);
	}
	
	function touch($f)
	{
		if (is_writable($f)) {
			$c = implode('',file($f));
			if ($fp = @fopen($f,'w')) {
				fwrite($fp,$c,strlen($c));
				fclose($fp);
			}			
		}
	}
	
	function makeDir($f)
	{
		if (@mkdir($f,fileperms(dirname($f))) === false) {
			return false;
		}
		
		@chmod($f,fileperms(dirname($f)));
	}

	function putContent($f, $f_content)
	{
		if (is_writable($f))
		{
			if ($fp = @fopen($f, 'w'))
			{
				fwrite($fp,$f_content,strlen($f_content));
				fclose($fp);
				return true;
			}
		}
		
		return false;
	}
	
	function size($size)
	{
		$kb = 1024;
		$mb = 1024 * $kb;
		$gb = 1024 * $mb;
		$tb = 1024 * $gb;
		
		if($size < $kb) {
			return $size." B";
		}
		else if($size < $mb) {
			return round($size/$kb,2)." KB";
		}
		else if($size < $gb) {
			return round($size/$mb,2)." MB";
		}
		else if($size < $tb) {
			return round($size/$gb,2)." GB";
		}
		else {
			return round($size/$tb,2)." TB";
		}
	}
	
	# Copier d'un fichier binaire distant
	function copyRemote($src,$dest)
	{
		if (($fp1 = @fopen($src,'r')) === false)
		{
			return __('An error occured while downloading the file.');
		}
		else
		{
			if (($fp2 = @fopen($dest,'w')) === false)
			{
				fclose($fp1);
				return __('An error occured while writing the file.');
			}
			else
			{
				while (($buffer = fgetc($fp1)) !== false) {
					fwrite($fp2,$buffer);
				}
				fclose($fp1);
				fclose($fp2);
				return true;
			}
		}
	}
	
	
	# Fonctions de cration de packages
	#
	function getDirList($dirName)
	{
		static $filelist = array();
		static $dirlist = array(); 
		
		$exclude_list=array('.','..','.svn');
		
		if (empty($res)) {
			$res = array();
		}
		
		$dirName = preg_replace('|/$|','',$dirName);
		
		if (!is_dir($dirName)) {
			return false;
		}
		
		$dirlist[] = $dirName;
		
		$d = dir($dirName);
		while($entry = $d->read())
		{
			if (!in_array($entry, $exclude_list))
			{
				if (is_dir($dirName.'/'.$entry))
				{
					if ($entry != 'CVS')
					{
						files::getDirList($dirName.'/'.$entry);
					}
				}
				else
				{
					$filelist[] = $dirName.'/'.$entry;
				}
			}
		}
		$d->close();
		
		return array('dirs'=>$dirlist, 'files'=>$filelist);
	}
	
	function makePackage($name,$dir,$remove_path='',$gzip=true)
	{
		if ($gzip && !function_exists('gzcompress')) {
			return false;
		}
		
		if (($filelist = files::getDirList($dir)) === false) {
			return false;
		}
		
		$res = array ('name' => $name, 'dirs' => array(), 'files' => array());
		
		foreach ($filelist['dirs'] as $v) {
			$res['dirs'][] = preg_replace('/^'.preg_quote($remove_path,'/').'/','',$v);
		}
		
		foreach ($filelist['files'] as $v) {
			$f_content = base64_encode(implode('',file($v)));
			$v = preg_replace('/^'.preg_quote($remove_path,'/').'/','',$v);
			$res['files'][$v] = $f_content;
		}
		
		$res = serialize($res);
		
		if ($gzip) {
			$res = gzencode($res);
		}
		
		return $res;
	}

	function real_path($p,$strict=true)
	{
		$os = (DIRECTORY_SEPARATOR == '\\') ? 'win' : 'nix';
		
		# Chemin absolu ou non ?
		if ($os == 'win') {
			$_abs = preg_match('/^\w+:/',$p);
		} else {
			$_abs = substr($p,0,1) == '/';
		}
		
		# Transformation du chemin, forme std
		if ($os == 'win') {
			$p = str_replace('\\','/',$p);
		}
		
		# Ajout de la racine du fichier appelant si 
		if (!$_abs) {
			$p = dirname($_SERVER['SCRIPT_FILENAME']).'/'.$p;
		}
		
		# Nettoyage
		$p = preg_replace('|/+|','/',$p);
		
		if (strlen($p) > 1) {
			$p = preg_replace('|/$|','',$p);
		}
		
		$_start = '';
		if ($os == 'win') {
			list($_start,$p) = explode(':',$p);
			$_start .= ':/';
		} else {
			$_start = '/';
		}
		$p = substr($p,1);
		
		# Parcours
		$P = explode('/',$p);
		$res = array();
		
		for ($i=0;$i<count($P);$i++)
		{
			if ($P[$i] == '.') {
				continue;
			}
			
			if ($P[$i] == '..') {
				if (count($res) > 0) {
					array_pop($res);
				}
			} else {
				array_push($res,$P[$i]);
			}
		}
		
		$p = $_start.implode('/',$res);
		
		if ($strict && !file_exists($p)) {
			return false;
		}
		
		return $p;
	}
}

?>