<?php
//error_reporting(E_ALL);
##############################################################################
#                                                                            #
#      This file is part of IXPRIM CMS - Content Management System           #
#                       <http:#www.ixprim-cms.org/>                          #
#                                                                            #
#   Copyright (c) 2006 Christophe Deltheil <aka trollix> and contributors.   #
#                      All rights reserved.                                  #
# -------------------------------------------------------------------------- #
#  Ixprim CMS is free software; you can redistribute it and/or modify        #
#  it under the terms of the GNU General Public License as published by      #
#  the Free Software Foundation; either version 2 of the License, or         #
#  (at your option) any later version.                                       #
#                                                                            #
#  Ixprim CMS is distributed in the hope that it will be useful,             #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of            #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
#  GNU General Public License for more details.                              #
#                                                                            #
#  You should have received a copy of the GNU General Public License         #
#  along with this program; if not, write to the Free Software               #
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA  #
##############################################################################
/*
 Iubito dhtml menu, d'aprs le script dispo sur www.openweb.eu.org, 
 mais grandement amlior par Sylvain Machefert.

 voir http://iubito.free.fr/prog/menu.php pour toutes les explications

*/

/**
* ixmenu: Menu dynamique 
* 
* php class by trollix for ixprim CMS
* http://www.ixprim-cms.org - http://www.trollix.com
*
* Sample usage:
*
*   $im = new ixmenu(200) ;
*   $im->base_url = IXP_ROOT_WEB.'/kernel/class/ixmenu';
*   echo $hm->show_menu() ;
*/
class ixmenu {

	var $items;
    var $base_url;
	var $css_file;

    var $options;

	/**
	* Constructeur de la classe
	*
	* Initialise les variables
	*
	* @param array $t tableau des items du menu
	* @access public
	*/
	function ixmenu($t=array()) {
		$this->items = $t;
        $this->css_file = 'ixmenu.css';
        
        $this->options['vertical'] = 'false';
        $this->options['largeur_menu'] = '180';
        $this->options['centrer_menu'] = 'false';
        $this->options['top_menu'] = '0';
		$this->options['marge_en_haut_de_page'] = strval(intval($this->options['top_menu']) + 22);
        $this->options['hauteur_menu'] = '25';
        $this->options['largeur_sous_menu'] = '180';
        $this->options['largeur_auto_ssmenu'] = 'false';
        $this->options['espace_entre_menus'] = '0';
        $this->options['delai'] = '650';
        $this->options['left_menu'] = '0';
        $this->options['suivre_le_scroll'] = 'false';
        $this->options['cacher_les_select'] = 'true';
	}

	function show_menu( $echo = true ) {

        $str = ''
            .$this->display_style()
		    .$this->display_config()
            .'<script type="text/javascript" src="'.$this->base_url.'/ixmenu.js"></script>'
            .'<div id="conteneurmenu">'
            .'<script language="Javascript" type="text/javascript">' // pour viter le clignotement dsagrable
            .'preChargement();'
            .'</script>'
            .$this->display_menu( $this->items )
            
            .'</div>'
            .'<script language="Javascript" type="text/javascript">Chargement();</script>';

		if ($echo) {
			echo $str;
		}
		else {
			return $str;
		}
	}

    function display_menu($data_array) {

        $str = '';

        for( $num=1; $num<=count($data_array); $num++ ) {

            // Menu main
            $str .= '<p id="menu'.$num.'" class="menu" onmouseover="MontrerMenu(\'ssmenu'.$num.'\');" onmouseout="CacherDelai();">';

            if ($data_array[$num][0]['href']!='not') {
                $str .= '<a href="'.$data_array[$num][0]['href'].'" onmouseover="MontrerMenu(\'ssmenu'.$num.'\');"  onfocus="MontrerMenu(\'ssmenu'.$num.'\');">'
                .$data_array[$num][0]['title'].'<span>&nbsp;:</span></a></p>';
            }
            else {
                $str .= $data_array[$num][0]['title'].'<span>&nbsp;:</span></p>';
            }
    
            if (count($data_array[$num]) >1) {
                // Sous menus
                $str .= '<ul id="ssmenu'.$num.'" class="ssmenu" onmouseover="AnnulerCacher();" onmouseout="CacherDelai();" onfocus="AnnulerCacher();" onblur="CacherDelai();">';

                for( $i=1; $i<=count($data_array[$num])-1; $i++ ) {
                    $str .= '<li><a href="'.$data_array[$num][$i]['href'].'">'.$data_array[$num][$i]['title'].'<span>&nbsp;;</span></a></li>';
                }
                $str .= '</ul>';
            }
        }
        return $str;
    }

    function display_config() {

        $str = "\n";
    
        $str .= '<script language="Javascript" type="text/javascript">'."\n";
        
        #---------------------------------------------------------------------
        #  true = le menu sera vertical,  gauche.
        #  false = le menu sera horizontal, en haut. 
        #---------------------------------------------------------------------
        $str .= "var vertical = ".$this->options['vertical'].";\n";

        #---------------------------------------------------------------------
        # TRES IMPORTANT !
	    #   Il faut mettre ici le nombre de menus, le script n'est pas capable de compter tout
	    #    seul ! :-p Donc si votre code va jusqu' <p id="menu5"...> il faut mettre 5. 
        #---------------------------------------------------------------------
        $str .= 'var nbmenu = '.count($this->items).";\n";

        #---------------------------------------------------------------------
        # Centrer le menu ? (true/false).
        # Centre horizontalement ou verticalement suivant le mode choisi. 
        #---------------------------------------------------------------------
        $str .= "var centrer_menu = ".$this->options['centrer_menu'].";\n";

        #---------------------------------------------------------------------
        # On est oblig de dfinir une largeur pour les menus.
	    #   Pour mettre des menus de largeurs diffrentes :
        #	var largeur_menu = new Array(largeur menu1, largeur menu2, largeur menu3...)
        #	Il faut faire attention  mettre autant de valeurs que de nombre de menu !
        #	Attention, si vous tes en menu vertical, mettez une largeur fixe (pas de Array) !
        #---------------------------------------------------------------------
        $str .= "var largeur_menu = ".$this->options['largeur_menu'].";\n";

        #---------------------------------------------------------------------
        # En mode vertical, on a besoin de connatre la hauteur de chaque menu.
        #	Mme si les "cases" ne sont pas dimensionnes en hauteur.
        #	Ajustez cette variable si les menus sont trop rapprochs ou espacs en vertical.
        #	Pour mettre des menus de hauteurs diffrentes :
        #	var hauteur_menu = new Array(hauteur menu1, hauteur menu2, hauteur menu3...)
        #	Il faut faire attention  mettre autant de valeurs que de nombre de menu !
        #	Attention, si vous tes en menu horizontal, mettez une largeur fixe (pas de Array) !
        #---------------------------------------------------------------------
        $str .= "var hauteur_menu = ".$this->options['hauteur_menu'].";\n";

        #---------------------------------------------------------------------
        # En mode horizontal.
        #	Largeur des sous-menus, pour IE uniquement, les autres navigateurs respectent la largeur
        #	auto. Mettez "auto" uniquement si vous tes sr d'avoir mis des &nbsp;  la place des
        #	espace dans les items !
        #	Pour mettre des sous-menus de largeurs diffrentes :
        #	var largeur_sous_menu = new Array(largeur1, largeur2...).
        #	Il faut faire attention  mettre autant de valeurs que de menus.
        #	Si un menu n'a pas de sous-menus, il faut mettre quand mme quelque chose !
        #	Il est possible de mettre "auto" dans certaines colonnes,  condition de respecter la
        #	consigne ci-dessus.
        #---------------------------------------------------------------------
        $str .= "var largeur_sous_menu = ".$this->options['largeur_sous_menu'].";\n";

        #---------------------------------------------------------------------
        # Pour les navigateurs connaissant la largeur automatique (s'adapte au contenu), cette
        #	option (active par dfaut) permet d'avoir une largeur automatique. En cas contraire
        #	(false), les sous menus auront la largeur largeur_sous_menu. 
        #---------------------------------------------------------------------
        $str .= "var largeur_auto_ssmenu = ".$this->options['largeur_auto_ssmenu'].";\n";

        #---------------------------------------------------------------------
        # ... pour mettre un peu d'espace entre les menus ! 
        #---------------------------------------------------------------------
        $str .= "var espace_entre_menus = ".$this->options['espace_entre_menus'].";\n";

        #---------------------------------------------------------------------
        # position du menu par rapport au haut de l'cran ou de la page.
        #	0 = le menu est tout en haut. en px 
        #---------------------------------------------------------------------
        $str .= "var top_menu = ".$this->options['top_menu'].";\n";
        
        #---------------------------------------------------------------------
        # En version horizontale.
        #	position des sous-menus par rapport au haut de l'cran ou de la page. Il faut prvoir
        #	la hauteur des menus, donc ne pas mettre 0 et faire " tton". en px */
        #---------------------------------------------------------------------
        $str .= "var top_ssmenu = top_menu + 21;\n";

        #---------------------------------------------------------------------
        # Position gauche du menu, en px. 
        #---------------------------------------------------------------------
        $str .= "var left_menu = ".$this->options['left_menu'].";\n";
        
        #---------------------------------------------------------------------
        # Quand la souris quitte un sous-menu, si le sous-menu disparait immdiatement,
        #	cela gne l'utilisateur. Alors on peut mettre un dlai avant disparition du sous-menu.
        #	500 ms c'est bien :-) 
        #---------------------------------------------------------------------
        $str .= "var delai = ".$this->options['delai'].";\n"; // en millisecondes

        #---------------------------------------------------------------------
        # Mettez  true si vous souhaitez que le menu soit toujours visible.
        #	Mettez false si vous ne le souhaitez pas, dans ce cas le menu "disparatra" quand vous
        #	descendrez dans la page. 
        #---------------------------------------------------------------------
        $str .= "var suivre_le_scroll = ".$this->options['suivre_le_scroll'].";\n";

        #---------------------------------------------------------------------
        # Pour IE uniquement, les balises <select> passent toujours au-dessus du menu, donc
        #	par dfaut on cache les listes droulantes quand le menu est ouvert, puis on les fait
        #	rapparatre  la fermeture du menu. Pour empcher a, mettre  false. 
        #---------------------------------------------------------------------
        $str .= "var cacher_les_select = ".$this->options['cacher_les_select'].";\n";


        #---------------------------------------------------------------------
        # HORIZONTAL ONLY
        #---------------------------------------------------------------------
        
        if ($this->options['vertical']=='false') {
            #-----------------------------------------------------------------
            #	Comme le menu peut se superposer avec le texte de la page, il est possible de faire
            #	descendre un peu la page (on augmente la marge du haut) pour arer un peu la page,
            #	une quarantaine de pixel c'est pas mal. en px
            #-----------------------------------------------------------------
            $str .= "var marge_en_haut_de_page = ".$this->options['marge_en_haut_de_page'].";\n";
        }


        #---------------------------------------------------------------------
        # VERTICAL ONLY
        #---------------------------------------------------------------------
        
        if ($this->options['vertical']=='true') {
            #-----------------------------------------------------------------
            # Position des sous-menus par rapport au bord gauche de l'cran.            #-----------------------------------------------------------------
            $str .= "var left_ssmenu = largeur_menu;\n";
            
            #-----------------------------------------------------------------
            #	On dcale le document  droite pour pas que le menu le superpose. 
            #-----------------------------------------------------------------
            $str .= "var marge_a_gauche_de_la_page = largeur_menu + 10;\n";
        }

        $str .= "</script>\n\n";
        return $str;
    }

    function display_style() {
        
        $str = "\n<style type=\"text/css\">\n";
        $str .= file_get_contents( dirname(__FILE__).'/'.$this->css_file );
        $str .= "</style>\n\n";
        $str = str_replace('url("', 'url("'.$this->base_url.'/', $str);
        return $str;       
    }

}
?>