<?php
//error_reporting(E_ALL);
##############################################################################
#                                                                            #
#      This file is part of IXPRIM CMS - Content Management System           #
#                       <http:#www.ixprim-cms.org/>                          #
#                                                                            #
#   Copyright (c) 2006 Christophe Deltheil <aka trollix> and contributors.   #
#                      All rights reserved.                                  #
# -------------------------------------------------------------------------- #
# ideas come from :                                                          #
# POSTNUKE Web Portal System - http://postnuke.org/                          #
# XOOPS Web Portal System - http://xoops.org/                                #
# myPHPNUKE Web Portal System - http://myphpnuke.com/                        #
# PHP-NUKE Web Portal System - http://phpnuke.org/                           #
# Thatware - http://thatware.org/                                            #
# dotclear Blog System - http://dotclear.net/                                #
# -------------------------------------------------------------------------- #
#  Ixprim CMS is free software; you can redistribute it and/or modify        #
#  it under the terms of the GNU General Public License as published by      #
#  the Free Software Foundation; either version 2 of the License, or         #
#  (at your option) any later version.                                       #
#                                                                            #
#  Ixprim CMS is distributed in the hope that it will be useful,             #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of            #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
#  GNU General Public License for more details.                              #
#                                                                            #
#  You should have received a copy of the GNU General Public License         #
#  along with this program; if not, write to the Free Software               #
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA  #
##############################################################################

#--------------------------------------------------------------------------- #
# This class is based on initial work of davidw@cascade.org.uk               #
# and totally rewritten for Ixprim by trollix                                #
#--------------------------------------------------------------------------- #

class ixCalendar
{

    var $first_day_of_week		= 1;	# first day of week - 0 = sunday/dimanche
    var $first_month_of_year	= 1;	# first month of the year - 1 = january/janvier
	var $display_month_links_after_today = 0; # display next link after today
	var $display_month_links_before_today = 0; # display next link after today

    var $short_day_names		= array('S', 'M', 'T', 'W', 'T', 'F', 'S');
    var $long_month_names		= array('January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December');
    
	var $css_style	=	 '<style type="text/css"> .ixcalheader { border: 1px solid #333399; font-weight: bold; color: #ffffff; background-color: #9999ff; text-align:center; vertical-align:top; }  .ixcaltoday { background-color: #9999ff; color:#ffffff;font-weight: bold; text-align:center;} .ixcalendar { margin: 1px; width:140; height:140; background-color: #efefef; border: 1px solid #333399; border-collapse: collapse;} .ixcalday { margin: 1px; padding:1px; border: 1px solid #333399; text-align:center;} .ixcalsetlink, .ixcalsetlink:link , .ixcalsetlink:visited { font-weight: bold; background-color: #333399; color:#ffffff;text-align:center; vertical-align:top; } .ixcalnextmonth:link, .ixcalnextmonth:visited { font-weight: bold; background-color: #9999ff; color:#ffffff; font-size:11px}  </style>';
	
    //------------------------------------------------------------------------
    //  class constructor - could be overridden
    //------------------------------------------------------------------------
    function ixCalendar() {
    }
   
    //------------------------------------------------------------------------
    //  class methods to set & get css style
    //------------------------------------------------------------------------
    function set_css_style( $p_style ) {
        $this->css_style = $p_style;
    }	

    function get_css_style() {
        return $this->css_style;
    }

    //------------------------------------------------------------------------
    //  class methods to set & get short month_names
    //------------------------------------------------------------------------
    function set_short_day_names( $p_day_array ) {
        $this->short_day_names = $p_day_array;
    }	

    function get_short_day_names() {
        return $this->short_day_names;
    }
    
    //------------------------------------------------------------------------
    //  class methods to set & get long month_names
    //------------------------------------------------------------------------
    function set_long_month_names( $p_month_array ) {
        $this->long_month_names = $p_month_array;
    }

    function get_long_month_names() {
        return $this->long_month_names;
    }
	
    //------------------------------------------------------------------------
    //  class methods to set & get 1st day of the week
    //------------------------------------------------------------------------
    function set_first_day_of_week( $p_first_day ) {
        $this->first_day_of_week = $p_first_day;
    }
    
	function get_first_day_of_week() {
        return $this->first_day_of_week;
    }
    
    //------------------------------------------------------------------------
    //  class methods to set & get 1st month of the year
    //------------------------------------------------------------------------    
    function set_first_month_of_year( $p_first_month ) {
        $this->first_month_of_year = $p_first_month;
    }

    function get_first_month_of_year() {
        return $this->first_month_of_year;
    }
      
    //------------------------------------------------------------------------
    //  class methods to set & get no_display_month_links_after_today
    //------------------------------------------------------------------------
    function set_display_month_links_after_today( $p_value ) {
        $this->display_month_links_after_today = $p_value;
    }
	
    function get_display_month_links_after_today() {
        return $this->display_month_links_after_today;
    }

    //------------------------------------------------------------------------
    //  class methods to set & get no_display_month_links_before_today
    //------------------------------------------------------------------------
    function set_display_month_links_before_today( $p_value ) {
        $this->display_month_links_before_today = $p_value;
    }
	
    function get_display_month_links_before_today() {
        return $this->display_month_links_before_today;
    }

    //------------------------------------------------------------------------
    //  class method need to be overridden to add links on day links
	//  return '' -> display no link
    //------------------------------------------------------------------------
    function set_calendar_next_prev_links($month, $year) {
        return '';
    }
    
    //------------------------------------------------------------------------
    //  class method need to be overridden to add links on day links
	//  return '' -> display no link
    //------------------------------------------------------------------------
    function set_date_link($day, $month, $year) {
        return '';
    }

    //------------------------------------------------------------------------
    //  class method need to be overridden to add links on day links
	//  return '' -> display no link
    //------------------------------------------------------------------------
    function set_calendar_current_month_links($month, $year) {
        return '';
    }

    //------------------------------------------------------------------------
    //  Display current month calendar
    //------------------------------------------------------------------------
    function display_current_month() {
        return $this->display_month( date('n'), date('Y') );
    }
    
    //------------------------------------------------------------------------
    //  Display current year calendar
    //------------------------------------------------------------------------
    function display_current_year() {
        return $this->display_year( date('Y') );
    }
        
    //------------------------------------------------------------------------
    //  Display calendar for a given month
    //------------------------------------------------------------------------
    function display_month($month, $year) {
        return $this->css_style.$this->__get_month_view($month, $year);
    }

    //------------------------------------------------------------------------
    //  Display calendar for a complete year
    //------------------------------------------------------------------------
    function display_year($year) {
        return $this->css_style.$this->getYearHTML($year);
    }
        
    

    //------------------------------------------------------------------------
    //  Number of days in a month
    //------------------------------------------------------------------------
	function __cal_get_days_in_month($p_month, $p_year) {
		return date("j", mktime(0, 0, 0, $p_month+1, 0, $p_year));
	}


    /*
        Generate the HTML for a given month
    */
    function __get_month_view($m, $y, $showYear = 1)
    {
        $s = "";
        
        $a = $this->adjustDate($m, $y);
        $month = $a[0];
        $year = $a[1];        
        
    	$days_in_moth_array = $this->__cal_get_days_in_month($month, $year);

		$mk_today_date = time();
    	$date = getdate( mktime(12, 0, 0, $month, 1, $year) );

    	$first = $date["wday"];
    	$monthName = $this->long_month_names[$month - 1];
    	
    	$prev = $this->adjustDate($month - 1, $year);
    	$next = $this->adjustDate($month + 1, $year);
		$mk_date_next = mktime(12,0,0,$next[0],1,$next[1]);
		$mk_date_prev = mktime(12,0,0,$prev[0],1,$prev[1]);
    	
    	if ($showYear == 1) {
    	    

			if ($this->display_month_links_before_today) {
				$prevMonth = $this->set_calendar_next_prev_links($prev[0], $prev[1]);
			}
			else {
				if ($mk_date_prev < $mk_today_date) {
					$prevMonth = "";
				}
				else  {
					$prevMonth = $this->set_calendar_next_prev_links($prev[0], $prev[1]);
				}
			}


			

			if ($this->display_month_links_after_today) {
				$nextMonth = $this->set_calendar_next_prev_links($next[0], $next[1]);
			}
			else {
				if ($mk_date_next > $mk_today_date) {
					$nextMonth = "";
				}
				else  {
					$nextMonth = $this->set_calendar_next_prev_links($next[0], $next[1]);
				}
			}

    	}
    	else {
    	    $prevMonth = "";
    	    $nextMonth = "";
    	}
    	
		$current_month = $this->set_calendar_current_month_links( $month, $year );
    	$header = $monthName . (($showYear > 0) ? " " . $year : "");
		$header = ($current_month != '' ) ? '<a class="ixcalnextmonth" href="'.$current_month.'">'.$header.'</a>' : $header;

    	
    	$s .= "<table class=\"ixcalendar\">\n";
    	$s .= "<tr>\n";
    	$s .= "<td class=\"ixcalheader\">" . (($prevMonth == "") ? '&nbsp;' : '<a class="ixcalnextmonth" href="'.$prevMonth.'">&laquo;</a>')  . '</td>';
    	$s .= "<td class=\"ixcalheader\" colspan=\"5\">$header</td>\n"; 
    	$s .= "<td class=\"ixcalheader\">" . (($nextMonth == "") ? '&nbsp;' : '<a class="ixcalnextmonth" href="'.$nextMonth.'">&raquo;</a>')  . '</td>';
    	$s .= "</tr>\n";
    	
    	$s .= $this->__short_day_line();
 
    	$d = $this->first_day_of_week + 1 - $first;
    	while ($d > 1) {
    	    $d -= 7;
    	}

        // Make sure we know when today is, so that we can use a different CSS style
        $today = getdate(time());
    	
    	while ($d <= $days_in_moth_array)
    	{
			
    	    $s .= "<tr>\n";       
    	    
    	    for ($i = 0; $i < 7; $i++) {
        	    
				unset( $class );    
				# link or not ? for the day 
				if ($d > 0 && $d <= $days_in_moth_array) {
    	            $computed_link = $this->set_date_link($d, $month, $year);
					
					if ($computed_link == '') {
						$link_to_display = $d;
					}
					else {
						$class = "ixcalsetlink";
						$link_to_display = '<a class="'.$class.'" href="'.$computed_link.'">'.$d.'</a>';
					}
					
    	        }
    	        else {
    	            $link_to_display = '&nbsp;';
    	        }
				
				if (!isset($class)) {
					$class = ($year == $today["year"] && $month == $today["mon"] && $d == $today["mday"]) ? "ixcaltoday" : "ixcalday";
				}

				$s .= '<td class="'.$class.'">'.$link_to_display.'</td>';       
        	    $d++;
    	    }
    	    $s .= "</tr>\n";    
    	}
    	
    	$s .= "</table>\n";
    	
    	return $s;  	
    }
    
    
    /*
        Generate the HTML for a given year
    */
    function getYearHTML($year)
    {
        $s = "";
    	$prev = $this->set_calendar_next_prev_links(0, $year - 1);
    	$next = $this->set_calendar_next_prev_links(0, $year + 1);
        
        $s .= "<table class=\"calendar\" border=\"0\">\n";
        $s .= "<tr>";
    	$s .= "<td align=\"left\">" . (($prev == "") ? "&nbsp;" : "<a href=\"$prev\">&lt;&lt;</a>")  . "</td>\n";
        $s .= "<td class=\"calendarHeader\" valign=\"top\" align=\"center\">" . (($this->first_month_of_year > 1) ? $year . " - " . ($year + 1) : $year) ."</td>\n";
    	$s .= "<td align=\"right\">" . (($next == "") ? "&nbsp;" : "<a href=\"$next\">&gt;&gt;</a>")  . "</td>\n";
        $s .= "</tr>\n";
        $s .= "<tr>";
        $s .= "<td class=\"calendar\" valign=\"top\">" . $this->__get_month_view(0 + $this->first_month_of_year, $year, 0) ."</td>\n";
        $s .= "<td class=\"calendar\" valign=\"top\">" . $this->__get_month_view(1 + $this->first_month_of_year, $year, 0) ."</td>\n";
        $s .= "<td class=\"calendar\" valign=\"top\">" . $this->__get_month_view(2 + $this->first_month_of_year, $year, 0) ."</td>\n";
        $s .= "</tr>\n";
        $s .= "<tr>\n";
        $s .= "<td class=\"calendar\" valign=\"top\">" . $this->__get_month_view(3 + $this->first_month_of_year, $year, 0) ."</td>\n";
        $s .= "<td class=\"calendar\" valign=\"top\">" . $this->__get_month_view(4 + $this->first_month_of_year, $year, 0) ."</td>\n";
        $s .= "<td class=\"calendar\" valign=\"top\">" . $this->__get_month_view(5 + $this->first_month_of_year, $year, 0) ."</td>\n";
        $s .= "</tr>\n";
        $s .= "<tr>\n";
        $s .= "<td class=\"calendar\" valign=\"top\">" . $this->__get_month_view(6 + $this->first_month_of_year, $year, 0) ."</td>\n";
        $s .= "<td class=\"calendar\" valign=\"top\">" . $this->__get_month_view(7 + $this->first_month_of_year, $year, 0) ."</td>\n";
        $s .= "<td class=\"calendar\" valign=\"top\">" . $this->__get_month_view(8 + $this->first_month_of_year, $year, 0) ."</td>\n";
        $s .= "</tr>\n";
        $s .= "<tr>\n";
        $s .= "<td class=\"calendar\" valign=\"top\">" . $this->__get_month_view(9 + $this->first_month_of_year, $year, 0) ."</td>\n";
        $s .= "<td class=\"calendar\" valign=\"top\">" . $this->__get_month_view(10 + $this->first_month_of_year, $year, 0) ."</td>\n";
        $s .= "<td class=\"calendar\" valign=\"top\">" . $this->__get_month_view(11 + $this->first_month_of_year, $year, 0) ."</td>\n";
        $s .= "</tr>\n";
        $s .= "</table>\n";
        
        return $s;
    }

	function __short_day_line() {

		$tempStr = '<tr>';

		for( $i=0; $i<=6; $i++) {
			$tempStr .= '<td class="ixcalheader">' . $this->short_day_names[($this->first_day_of_week+$i)%7] . '</td>';
		}
		$tempStr .= '</tr>';
		return $tempStr;
	}
	
	/*
        Adjust dates to allow months > 12 and < 0. Just adjust the years appropriately.
        e.g. Month 14 of the year 2001 is actually month 2 of year 2002.
    */
    function adjustDate($month, $year)
    {
        $a = array();  
        $a[0] = $month;
        $a[1] = $year;
        
        while ($a[0] > 12)
        {
            $a[0] -= 12;
            $a[1]++;
        }
        
        while ($a[0] <= 0)
        {
            $a[0] += 12;
            $a[1]--;
        }
        
        return $a;
    }


    
}

?>