<?php
//error_reporting(E_ALL);
##############################################################################
#                                                                            #
#      This file is part of IXPRIM CMS - Content Management System           #
#                       <http:#www.ixprim-cms.org/>                          #
#                                                                            #
#   Copyright (c) 2006 Christophe Deltheil <aka trollix> and contributors.   #
#                      All rights reserved.                                  #
# -------------------------------------------------------------------------- #
# ideas come from :                                                          #
# POSTNUKE Web Portal System - http://postnuke.org/                          #
# XOOPS Web Portal System - http://xoops.org/                                #
# myPHPNUKE Web Portal System - http://myphpnuke.com/                        #
# PHP-NUKE Web Portal System - http://phpnuke.org/                           #
# Thatware - http://thatware.org/                                            #
# dotclear Blog System - http://dotclear.net/                                #
# -------------------------------------------------------------------------- #
#  Ixprim CMS is free software; you can redistribute it and/or modify        #
#  it under the terms of the GNU General Public License as published by      #
#  the Free Software Foundation; either version 2 of the License, or         #
#  (at your option) any later version.                                       #
#                                                                            #
#  Ixprim CMS is distributed in the hope that it will be useful,             #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of            #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
#  GNU General Public License for more details.                              #
#                                                                            #
#  You should have received a copy of the GNU General Public License         #
#  along with this program; if not, write to the Free Software               #
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA  #
##############################################################################
include_once(IXP_ROOT_PATH."/kernel/class/ixpobject.class.php");
include_once(IXP_ROOT_PATH."/kernel/class/ixpmodule.class.php");
include_once(IXP_ROOT_PATH."/kernel/class/ixpgroup.class.php");

class ixpBlock extends ixpObject {

	function ixpBlock($id = NULL) 
	{
		$this->ixpObject();
		$this->initVar('bid', 'int', NULL, false);
		$this->initVar('mid', 'int', 0, false);
		$this->initVar('func_num', 'int', 0, false);
		$this->initVar('options', 'textbox', NULL, false, 255, false);
		$this->initVar('name', 'textbox', NULL, true, 150, false);
		$this->initVar('position', 'int', 0, false);
		$this->initVar('title', 'textbox', NULL, false, 150, false);
		$this->initVar('content', 'textarea', NULL, false);
		$this->initVar('side', 'int', 0, false);
		$this->initVar('weight', 'int', 0, false);
		$this->initVar('visible', 'int', 0, false);
		$this->initVar('type', 'other', NULL, false);
		$this->initVar('is_duplicate', 'int', 0, false);
		$this->initVar('c_type', 'other', NULL, false);
		$this->initVar('themeblock', 'textbox', NULL, false, 150, false);
		$this->initVar('weightblock', 'textbox', 150, false);
		$this->initVar('spaceblock', 'textbox', 20, false);
		$this->initVar('ixp_language', 'textbox', 20, false);
		$this->initVar('cachetime', 'int', 0, false);
		$this->initVar('isactive', 'int', NULL, false);
		
		if (!empty($id)) {
            if (is_array($id)) { 
                $this->set($id);
            } else { 
                $this->load(intval($id));
            }
		}

	}

	function load($id) {

		if (!empty($id)) {
            $sql = "SELECT * FROM ".$this->db->prefix("ixpblocks")." WHERE bid = ".$id;
		    $result = $this->db->sql_query($sql);
		    $arr = $this->db->sql_fetchrow($result, MYSQL_ASSOC);		//fetchArray 200506
		    $this->set($arr);
		    $this->db->sql_freeresult($result);
		}

	}

	function store() {

        if (!$this->isCleaned()) {
			if (!$this->cleanVars()) {
				return false;
			}
		}

		foreach ( $this->cleanVars as $k=>$v ) {
			$$k = $v;
		}

		if (empty($bid)) {
			$bid = $this->db->sql_genId($this->db->prefix("blocks")."_bid_seq");
			$sql = "INSERT INTO ".$this->db->prefix('ixpblocks')." (bid, mid, func_num, options, name, position, title, content, side, weight, visible, type, is_duplicate, c_type, themeblock, weightblock, spaceblock, ixp_language, cachetime, isactive) VALUES ('$bid', '$mid', '$func_num', '$options', '".$name."', '$position', '".$title."', '".$content."', '".$side."', '".intval($weight)."', '".intval($visible)."', '$type', '".intval($is_duplicate)."', '".$c_type."', '".$themeblock."', '".$weightblock."', '".$spaceblock."', '".$ixp_language."', '".$cachetime."', 1)";
		} else {
			$sql = "UPDATE ".$this->db->prefix("ixpblocks")." SET options='".$options."'";
			// a custom block needs its own name
			if ( $type == "C" ) {
				$sql .= ", name='".$name."'";
			}
			$sql .= ", position='".$position."', title='".$title."', content='".$content."', side='".$side."', weight='".intval($weight)."', visible='".intval($visible)."', is_duplicate='".intval($is_duplicate)."', c_type='".$c_type."', themeblock='".$themeblock."', weightblock='".$weightblock."',  spaceblock='".$spaceblock."',  ixp_language='".$ixp_language."',  cachetime='".$cachetime."' WHERE bid='".intval($bid)."'";
		}
		//echo $sql;
		if ( !$this->db->sql_query($sql) ) {
			$this->setErrors("Could not save block data into database");
			return false;
		}
		if ( empty($bid) ) {
			$bid = $this->db->sql_nextid();
		}
		return $bid;
	}

	function delete() 
	{
		$sql = "DELETE FROM ".$this->db->prefix("ixpblocks")." WHERE bid=".$this->getVar("bid");
		if ( !$this->db->sql_query($sql) ) {
			return false;
		}
		$sql = "DELETE FROM ".$this->db->prefix("groups_blocks_link")." WHERE block_id=".$this->getVar("bid");
		$this->db->sql_query($sql);
		return true;
	}

	/**
   	* do stripslashes/htmlspecialchars according to the needed output
	*
	* @param $format      output use: S for Show and E for Edit
	* @param $c_type    type of block content
	* @returns string
	*/
	function getContent($format = "S", $c_type = "T") 
	{
		$myts =& MyTextSanitizer::getInstance();
        $content = '';

		switch ($format) {

			case "S":
				// check the type of content
				// H : custom HTML block
				// P : custom PHP block
				// J : custom JS block
				// S : use text sanitizater (smilies enabled)
				// T : use text sanitizater (smilies disabled)
				if (( $c_type == "H" ) or ( $c_type == "J" )) {
					return  str_replace("{X_SITEURL}", IXP_URL."/", $myts->oopsStripSlashesRT($this->getVar("content", "N")));
				} elseif ( $c_type == "P" ) {
                    ob_start();
					print eval($this->getVar("content", "N"));
    				$content = ob_get_contents();
    				ob_end_clean();
					return str_replace("{X_SITEURL}", IXP_URL."/", $content);
				} elseif ( $c_type == "S" ) {
					return str_replace("{X_SITEURL}", IXP_URL."/", $myts->makeTareaData4Show($this->getVar("content", "N"), 1, 1));
				} else {
					return str_replace("{X_SITEURL}", IXP_URL."/", $myts->makeTareaData4Show($this->getVar("content", "N")));
				}

			case "E":
				return($this->getVar("content", "E"));
		}
		return $content;
	}



	function buildBlock() 
	{
		global $ixpdb;

		$block = array();
		
		// M for module block, S for system block C for Custom
		if ( $this->getVar("type") != "C" ) {
			// 0.968 optimisation -> passage par getByDirname car optimis ($GLOBAL)
			//$module = new ixpModule($this->getVar("mid"));
			
			if (isset( $GLOBALS['global_module']['mid'][$this->getVar("mid")] )) {
				$module = $GLOBALS['global_module']['mid'][$this->getVar("mid")];
			} else {
				$module = new ixpModule($this->getVar("mid"));
				$GLOBALS['global_module']['mid'][$this->getVar("mid")] = $module;				
			}
			

			// get block display function
			$show_func = $module->blockShowFunc($this->getVar("func_num"));
			if (!$show_func) { 
                return false;
            }

			// must get lang files b4 execution of the function
			if ( file_exists(IXP_ROOT_PATH."/mod/".$module->dirname()."/blocks/".$module->blockFuncFile($this->getVar("func_num"))) ) {
                
                if ( file_exists(IXP_ROOT_PATH."/mod/".$module->dirname()."/language/".IXPGLOBAL___current_language."/blocks.php") ) {
					include_once(IXP_ROOT_PATH."/mod/".$module->dirname()."/language/".IXPGLOBAL___current_language."/blocks.php");
				} elseif ( file_exists(IXP_ROOT_PATH."/mod/".$module->dirname()."/language/french/blocks.php") ) {
					include_once(IXP_ROOT_PATH."/mod/".$module->dirname()."/language/french/blocks.php");
				}
				
				// get the file where the function is defined
				include_once(IXP_ROOT_PATH."/mod/".$module->dirname()."/blocks/".$module->blockFuncFile($this->getVar("func_num")));
				$options = explode("|", $this->getVar("options"));
				if ( function_exists($show_func) ) {
					// execute the function
					$block = $show_func($options);
					if (!$block) { 
                        return false;
                    }
				} else {
					return false;
				}

				$block['content'] = $this->buildContent($this->getVar("position"),$block['content'],$this->getContent("S",$this->getVar("c_type")));
				$block['title'] = $this->buildTitle($block['title'], $this->getVar("title"), $this->getVar("mid"), $this->getVar("themeblock"));
				$block['themeblock'] = $this->getVar("themeblock");     # TiX
				$block['weightblock'] = $this->getVar("weightblock");   # TiX
				$block['spaceblock'] = $this->getVar("spaceblock");     # TiX
				$block['ixp_language'] = $this->getVar("ixp_language"); # TiX
				$block['cachetime'] = $this->getVar("cachetime");       # TiX
				$block['type'] = $this->getVar("type");                 # TiX
			} else {
				return false;
			}

		} else {

			// it is a custom block, so just return the contents
			// and title in db
			$block['title'] = $this->buildTitle($block['title'], $this->getVar("title"), $this->getVar("mid"), $this->getVar("themeblock"));
			$block['content'] = $this->getContent("S",$this->getVar("c_type"));
			$block['themeblock'] = $this->getVar("themeblock");         # TiX
			$block['weightblock'] = $this->getVar("weightblock");       # TiX
			$block['spaceblock'] = $this->getVar("spaceblock");         # TiX
			$block['ixp_language'] = $this->getVar("ixp_language");     # TiX
			$block['cachetime'] = $this->getVar("cachetime");           # TiX
			$block['type'] = $this->getVar("type");                     # TiX

		}

		return $block;
	}

	/*
	* Aligns the content of a block
	* If position is 0, content in DB is positioned
	* before the original content
	* If position is 1, content in DB is positioned
	* after the original content
	*/
	function buildContent($position, $content='', $contentdb='') {
		if ($position == 0) {
			return($contentdb.$content);
		} elseif ($position == 1) {
			return($content.$contentdb);
		} else {
            return('');
        }
	}

	/**
	* pour mmo:
	* originaltitle: dfini dans les blocks (c'est le nom sans lien)
	* newtitle: dfini par la configuration du bloc
    */
	function buildTitle($originaltitle, $newtitle='', $mid, $themeblock) 
	{
        if ($newtitle=='notitle') {
			return('');
		} elseif ($newtitle=='titlewithlink') {
			$modname = ixpModule::dirname_by_mid($mid);
			return('<a class="'.$themeblock.'_blocktitle" href="'.IXP_ROOT_WEB.'/ixm_'.$modname.'.php">'.$originaltitle.'</a>');
		} elseif ($newtitle=='titlewithoutlink') {
			return('<span class="'.$themeblock.'_blocktitle">'.$originaltitle.'</span>');
		} elseif ($newtitle!='') {
			return($newtitle);
		} else {
			return($originaltitle);
		}

	}

	/**
   	* oui si bloc defini par l'utilisateur
	* non sinon
	*/
	function isCustom() {
	    return($this->getVar('type') == 'C');
	}

	/**
   	* gets html form for editting block options
	* 
	*/
	function getOptions() {	

		if ($this->getVar("type") != "C") {

			// 0.968 optimisation -> passage par getByDirname car optimis ($GLOBAL)
			//$module = new ixpModule($this->getVar("mid"));
			
			if (isset( $GLOBALS['global_module']['mid'][$this->getVar("mid")] )) {
				$module = $GLOBALS['global_module']['mid'][$this->getVar("mid")];
			} else {
				$module = new ixpModule($this->getVar("mid"));
				$GLOBALS['global_module']['mid'][$this->getVar("mid")] = $module;				
			}

			$edit_func = $module->blockEditFunc($this->getVar("func_num"));
			if (!$edit_func) {
                return false;
			}

			if (file_exists(IXP_ROOT_PATH."/mod/".$module->dirname()."/blocks/".$module->blockFuncFile($this->getVar("func_num")))) {
				
				if ( file_exists(IXP_ROOT_PATH."/mod/".$module->dirname()."/language/".IXPGLOBAL___current_language."/blocks.php") ) {
					include_once(IXP_ROOT_PATH."/mod/".$module->dirname()."/language/".IXPGLOBAL___current_language."/blocks.php");
				} elseif ( file_exists(IXP_ROOT_PATH."/mod/".$module->dirname()."/language/french/blocks.php") ) {
					include_once(IXP_ROOT_PATH."/mod/".$module->dirname()."/language/french/blocks.php");
				}

				include_once(IXP_ROOT_PATH."/mod/".$module->dirname()."/blocks/".$module->blockFuncFile($this->getVar("func_num")));
				$options = explode("|", $this->getVar("options"));
				$edit_form = $edit_func($options);
				
                if ( !$edit_form ) {
					return false;
				} else {
                    return $edit_form;
                }
			} else {
				return false;
			}
		} else {
			return false;
		}

	}

	/**
   	* get all the blocks that match the supplied parameters
	* @param $side   0: sideblock - left
	*		 1: sideblock - right
	*		 2: sideblock - left and right
	*		 3: centerblock - left
	*		 4: centerblock - right
	*		 5: centerblock - center
	*		 6: centerblock - left, right, center
	* @param $groupid   groupid (can be an array)
	* @param $visible   0: not visible 1: visible
	* @param $orderby   order of the blocks
	* @returns array of block objects
	*/
	function getAllBlocksByGroup($groupid, $asobject=true, $side=NULL, $visible=NULL, $orderby="b.weight, b.bid", $isactive=1)
	{
		global $ixpdb;

		$ret = array();
		if ( !$asobject ) {
			$sql = "SELECT b.bid ";
		} else {
			$sql = "SELECT b.* ";
		}
		$sql .= "FROM ".$ixpdb->prefix("ixpblocks")." b LEFT JOIN ".$ixpdb->prefix("groups_blocks_link")." l ON l.block_id=b.bid";
		if ( is_array($groupid) ) {
			$sql .= " WHERE (l.groupid=".$groupid[0];
			$size = sizeof($groupid);
			if ( $size  > 1 ) {
				for ( $i = 1; $i < $size; $i++ ) {
					$sql .= " OR l.groupid=".$groupid[$i];
				}
			}
			$sql .= ")";
		} else {
			$sql .= " WHERE l.groupid=".$groupid;
		} 
		$sql .= " AND b.isactive=".$isactive;
		
		if (isset($side)) {

			// get both sides in sidebox? (some themes need this)
			if ($side == 2)	{ 
                $side = "(b.side=0 OR b.side=1)";
            } elseif ($side == 6) {
                $side = "(b.side=3 OR b.side=4 OR b.side=5)";
            } elseif ($side == 10) {
                $side = "(b.side=7 OR b.side=8 OR b.side=9)";
            } elseif ($side == 100) {
                $side = '(0 '.IXP_FREEBLOCKS_OR_SIDE.')';
            } elseif ($side == 1000) { 
                $side = "(side=0 OR side=1 OR side=3 OR side=4 OR side=5 OR side=7 OR side=8 OR side=9 ".IXP_FREEBLOCKS_OR_SIDE.')';
            } else { 
                $side = "b.side=".$side;
            }
			$sql .= " AND ".$side;
		}

		if (isset($visible)) { 
            $sql .= " AND b.visible=$visible";
        }

		#$sql .= " AND b.bid=3";
		$sql .= " ORDER BY $orderby";
		$result = $ixpdb->sql_query($sql);
		$added = array();
		while ( $myrow = $ixpdb->sql_fetchrow($result) ) {  //fetchArray
			if (!in_array($myrow['bid'], $added)) {
				if (!$asobject) {
					$ret[] = $myrow['bid'];
                } else {
					$ret[] = new ixpBlock($myrow);
				}
				array_push($added, $myrow['bid']);
			}
		}
		//echo $sql;
		$ixpdb->sql_freeresult($result);
		return $ret;
	}

	function getAllBlocksByGroupByModule($groupid, $tabModBlocks, $asobject=true, $side=NULL, $visible=NULL, $orderby="b.weight,b.bid", $isactive=1)
	{
		global $ixpdb;

		$ret = array();
	
		if ( !$asobject )	{ 
			$sql = "SELECT b.bid ";
		} else { 
			$sql = "SELECT b.* ";
		}

		$sql .= "FROM ".$ixpdb->prefix("ixpblocks")." b LEFT JOIN ".$ixpdb->prefix("groups_blocks_link")." l ON l.block_id=b.bid";
		
		if ( is_array($groupid) ) {
			$sql .= " WHERE (l.groupid=".$groupid[0];
			$size = sizeof($groupid);
			if ( $size  > 1 ) {
				for ( $i = 1; $i < $size; $i++ ) {
					$sql .= " OR l.groupid=".$groupid[$i];
				}
			}
			$sql .= ")";
		} else {
			$sql .= " WHERE l.groupid=".$groupid;
		} 
		$sql .= " AND b.isactive=".$isactive;
		
		if ( isset($side) ) {
			// get both sides in sidebox? (some themes need this)
			if ( $side == 2 )		{ $side = "(b.side=0 OR b.side=1)";					} 
			elseif ( $side == 6 )	{ $side = "(b.side=3 OR b.side=4 OR b.side=5)";		}
			elseif ( $side == 10 )	{ $side = "(b.side=7 OR b.side=8 OR b.side=9)";			} //Tix
			//elseif ( $side == 100 ) { $side = "(side=11 OR side=12 OR side=13 OR side=14 OR side=15 OR side=16 OR side=17 OR side=18 OR side=19)"; } //Tix
			elseif ( $side == 100 ) { $side = '(0 '.IXP_FREEBLOCKS_OR_SIDE.')'; } //Tix
			//elseif ( $side == 1000 ){ $side = "(b.side=0 OR b.side=1 OR b.side=3 OR b.side=4 OR b.side=5 OR b.side=7 OR b.side=8 OR b.side=9  OR side=11 OR side=12 OR side=13 OR side=14 OR side=15 OR side=16 OR side=17 OR side=18 OR side=19)"; } //Tix
			elseif ( $side == 1000 ){ $side = "(side=0 OR side=1 OR side=3 OR side=4 OR side=5 OR side=7 OR side=8 OR side=9 ".IXP_FREEBLOCKS_OR_SIDE.')'; } //Tix
			else					{ $side = "b.side=".$side;							}
			$sql .= " AND ".$side;
		}
		
		if ( isset($visible) ) { $sql .= " AND b.visible=$visible"; }
		#Tix: solution 1: ajouter le bid dans la requete
		#if ( !empty($modBlocks) ) { $sql .= " AND b.bid=$modBlocks"; }

		if (!empty($tabModBlocks))
		{
		  $str=' AND ( ';
		  foreach( $tabModBlocks as $tabkey)
		  {
		    $str .= ' b.bid='.$tabkey.' OR ';
		  }
		  $sql .= $str.' 0 )';
		}
	
		$sql .= " ORDER BY $orderby";
		$result = $ixpdb->sql_query($sql);
		$added = array();
		
		while ( $myrow = $ixpdb->sql_fetchrow($result, MYSQL_ASSOC) ) //fetchArray 200506
		{
			#Comment: s'il n'est pas dans le tab (init  vide) alors l'ajouter...
			#print_r($tabModBlocks);
			if ( !in_array($myrow['bid'], $added) )
			{
				if (!$asobject)	{ $ret[] = $myrow['bid'];			} 
				else			{ $ret[] = new ixpBlock($myrow);	}
				array_push($added, $myrow['bid']);
			}
		}
		//echo $sql;
		$ixpdb->sql_freeresult($result);
		return $ret;
	}

	function getAllBlocks($rettype="object", $side=NULL, $visible=NULL, $orderby="side,weight,bid", $isactive=1)
	{
		global $ixpdb;

		$ret = array();
		$where_query = " WHERE isactive=".$isactive;
		if (isset($side)) {     // get both sides in sidebox? (some themes need this)
		
			if ($side == 2)	{ 
                $side = "(side=0 OR side=1)";
            } elseif ($side == 6) { 
                $side = "(side=3 OR side=4 OR side=5)";
            } elseif ($side == 10) { 
                $side = "(side=7 OR side=8 OR side=9)";
            } elseif ($side == 100) { 
                $side = '(0 '.IXP_FREEBLOCKS_OR_SIDE.')';
            } elseif ($side == 1000){ 
                $side = "(side=0 OR side=1 OR side=3 OR side=4 OR side=5 OR side=7 OR side=8 OR side=9 ".IXP_FREEBLOCKS_OR_SIDE.')';
            } else { 
                $side = "side=".$side;
            }
			$where_query .= " AND ".$side;
		}

		if ( isset($visible) ) {
			$where_query .= " AND visible=$visible";
		}
		$where_query .= " ORDER BY $orderby";

		switch($rettype) {

			case "object":
				$sql = "SELECT * FROM ".$ixpdb->prefix("ixpblocks").$where_query;
				$result = $ixpdb->sql_query($sql);
				while ( $myrow = $ixpdb->sql_fetchrow($result) ) {  //fetchArray
				    $ret[] = new ixpBlock($myrow);
				}
				$ixpdb->sql_freeresult($result);
			    break;

			case "list":
				$sql = "SELECT * FROM ".$ixpdb->prefix("ixpblocks").$where_query;
				$result = $ixpdb->sql_query($sql);
				while ( $myrow = $ixpdb->sql_fetchrow($result)) {   //fetchArray
					$block = new ixpBlock($myrow);
					$name = ($block->getVar("type") != "C") ? $block->getVar("name") : $block->getVar("title");
					$ret[$block->getVar("bid")] = $name;
				}
				$ixpdb->sql_freeresult($result);
				break;

			case "id":
				$sql = "SELECT bid FROM ".$ixpdb->prefix("ixpblocks").$where_query;
				$result = $ixpdb->sql_query($sql);
				while ($myrow = $ixpdb->sql_fetchrow($result)) {    //fetchArray
					$ret[] = $myrow['bid'];
				}
				$ixpdb->sql_freeresult($result);
				break;

		}

		return $ret;
	}

	function getByModule($moduleid, $asobject=true) {

		global $ixpdb;

		if ( $asobject == true ) {
			$sql = $sql = "SELECT * FROM ".$ixpdb->prefix("ixpblocks")." WHERE mid=".$moduleid;
		} else {
			$sql = "SELECT bid FROM ".$ixpdb->prefix("ixpblocks")." WHERE mid=".$moduleid;
		}
		$result = $ixpdb->sql_query($sql);
		$ret = array();
		while( $myrow = $ixpdb->sql_fetchrow($result) ) {   //fetchArray
			if ( $asobject ) {
				$ret[] = new ixpBlock($myrow);
			} else {
				$ret[] = $myrow['bid'];
			}
		}
		return $ret;
	}
    
	function getName($bid) {

		global $ixpdb;

		$sql = "SELECT name FROM ".$ixpdb->prefix("ixpblocks")." WHERE bid=".$bid;
		$result = $ixpdb->sql_query($sql);
		$name = $ixpdb->sql_fetchrow($result); //fetchArray
		$ret = $name['name'];
		$ixpdb->sql_freeresult($result);
		return $ret;
	}


    // Ne pas employer avec $block->getMid( $bid ), mais plutt $block->getvar('mid');
	// ncessaire si: ixpblocks::getMid
	function getMid( $bid )
	{
		global $ixpdb;

		$sql = "SELECT mid FROM ".$ixpdb->prefix("ixpblocks")." WHERE bid=".$bid;
		$result = $ixpdb->sql_query($sql);
		$name = $ixpdb->sql_fetchrow($result); //fetchArray
		$ret = $name['mid'];
		$ixpdb->sql_freeresult($result);
		return $ret;
	}

    // idem : pour : ixpBlock::get_cachetime( '3' )
	function get_cachetime( $bid )
	{
		global $ixpdb;

		$sql = "SELECT cachetime FROM ".$ixpdb->prefix("ixpblocks")." WHERE bid=".$bid;
		$result = $ixpdb->sql_query($sql);
		$name = $ixpdb->sql_fetchrow($result); //fetchArray
		$ret = $name['cachetime'];
		$ixpdb->sql_freeresult($result);
		return $ret;
	}

	function getTitle( $bid )
	{
		global $ixpdb;

		$sql = "SELECT title FROM ".$ixpdb->prefix("ixpblocks")." WHERE bid=".$bid;
		$result = $ixpdb->sql_query($sql);
		$name = $ixpdb->sql_fetchrow($result); //fetchArray
		$ret = $name['title'];
		$ixpdb->sql_freeresult($result);
		return $ret;
	}
	function getSideStr( $bid )
	{
		global $ixpdb;

		$sql = "SELECT side FROM ".$ixpdb->prefix("ixpblocks")." WHERE bid=".$bid;
		$result = $ixpdb->sql_query($sql);
		$type = $ixpdb->sql_fetchrow($result); //fetchArray
		$ret = $type['side'];
		switch($ret)
		{
			case 0: return _GALAD_BLOCK_L; break;
			case 1: return _GALAD_BLOCK_R; break;
			case 3: return _GALAD_BLOCK_TL;break;
			case 4: return _GALAD_BLOCK_TR;break;
			case 5: return _GALAD_BLOCK_TC;break;
			case 7: return _GALAD_BLOCK_BL;break;
			case 8: return _GALAD_BLOCK_BR;break;
			case 9: return _GALAD_BLOCK_BC;break;
			// Bloc Free 1
			case $ret: return constant('_GALAD_BLOCK_F'.($ret-10));break;
		}
	}

	function isCenterBlock( $bid )
	{
		global $ixpdb;

		$sql = "SELECT side FROM ".$ixpdb->prefix("ixpblocks")." WHERE bid=".$bid;
		$result = $ixpdb->sql_query($sql);
		$type = $ixpdb->sql_fetchrow($result); //fetchArray
		$ret = $type['side'];
		if ( ($ret!=0) && ($ret!=1))  return 1;
		else return 0;
	}

	function getUserBlockSide()
	{
		global $ixpdb;
		
		$mid = ixpModule::mid_by_dirname('ixpmembers');
		if ($mid != '') {
			$sql = "SELECT side FROM ".$ixpdb->prefix("ixpblocks")." WHERE mid=".$mid." AND func_num=1 AND isactive=1";
			$result = $ixpdb->sql_query($sql);
			list( $side ) = $ixpdb->sql_fetchrow($result);
		}
		else {
			$side = -1;
		}
		return $side;
	}


}

?>