<?php
//error_reporting(E_ALL);
##############################################################################
#                                                                            #
#      This file is part of IXPRIM CMS - Content Management System           #
#                       <http:#www.ixprim-cms.org/>                          #
#                                                                            #
#   Copyright (c) 2006 Christophe Deltheil <aka trollix> and contributors.   #
#                      All rights reserved.                                  #
# -------------------------------------------------------------------------- #
# ideas come from :                                                          #
# POSTNUKE Web Portal System - http://postnuke.org/                          #
# XOOPS Web Portal System - http://xoops.org/                                #
# myPHPNUKE Web Portal System - http://myphpnuke.com/                        #
# PHP-NUKE Web Portal System - http://phpnuke.org/                           #
# Thatware - http://thatware.org/                                            #
# dotclear Blog System - http://dotclear.net/                                #
# -------------------------------------------------------------------------- #
#  Ixprim CMS is free software; you can redistribute it and/or modify        #
#  it under the terms of the GNU General Public License as published by      #
#  the Free Software Foundation; either version 2 of the License, or         #
#  (at your option) any later version.                                       #
#                                                                            #
#  Ixprim CMS is distributed in the hope that it will be useful,             #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of            #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
#  GNU General Public License for more details.                              #
#                                                                            #
#  You should have received a copy of the GNU General Public License         #
#  along with this program; if not, write to the Free Software               #
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA  #
##############################################################################

class ixpBrowser
{

	var $browser=Array(

	'recorded'=>NULL,
	'user_agent'=>'',
	'format'=>'',
	'platform'=>'',
	'os'=>'',
	'parent'=>'',
	'majorver'=>0,
	'minorver'=>0,
	'javascript'=>1,
	'activexcontrols'=>1,
	'cookies'=>0,
	'visitors_agent'=>'',
	'lang' =>'fr'
	);
	var $summary;	// String - chaine rsum
	var $agent_max_length;

	// CONSTRUCTOR - Main function to resolving user agents
	function ixpBrowser( $p_user_agent ) // PUBLIC - BrowserInfo((string) USER_AGENT_STRING)
	{
		$this->user_agent = $p_user_agent;
		$this->agent_max_length = 50;
		$this->_analyze_browser();
		$this->summary = strtoupper($this->browser['parent']) . ';' . $this->browser['majorver'] . '.' . $this->browser['minorver'] . ';'. $this->browser['os']  ;
		$this->browser['visitors_agent'] = $this->_visitors_agent();

		// Default Language
		if (is_integer(strpos($_SERVER['HTTP_ACCEPT_LANGUAGE'],'fr'))) {
			$this->browser['lang'] = 'french';
		} else {
			$this->browser['lang'] = 'english';
		}

	}

	function set_agent_max_length( $p_agent_max_length )
	{
		$this->agent_max_length = $p_agent_max_length;
	}

	function _visitors_agent()
	{

		if ( $this->browser['crawler'] == 1) {
			$new_agent = strip_tags( $this->user_agent );
			if ( strlen($new_agent) > $this->agent_max_length ) {
				$new_agent = substr($new_agent, 0, $this->agent_max_length-4).' ...';
			}
			return $new_agent;
		}
		else {
			return strtoupper($this->browser['parent']) . ';' . $this->browser['majorver'] . '.' . $this->browser['minorver'] . ';'. $this->browser['os']  ;
		}
	}


	/***********************************************************************************/

	function _analyze_browser()
	{

		$this->browser = array();

		$regex_windows  = '/([^dar]win[dows]*)[\s]?([0-9a-z]*)[\w\s]?([a-z0-9.]*)/i';
		$regex_mac      = '/(68[k0]{1,3})|(ppc mac os x)|([p\S]{1,5}pc)|(darwin)/i';
		$regex_linux    = '/x11|inux/i';
		$regex_unix     = '/sun|i86|irix|hp-ux|aix|dec|osfl|alphaserver|ultrix|alphastation|vax|openvms|sco|unix_sv|(free)?(bsd)/i';
		$regex_crawler  ='/abou|alta|ask|asps|atomz|b2w|blowfish|bookmark|bot|brouser|eye|'.
		'catch|cgi|cosmos|crawl|data|download|easy|email|fetch|fusion|generic|get|'.
		'gulli|hitwise|httplib|java|link|load|lycos|net|netmind|offline|page|php|picker'.
		'|python|scan|scout|search|seek|site|slurp|spanner|spide|spider|spyder'.
		'|super|tele|tools|tracker|url|web|wget|www-perl/i';
		$regex_os2      = '/os\/2|ibm-webexplorer/i'; // not detected

		if(preg_match_all($regex_windows,$this->user_agent,$match)) {

			$v  = $match[2][count($match[0])-1];
			$v2 = $match[3][count($match[0])-1];

			if(stristr($v,'NT') && $v2 == 5.1 || stristr($v,'XP')) {

				$v = 'WinXP';
			}
			elseif ($v == '2000' || (stristr($v,'NT') && $v2 == 5.0)) {

				$v = 'Win2000';
			}
			else if (stristr($v,'9x') && $v2 == 4.9) {

				$v = 'Win98';							//Windows 98
			}
			elseif($v.$v2 == '16bit') {

				$v = 'Win16';
			}
			else {
				$v = "WinOther";						// WinME | WinCE
			}

			$this->browser['format']="windows";
			$this->browser['os']=$v;
		}
		elseif(preg_match($regex_mac,$this->user_agent,$match)) {

			$os = !empty($match[1]) ? '68k' : '';
			$os = !empty($match[2]) ? 'osx' : $os;
			$os = !empty($match[3]) ? 'ppc' : $os;
			$os = !empty($match[4]) ? 'osx' : $os;

			if($os=="osx"){
				$this->browser['format']="unix";
			}
			else{
				$this->browser['format']="mac";
			}

			$this->browser['os']= "mac".$os;
			$this->browser['activexcontrols']=0;
		}elseif(preg_match($regex_linux,$this->user_agent,$match)){
			$this->browser['format']="unix";
			$this->browser['os']="linux";
		}elseif(preg_match($regex_unix,$this->user_agent,$match)){
			$this->browser['format']="unix";
			$this->browser['os']="unix";
		}else{
			$this->browser['format']="unknown";
			$this->browser['os']="unknown";
		}
		if($this->browser['format']=="unix"){
			$this->browser['activexcontrols']=0;
		}
		$this->browser['platform']=$this->browser['os']; // !! 'platform' is the browscap name for the os !!

		/* Determine Browser
		*/
		$log_version[1]="0.0";
		if(preg_match('/opera ([0-9].[0-9]{1,2})/i',$this->user_agent,$log_version)){
			$this->browser['parent']= 'OP';
		}
		elseif(preg_match('/msie ([0-9].[0-9]{1,2})/i',$this->user_agent,$log_version)){
			$this->browser['parent']= 'IE';
		}
		elseif(preg_match('/netscape6[\/\sa-z]*([0-9].[0-9]{1,2})/i',$this->user_agent,$log_version)){
			$this->browser['parent']= 'NS';
		}
		elseif(preg_match('/netscape[\/\sa-z]*([0-9].[0-9]{1,2})/i',$this->user_agent,$log_version)){
			$this->browser['parent']= 'NS';
		}
		elseif(preg_match('/firefox[\/\sa-z]*([0-9].[0-9]{1,2})/i',$this->user_agent,$log_version)){
			$this->browser['parent']= 'FOX';
		}
		elseif(preg_match('/firebird[\/\sa-z]*([0-9].[0-9]{1,2})/i',$this->user_agent,$log_version)){
			$this->browser['parent']= 'FOX';
		}
		elseif(preg_match('/camino[\/\sa-z]*([0-9].[0-9]{1,2})/i',$this->user_agent,$log_version)){
			$this->browser['parent']= 'CAM';
		}
		elseif(preg_match('/mozilla/i', $this->user_agent) && preg_match('/rv:([0-9].[0-9]{1,2})/i', $this->user_agent, $log_version)){
			$this->browser['parent']= 'MOZ';
		}
		elseif(preg_match('/gecko/i', $this->user_agent)){
			$this->browser['parent']= 'MOZ';
		}
		elseif(preg_match($regex_crawler, $this->user_agent)){
			$this->browser['crawler']= 1;
			$this->browser['parent']= 'other';
		}else{
			$this->browser['parent']= 'other';
			$this->browser['javascript']=0;
			$this->browser['activexcontrols']=0;
		}
		$ver= explode(".",$log_version[1]);
		$this->browser['majorver']= $ver[0];
		$this->browser['minorver']= $ver[1];
	}


}
?>