<?php
//error_reporting(E_ALL);
##############################################################################
#                                                                            #
#      This file is part of IXPRIM CMS - Content Management System           #
#                       <http:#www.ixprim-cms.org/>                          #
#                                                                            #
#   Copyright (c) 2006 Christophe Deltheil <aka trollix> and contributors.   #
#                      All rights reserved.                                  #
# -------------------------------------------------------------------------- #
# ideas come from :                                                          #
# POSTNUKE Web Portal System - http://postnuke.org/                          #
# XOOPS Web Portal System - http://xoops.org/                                #
# myPHPNUKE Web Portal System - http://myphpnuke.com/                        #
# PHP-NUKE Web Portal System - http://phpnuke.org/                           #
# Thatware - http://thatware.org/                                            #
# dotclear Blog System - http://dotclear.net/                                #
# -------------------------------------------------------------------------- #
#  Ixprim CMS is free software; you can redistribute it and/or modify        #
#  it under the terms of the GNU General Public License as published by      #
#  the Free Software Foundation; either version 2 of the License, or         #
#  (at your option) any later version.                                       #
#                                                                            #
#  Ixprim CMS is distributed in the hope that it will be useful,             #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of            #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
#  GNU General Public License for more details.                              #
#                                                                            #
#  You should have received a copy of the GNU General Public License         #
#  along with this program; if not, write to the Free Software               #
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA  #
##############################################################################
#                                                                            #
#  This class is a new class where ideas and piece of code come from GPL     #
#  of these 2 scripts:                                                       #
#                                                                            #
#	Securimage 0.3 - Portable Security Image Script                          #
#   Author: Drew Phillips - www.neoprogrammers.com                           #
#   Copyright 2005 Drew Phillips                                             #
#   http://www.hotscripts.com/rate/49400.html  Thanks.                       #
#                                                                            #
#   PHP-Class hn_captcha Version 1.2, released 16-Apr-2004                   #
#   Author: Horst Nogajski, horst@nogajski.de                                #
#   Download: http://hn273.users.phpclasses.org/browse/package/1569.html     #
#                                                                            #
##############################################################################

class ixpCatpcha {


	/**
      * @shortdesc width of security image
	  * @type integer
	  * @public
      *
      **/
	var $image_width = 120;

	/**
      * @shortdesc height of security image
	  * @type integer
	  * @public
      *
      **/
	var $image_height = 30;

	/**
      * @shortdesc how many letters in the code
	  * @type integer
	  * @public
      *
      **/
	var $code_length = 5;

	/**
      * @shortdesc ttf font to use
	  * @type integer
	  * @public
      *
      **/
	var $ttf_file = "DENMARK.TTF";

	/**
      * @shortdesc path to ttf font to use
	  * @type integer
	  * @public
      *
      **/
	var $ttf_file_path;


	/**
      * @shortdesc size of the font
	  * @type integer
	  * @public
      *
      **/
	var $font_size = 12;


  var $text_angle_minimum = -30;
  //minimum angle in degress of letter. counter-clockwise direction

  var $text_angle_maximum = 30;
  //maximum angle in degrees of letter. clockwise direction

  var $text_x_start = 9;
  //position (in pixels) on the x axis where text starts

  var $text_minimum_distance = 15;
  //the shortest distance in pixels letters can be from eachother (a very small value will cause overlapping)

  var $text_maximum_distance = 25;
  //the longest distance in pixels letters can be from eachother

  var $image_bg_color = array("red" => 255, "green" => 255, "blue" => 255);
  //images background color.  set each red, green, and blue to a 0-255 value

  var $text_color = array("red" => 128, "green" => 128, "blue" => 255);
  //the color of the text

  var $shadow_text = true;
  //draw a shadow for the text (gives a 3d raised bolder effect)

  var $use_transparent_text = true;
  //true for the ability to use transparent text, false for normal text

  var $text_transparency_percentage = 30;	// 30 si fonts, 60 pour lines
  //0 to 100, 0 being completely opaque, 100 being completely transparent

  var $type_draw = 'fonts';		// 'lines' OR 'fonts'

  //set to true to draw horizontal and vertical lines on the image
  //the following 3 options will have no effect if this is set to false

  var $line_color = array("red" => 204, "green" =>204, "blue" => 255);
  //color of the horizontal and vertical lines through the image

  var $line_distance = 12;
  //distance in pixels the lines will be from eachother.
  //the smaller the value, the more "cramped" the lines will be, potentially making
  //the text harder to read for people

  var $draw_angled_lines = TRUE;
  //set to true to draw lines at 45 and -45 degree angles over the image  (makes x's)

  var $draw_lines_over_text = false;
  //set to true to draw the lines on top of the text, otherwise the text will be on the lines

  var $data_directory = "./image_data";
  //path of directory to store code data in.  make sure this is either outside of the webroot or unreadable

  var $prune_minimum_age = 10;
  //age (in minutes) of files containing unused codes to be deleted

  var $hash_salt = "fg7hg3yg3fd90oi4i";
  //set this to a unique string, this prevents users guessing filenames and make data more secure

 
  //END USER CONFIGURATION
  //There should be no need to edit below unless you really know what you are doing



  var $im;
  var $code;
  var $code_entered;
  var $correct_code;  
  var $image_cache_root_web;
  var $public_key;
  var $prefix_cache = 'captcha_';


		/** @private **/
		var $r;
		/** @private **/
		var $g;
		/** @private **/
		var $b;
		var $minsize	= 20;
		var $maxsize	= 40;
		/** @private **/
		var $nb_noise ;			// number of background-noise-characters
		var $noise		= TRUE;
		var $noisefactor = 15;	// this will multiplyed with number of chars

	////////////////////////////////
	//
	//	CONSTRUCTOR
	//

	/**
	  * @shortdesc Initialisation des paramtres
	  * @private
	  * @type void
	  * @return nothing
	  *
	  **/

	function ixpCatpcha() {
	
		$this->r = $this->image_bg_color['red'];
		$this->b = $this->image_bg_color['blue'];
		$this->g = $this->image_bg_color['green'];
		$this->nb_noise = 9;

		$this->ttf_file_path = IXP_ROOT_PATH.'/images/fonts';
		$this->ttf_file = $this->ttf_file_path.'/'.$this->ttf_file;
		$this->data_directory = IXP_ROOT_PATH_CACHE;
		$this->image_cache_root_web = IXP_ROOT_WEB.'/cache';
		
		$this->public_key = substr(md5($this->hash_salt . $_SERVER['REMOTE_ADDR'].floor((time()/20))), 0, $this->code_length);
	
	}


	/**
	  * @shortdesc Affiche l'image en raw
	  * @private
	  * @type void
	  * @return nothing
	  *
	  **/
	
	function show() {
		$this->doImage();
		$this->output();
	}

	function make_image() {
		$this->doImage();
		$this->output_to_file();
	}

  function prune()
  {
    $this->pruneOld();
  }

  function check($code, $p_prune=false)
  {
    $this->code_entered = $code;
    $this->validate($p_prune);
    return $this->correct_code;
  }

  function doImage()
  {

    //$this->random_color(160, 224);

    if($this->use_transparent_text == TRUE) {
      $this->im = imagecreatetruecolor($this->image_width, $this->image_height);
      $bgcolor = imagecolorallocate($this->im, $this->r, $this->g, $this->b);
      imagefilledrectangle($this->im, 0, 0, imagesx($this->im), imagesy($this->im), $bgcolor);
    } else { //no transparency
      $this->im = imagecreate($this->image_width, $this->image_height);
      $bgcolor = imagecolorallocate($this->im, $this->r, $this->g, $this->b);
    }

	// allocates the 216 websafe color palette to the image
	//if($this->gd_version < 2 || $this->websafecolors) 
	$this->makeWebsafeColors($this->im);


    $this->code = $this->generateCode($this->code_length);

	if (!$this->draw_lines_over_text) {
		if ($this->type_draw=='fonts') {
			$this->drawFonts();
		} elseif (!$this->draw_lines_over_text) {
			$this->drawLines();
		}
    }

    $this->drawWord();
    
    
	if ($this->draw_lines_over_text) {
		if ($this->type_draw=='fonts') {
			$this->drawFonts();
		} elseif ($this->draw_lines_over_text) {
			$this->drawLines();
		}
	}


    $this->saveData();

  }


  function drawLines()
  {
    $linecolor = imagecolorallocate($this->im, $this->line_color['red'], $this->line_color['green'], $this->line_color['blue']);

    //vertical lines
    for($x = 1; $x < $this->image_width; $x += $this->line_distance) {
      imageline($this->im, $x, 0, $x, $this->image_height, $linecolor);
    }

    //horizontal lines
    for($y = 11; $y < $this->image_height; $y += $this->line_distance) {
      imageline($this->im, 0, $y, $this->image_width, $y, $linecolor);
    }

    if ($this->draw_angled_lines == TRUE) {
      for ($x = -($this->image_height); $x < $this->image_width; $x += $this->line_distance) {
        imageline($this->im, $x, 0, $x + $this->image_height, $this->image_height, $linecolor);
      }

      for ($x = $this->image_width + $this->image_height; $x > 0; $x -= $this->line_distance) {
        imageline($this->im, $x, 0, $x - $this->image_height, $this->image_height, $linecolor);
      }
    }
  }


	function drawFonts() {
		

			// Set Backgroundcolor
			$this->random_color(224, 255, $this->r, $this->g, $this->b);
			$back =  @imagecolorallocate($this->im, $this->r, $this->g, $this->b);
			@ImageFilledRectangle($this->im,0,0,$this->image_width,$this->image_height,$back);


		for($i=0; $i < $this->nb_noise; $i++) {

			srand((double)microtime()*1000000);
			$size	= intval(rand((int)($this->minsize / 2.3), (int)($this->maxsize / 1.7)));
			srand((double)microtime()*1000000);
			$angle	= intval(rand(0, 360));
			srand((double)microtime()*1000000);
			$x		= intval(rand(0, $this->image_width));
			srand((double)microtime()*1000000);
			$y		= intval(rand(0, (int)($this->image_height - ($size / 5))));
			$this->random_color(160, 224, $this->r, $this->g, $this->b);
			$color	= imagecolorallocate($this->im, $this->r, $this->g, $this->b);
			srand((double)microtime()*1000000);
			$text	= chr(intval(rand(45,250)));
			@ImageTTFText($this->im, $size, $angle, $x, $y, $color, $this->ttf_file, $text);
		}

	}

	// Dessine le mot alatoire
	function drawWord() {
		
		$x = $this->text_x_start;
		$strlen = strlen($this->code);
		$y_min = ($this->image_height / 2) + ($this->font_size / 2) - 2;
		$y_max = ($this->image_height / 2) + ($this->font_size / 2) + 2;
    
		for($i = 0; $i < $strlen; ++$i) {



		$this->random_color(0, 127, $this->text_color['red'], $this->text_color['green'], $this->text_color['blue']);

		if($this->use_transparent_text == TRUE) {
			
			$alpha = floor($this->text_transparency_percentage / 100 * 127);
			$font_color = imagecolorallocatealpha($this->im, $this->text_color['red'], $this->text_color['green'], $this->text_color['blue'], $alpha);
		} else {	//no transparency
			$font_color = imagecolorallocate($this->im, $this->text_color['red'], $this->text_color['green'], $this->text_color['blue']);
		}



			$angle = rand($this->text_angle_minimum, $this->text_angle_maximum);
			$y = rand($y_min, $y_max);
			imagettftext($this->im, $this->font_size, $angle, $x, $y, $font_color, $this->ttf_file, $this->code{$i});
			if($this->shadow_text == TRUE) {
				imagettftext($this->im, $this->font_size, $angle, $x + 1, $y + 1, $font_color, $this->ttf_file, $this->code{$i});
			}
			$x += rand($this->text_minimum_distance, $this->text_maximum_distance);
		}

	}



  function generateCode($len)
  {
    $code = "";
    for($i = 1; $i <= $len; ++$i) {
      $code .= chr(rand(65, 90));
    }
    return $code;
  }


	/** @private **/
	function output() {
		header("Content-Type: image/jpeg");
		imagejpeg($this->im);
		imagedestroy($this->im);
	}

	/** @private **/
	function output_to_file() {
		if (!file_exists($this->get_filename_root_path())) {
			@imagejpeg($this->im, $this->get_filename_root_path());
			imagedestroy($this->im);
		}
	}

	/** @private **/
	function get_filename_root_path($public="") {
		if($public=="") {
			$public = $this->public_key;
		}
		return $this->data_directory.'/'.$this->prefix_cache.$public.".jpg";
	}

	function get_filename_root_web($public="") {
		if($public=="") {
			$public = $this->public_key;
		}
		return $this->image_cache_root_web.'/'.$this->prefix_cache.$public.".jpg";
	}


  function saveData()
  {
    $filename = md5($this->hash_salt . $_SERVER['REMOTE_ADDR']);
    $fp = fopen($this->data_directory . "/" . $filename, "w+");
    fwrite($fp, md5( $this->hash_salt . strtolower($this->code) )  );
    fclose($fp);
  }

	function validate($p_prune=false) {

		$filename = md5($this->hash_salt . $_SERVER['REMOTE_ADDR']);
		$enced_code = trim(@file_get_contents($this->data_directory . "/" . $filename));
		$check = md5($this->hash_salt . strtolower($this->code_entered));

		if($check == $enced_code) {
			$this->correct_code = TRUE;
			@unlink($this->data_directory . "/" . $filename);
			if ($p_prune) {
				$this->pruneOld();
			}
		} else {
			$this->correct_code = FALSE;
		}
	}


	function checkCode() {
		return $this->correct_code;
	}

	function pruneOld() {

		if ($handle = @opendir($this->data_directory)) {
			while ((($filename = readdir($handle)) !== false)) {
				if(time() - filemtime($this->data_directory . "/" . $filename) > $this->prune_minimum_age * 60) {
					if (strstr($filename, $this->prefix_cache)) {
						@unlink($this->data_directory . "/" . $filename);
					}
				} 
			}
			closedir($handle);
		}
		
	}


		/** @private **/
		function makeWebsafeColors(&$image)
		{
			//$a = array();
			for($r = 0; $r <= 255; $r += 51)
			{
				for($g = 0; $g <= 255; $g += 51)
				{
					for($b = 0; $b <= 255; $b += 51)
					{
						$color = imagecolorallocate($image, $r, $g, $b);
						//$a[$color] = array('r'=>$r,'g'=>$g,'b'=>$b);
					}
				}
			}
			//return $a;
		}


		/** @private **/
		function random_color($min,$max, &$red, &$green, &$blue)
		{
			srand((double)microtime() * 1000000);
			$red = intval(rand($min,$max));
			srand((double)microtime() * 1000000);
			$green = intval(rand($min,$max));
			srand((double)microtime() * 1000000);
			$blue = intval(rand($min,$max));
			//echo " (".$this->r."-".$this->g."-".$this->b.") ";
		}


	function realimage() {

	}

} //end class

?>