<?php
//error_reporting(E_ALL);
##############################################################################
#                                                                            #
#      This file is part of IXPRIM CMS - Content Management System           #
#                       <http:#www.ixprim-cms.org/>                          #
#                                                                            #
#   Copyright (c) 2006 Christophe Deltheil <aka trollix> and contributors.   #
#                      All rights reserved.                                  #
# -------------------------------------------------------------------------- #
# ideas come from :                                                          #
# POSTNUKE Web Portal System - http://postnuke.org/                          #
# XOOPS Web Portal System - http://xoops.org/                                #
# myPHPNUKE Web Portal System - http://myphpnuke.com/                        #
# PHP-NUKE Web Portal System - http://phpnuke.org/                           #
# Thatware - http://thatware.org/                                            #
# dotclear Blog System - http://dotclear.net/                                #
# -------------------------------------------------------------------------- #
#  Ixprim CMS is free software; you can redistribute it and/or modify        #
#  it under the terms of the GNU General Public License as published by      #
#  the Free Software Foundation; either version 2 of the License, or         #
#  (at your option) any later version.                                       #
#                                                                            #
#  Ixprim CMS is distributed in the hope that it will be useful,             #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of            #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
#  GNU General Public License for more details.                              #
#                                                                            #
#  You should have received a copy of the GNU General Public License         #
#  along with this program; if not, write to the Free Software               #
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA  #
##############################################################################
// Author of File: 							     //
// Kazumi Ono (http://www.mywebaddons.com/ , http://www.myweb.ne.jp/)        //
// ------------------------------------------------------------------------- //
class ixpFormCheckBox extends ixpFormElement 
{

	// private
	var $options = array();

	// private
	// pre-selected values in array
	var $value = array();
	var $disabled = false;

	// public
	function ixpFormCheckBox($caption, $name, $value="")
	{
		$this->setCaption($caption);
		$this->setName($name);
		if ( $value != "" ) 
		{
			if ( is_array($value) ) {
				foreach ( $value as $v ) {
					$this->value[] = $v;
				}
			} else {
				$this->value[] = $value;
			}
		}
	}

	// public
	function getValue(){
		return $this->value;
	}

	// public
	function addOption($value, $name="")
	{
		if ( $name != "" ) 
		{
			$this->options[$value] = $name.'<br />';
		} 
		else 
		{
			$this->options[$value] = $value.'<br />';
		}
	}

	// public
	function addOptionArray($arr)
	{
		if ( is_array($arr) ) 
		{
			foreach ( $arr as $k=>$v ) 
			{
				$this->addOption($k, $v);
			}
		}
	}

	// public
	function getOptions(){
		return $this->options;
	}

	// public
	function setDisabled(){
		return $this->disabled=true;
	}

	// public
	function render()
	{
		$ret = '';
		if ( count($this->getOptions()) > 1 && substr($this->getName(), -2, 2) != '[]' ) 
		{
			$newname = $this->getName().'[]';
			$this->setName($newname);
		}
		foreach ( $this->getOptions() as $value => $name ) 
		{
			$ret .= '<input type="checkbox" name="'.$this->getName().'" id="'.$this->getName().'" value="'.$value.'"';
			$count = count($this->getValue());
			if ( $count > 0 && in_array($value, $this->getValue()) ) {
				$ret .= ' checked="checked"';
			}
			if ($this->disabled) {
				$ret .= ' disabled';
			}
			$ret .= $this->getExtra().' />&nbsp;'.$name;
		}
		return $ret;
	}
}
?>