<?php
//error_reporting(E_ALL);
##############################################################################
#                                                                            #
#      This file is part of IXPRIM CMS - Content Management System           #
#                       <http:#www.ixprim-cms.org/>                          #
#                                                                            #
#   Copyright (c) 2006 Christophe Deltheil <aka trollix> and contributors.   #
#                      All rights reserved.                                  #
# -------------------------------------------------------------------------- #
# ideas come from :                                                          #
# POSTNUKE Web Portal System - http://postnuke.org/                          #
# XOOPS Web Portal System - http://xoops.org/                                #
# myPHPNUKE Web Portal System - http://myphpnuke.com/                        #
# PHP-NUKE Web Portal System - http://phpnuke.org/                           #
# Thatware - http://thatware.org/                                            #
# dotclear Blog System - http://dotclear.net/                                #
# -------------------------------------------------------------------------- #
#  Ixprim CMS is free software; you can redistribute it and/or modify        #
#  it under the terms of the GNU General Public License as published by      #
#  the Free Software Foundation; either version 2 of the License, or         #
#  (at your option) any later version.                                       #
#                                                                            #
#  Ixprim CMS is distributed in the hope that it will be useful,             #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of            #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
#  GNU General Public License for more details.                              #
#                                                                            #
#  You should have received a copy of the GNU General Public License         #
#  along with this program; if not, write to the Free Software               #
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA  #
##############################################################################
class ixpFormSelect extends ixpFormElement {

	// private
	var $options = array();

	// private
	var $multiple = false;

	// private
	var $size;

	// private
	// pre-selected values in array
	var $value = array();

	// public
	function ixpFormSelect($caption, $name, $value="", $size=1, $multiple=false)
	{
		$this->setCaption($caption);
		$this->setName($name);
		$this->multiple = $multiple;
		$this->size = intval($size);
		if ( $value != "" || $value == 0 ) // fixed by littleboy
		{
			if ( is_array($value) ) {
				foreach ( $value as $v ) {
					$this->value[] = $v;
				}
			} else {
				$this->value[] = $value;
			}
		}
	}

	// public
	function isMultiple(){
		return $this->multiple;
	}

	// public
	function getSize(){
		return $this->size;
	}

	// public
	function getValue(){
		return $this->value;
	}

	// public
	function addOption($value, $name=""){
		if ( $name != "" ) {
			$this->options[$value] = $name;
		} else {
			$this->options[$value] = $value;
		}
	}

	// public crer un select avec value,value
	function addOptionArray($arr){
		if ( is_array($arr) ) {
			foreach ( $arr as $k=>$v ) {
				$this->addOption($k, $v);
			}
		}
	}

	// public crer un select avec value,value aulieude key,value
	function addOptionArrayValueValue($arr){
		if ( is_array($arr) ) {
			foreach ( $arr as $k=>$v ) {
				$this->addOption($v, $v);
			}
		}
	}


	// public
	function getOptions(){
		return $this->options;
	}

	// public
	function render(){
		$ret = "<select ".$this->getDisabled()." size='".$this->getSize()."'".$this->getExtra()."";
		if ( $this->isMultiple() != false ) {
			$ret .= " name='".$this->getName()."[]' id='".$this->getName()."[]' multiple='multiple'>\n";
		} else {
			$ret .= " name='".$this->getName()."' id='".$this->getName()."'>\n";
		}
		foreach ( $this->getOptions() as $value => $name ) {
            if (!strstr($value, '_optgroup_')) {
                $ret .= "<option value='".htmlspecialchars($value, ENT_QUOTES)."'";
			    $count = count($this->getValue());
			    if ( $count > 0 && in_array($value, $this->getValue()) ) {
					$ret .= " selected='selected'";
			    }
			    $ret .= ">".$name."</option>\n";
            } else {
                $ret .= '<optgroup label="'.$name.'">';
            }
		}
		$ret .= "</select>";
		return $ret;
	}
}

class ixpFormSelectSubmit extends ixpFormElement {

	// private
	var $options = array();

	// private
	var $multiple = false;

	// private
	var $size;

	// private
	// pre-selected values in array
	var $value = array();

	// public
	function ixpFormSelectSubmit($caption, $name, $value="", $size=1, $multiple=false){
		$this->setCaption($caption);
		$this->setName($name);
		$this->multiple = $multiple;
		$this->size = intval($size);
		if ( $value != "" ) {
			if ( is_array($value) ) {
				foreach ( $value as $v ) {
					$this->value[] = $v;
				}
			} else {
				$this->value[] = $value;
			}
		}
	}

	// public
	function isMultiple(){
		return $this->multiple;
	}

	// public
	function getSize(){
		return $this->size;
	}

	// public
	function getValue(){
		return $this->value;
	}

	// public
	function addOption($value, $name=""){
		if ( $name != "" ) {
			$this->options[$value] = $name;
		} else {
			$this->options[$value] = $value;
		}
	}

	// public
	function addOptionArray($arr){
		if ( is_array($arr) ) {
			foreach ( $arr as $k=>$v ) {
				$this->addOption($k, $v);
			}
		}
	}

	// public
	function getOptions(){
		return $this->options;
	}

	// public
	function render(){
		$ret = "<select ".$this->getDisabled()." size='".$this->getSize()."'".$this->getExtra()."";
		if ( $this->isMultiple() != false ) {
			$ret .= " name='".$this->getName()."[]' id='".$this->getName()."[]' multiple='multiple'";
		} else {
			$ret .= " name='".$this->getName()."' id='".$this->getName()."'";
		}
		$ret .= " onChange=\"this.form.submit()\">\n";
		foreach ( $this->getOptions() as $value => $name ) {
			$ret .= "<option value='".htmlspecialchars($value, ENT_QUOTES)."'";
			$count = count($this->getValue());
			if ( $count > 0 && in_array($value, $this->getValue()) ) {
					$ret .= " selected='selected'";
			}
			$ret .= ">".$name."</option>\n";
		}
		$ret .= "</select>";
		return $ret;
	}
}

class ixpFormSelectDisplayText extends ixpFormSelect {

	var $displayText='';

	// public
	function ixpFormSelectDisplayText($caption, $name, $value="", $size=1, $multiple=false){
		$this->setCaption($caption);
		$this->setName($name);
		$this->multiple = $multiple;
		$this->size = intval($size);
		if ( $value != "" ) {
			if ( is_array($value) ) {
				foreach ( $value as $v ) {
					$this->value[] = $v;
				}
			} else {
				$this->value[] = $value;
			}
		}
	}

	// public
	function setDisplayText($text){
		$this->displayText = $text;
	}

	// public
	function render(){

		$ret = '';

		if (!empty($this->displayText)) {
			
			$tab = $this->displayText;
			$ret .= "<script>\n"
					."var tableau=[];\n";
			$i=0;
			foreach( $tab as $value ) {
				$ret .= 'tableau['.$i++.']="'.$value.'";'."\n";
			}

			$ret .= "function show_text_selected(selectId, divId) {\n"
					."selectDom = ixpGetElementById(selectId);\n"
					."divDom = ixpGetElementById(divId);\n"
					."divDom.innerHTML=tableau[selectDom.selectedIndex];\n"
					."}\n";

			$ret .= "</script>\n";
		}
			
		$ret .= "<select ".$this->getDisabled()." size='".$this->getSize()."'".$this->getExtra()."";
		if ( $this->isMultiple() != false ) {
			$ret .= " name='".$this->getName()."[]' id='".$this->getName()."[]' multiple='multiple'";
		} else {
			$ret .= " name='".$this->getName()."' id='".$this->getName()."'";
		}
		if (empty($this->displayText)) {
			$ret .= ">\n";
		} else {
			$tab = $this->displayText;
			$ret .= " onChange=\"show_text_selected('".$this->getName()."', 'selectdisplaytext')\">\n";
		}

		foreach ( $this->getOptions() as $value => $name ) {
			$ret .= "<option value='".htmlspecialchars($value, ENT_QUOTES)."'";
			$count = count($this->getValue());
			if ( $count > 0 && in_array($value, $this->getValue()) ) {
					$ret .= " selected='selected'";
			}
			$ret .= ">".$name."</option>\n";
		}
		$ret .= "</select>";
		return $ret;
	}
}
?>