<?php
//error_reporting(E_ALL);
##############################################################################
#                                                                            #
#      This file is part of IXPRIM CMS - Content Management System           #
#                       <http:#www.ixprim-cms.org/>                          #
#                                                                            #
#   Copyright (c) 2006 Christophe Deltheil <aka trollix> and contributors.   #
#                      All rights reserved.                                  #
# -------------------------------------------------------------------------- #
# ideas come from :                                                          #
# POSTNUKE Web Portal System - http://postnuke.org/                          #
# XOOPS Web Portal System - http://xoops.org/                                #
# myPHPNUKE Web Portal System - http://myphpnuke.com/                        #
# PHP-NUKE Web Portal System - http://phpnuke.org/                           #
# Thatware - http://thatware.org/                                            #
# dotclear Blog System - http://dotclear.net/                                #
# -------------------------------------------------------------------------- #
#  Ixprim CMS is free software; you can redistribute it and/or modify        #
#  it under the terms of the GNU General Public License as published by      #
#  the Free Software Foundation; either version 2 of the License, or         #
#  (at your option) any later version.                                       #
#                                                                            #
#  Ixprim CMS is distributed in the hope that it will be useful,             #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of            #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
#  GNU General Public License for more details.                              #
#                                                                            #
#  You should have received a copy of the GNU General Public License         #
#  along with this program; if not, write to the Free Software               #
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA  #
##############################################################################

class ixpGForm
{

	//-----------------------------------------------------------------------
	// form() : display form
	//-----------------------------------------------------------------------
    function form($p_action, $p_method='post', $p_id='', $p_name='', $p_class='') {

        $l_res = '<form action="'.$p_action.'" ';
        $l_res .= 'method="'.$p_method.'" ';

		if($p_id != '') {
			$l_res .= 'class="'.$p_id.'" ';
		}

		if($p_name != '') {
			$l_res .= 'id="'.$p_name.'" ';
		} else {
			$l_res .= 'id="'.$p_id.'" ';
		}

		if($p_class != '') {
			$l_res .= 'class="'.$p_class.'" ';
		}

		$l_res .= ">\n";
		
		return $l_res;
    }


	//-----------------------------------------------------------------------
	// form() : display form
	//-----------------------------------------------------------------------
    function form_wysiwyg($p_action, $p_method='post', $p_id='', $p_name='', $p_class='') {

        switch (IXPGLOBAL___typewysiwygeditor) {
            case 'tinymce': $value = 'wysiwyg'; break;
            case 'spaw': $value = 'wysiwyg'; break;
            case 'fckeditor': $value = 'wysiwyg'; break;
            case 'koivi': $value = 'wysiwyg'; break;
            case 'htmlarea': $value = 'wysiwyg'; break;
            case 'wpro': $value = 'wysiwyg'; break;
            default: $value = 'textarea'; break;
        }

        $l_res = ixpGForm::form($p_action, $p_method, $p_id, $p_name, $p_class);
        $l_res .= "\n";
		$l_res .= ixpGForm::hidden('post_editor', $value);
        $l_res .= "\n";
		
		return $l_res;
    }


	//-----------------------------------------------------------------------
	// combobox() : display combobox
	//-----------------------------------------------------------------------
	function combobox($p_name, $p_tabdata, $p_default='', $p_class='', $p_id='', $p_tabindex='')
	{
		$l_res = '<select name="'.$p_name.'" ';
		
		if($p_class != '') {
			$l_res .= 'class="'.$p_class.'" ';
		}

		if($p_tabindex != '') {
			$l_res .= 'tabindex="'.$p_tabindex.'" ';
		}

		if($p_id != '') {
			$l_res .= 'id="'.$p_id.'" ';
		} else {
			$l_res .= 'id="'.$p_name.'" ';
		}
		
		$l_res .= '>'."\n";
		
		foreach($p_tabdata as $k => $v) {
			$l_res .= '<option value="'.$v.'"';
			if($v == $p_default) {
				$l_res .= ' selected="selected"';
			}
			$l_res .= '>'.$k.'</option>'."\n";
		}
		
		$l_res .= '</select>'."\n";
		
		return $l_res;
	}
	
	//-----------------------------------------------------------------------
	// input() : display input
	//-----------------------------------------------------------------------
	function input_text($p_id, $p_name, $p_size, $p_max, $p_value='', $p_class='', $p_tabindex='', $p_html='')
	{
		$l_res = '<input type="text" ';
		$l_res .= ($p_class != '')		? 'class="'.$p_class.'" ' : '';
		$l_res .= 'size="'.$p_size.'" name="'.$p_name.'" id="'.$p_id.'" ';
		$l_res .= ($p_max != '')		? 'maxlength="'.$p_max.'" ' : '';
		$l_res .= ($p_tabindex != '')	? 'tabindex="'.$p_tabindex.'" ' : '';
		$l_res .= ($p_value != '')		? 'value="'.$p_value.'" ' : '';
		
		$l_res .= $p_html;
		
		$l_res .= ' />';
		
		return $l_res;
	}
	
	//-----------------------------------------------------------------------
	// input() : display input
	//-----------------------------------------------------------------------
	function input_submit($p_value, $p_id='', $p_onclick='', $p_class='')
	{
		$l_res = '<input type="submit" ';
		$l_res .= ($p_id != '')		? 'id="'.$p_id.'" name="'.$p_id.'" ' : '';
		$l_res .= ($p_class != '')		? 'class="'.$p_class.'" ' : '';
		$l_res .= 'value="'.$p_value.'"';
		$l_res .= ($p_onclick != '')		? 'onclick="'.$p_onclick.'" ' : '';
		$l_res .= ' />';
		
		return $l_res;
	}

	//-----------------------------------------------------------------------
	// input() : display input
	//-----------------------------------------------------------------------
	function input_button($p_value, $p_id='', $p_onclick='', $p_class='')
	{
		$l_res = '<input type="button" ';
		$l_res .= ($p_id != '')		? 'id="'.$p_id.'" ' : '';
		$l_res .= ($p_class != '')		? 'class="'.$p_class.'" ' : '';
		$l_res .= 'value="'.$p_value.'"';
		$l_res .= ($p_onclick != '')		? 'onclick="'.$p_onclick.'" ' : '';
		$l_res .= ' />';
		
		return $l_res;
	}

	//-----------------------------------------------------------------------
	// input() : display input checkbox
	//-----------------------------------------------------------------------
	function input_checkbox($p_value, $p_id='', $p_onclick='', $p_class='')
	{
		$l_res = '<input type="checkbox" ';
		$l_res .= ($p_id != '')		? 'id="'.$p_id.'" name="'.$p_id.'" ' : '';
		$l_res .= ($p_class != '')		? 'class="'.$p_class.'" ' : '';
		$l_res .= 'value="'.$p_value.'"';
		$l_res .= ($p_onclick != '')		? 'onclick="'.$p_onclick.'" ' : '';
		$l_res .= ' />';
		
		return $l_res;
	}

	//-----------------------------------------------------------------------
	// radio() : display input checkbox
	//-----------------------------------------------------------------------
	function input_radio($p_value, $p_id, $p_checked='', $p_class='')
	{
		$l_res = '<input type="radio" ';
		$l_res .= ($p_id != '')		? 'id="'.$p_id.'" name="'.$p_id.'" ' : '';
		$l_res .= ($p_class != '')	? 'class="'.$p_class.'" ' : '';
		$l_res .= (($p_checked === 0) or $p_checked >= 1)	?  '' : 'checked="checked" ';
		$l_res .= '/>'."\n";
		
		return $l_res;	
	}

	//-----------------------------------------------------------------------
	// textarea() : display textarea
	//-----------------------------------------------------------------------
	function textarea($p_id, $p_name, $p_cols, $p_rows, $p_value='', $p_tabindex='', $p_html='')
	{
		$l_res = '<textarea cols="'.$p_cols.'" rows="'.$p_rows.'" ';
		$l_res .= 'name="'.$p_name.'" id="'.$p_id.'" ';
		$l_res .= ($p_tabindex != '') ? 'tabindex="'.$p_tabindex.'" ' : '';
		$l_res .= $p_html.'>';
		$l_res .= $p_value;
		$l_res .= '</textarea>';
		
		return $l_res;
	}
	
	//-----------------------------------------------------------------------
	// hidden() : display hidden
	//-----------------------------------------------------------------------
	function hidden($p_name, $p_value) {
		return '<input type="hidden" name="'.$p_name.'" value="'.$p_value.'" />';
	}

	//-----------------------------------------------------------------------
	// field() : display field
	//-----------------------------------------------------------------------
	function field($p_id, $p_name, $p_size, $p_max, $p_default='', $p_tabindex='', $p_html='')
	{
		$res = '<input type="text" size="'.$p_size.'" name="'.$p_name.'" id="'.$p_id.'" ';
		
		$res .= ($p_max != '') ? 'maxlength="'.$p_max.'" ' : '';
		$res .= ($p_tabindex != '') ? 'tabindex="'.$p_tabindex.'" ' : '';
		$res .= ($p_default != '') ? 'value="'.$p_default.'" ' : '';
		$res .= $p_html;
		
		$res .= ' />';
		
		return $res;
	}

	//-----------------------------------------------------------------------
	// textarea() : display textarea
	//-----------------------------------------------------------------------
	function textarea_wysiwyg($p_name, $p_cols, $p_rows, $p_value='', $editor, $title='') {

        if (!is_array($p_name)) {

			switch ($editor) {
				case 'tinymce': 
					$fields = $p_name; 
					include(IXP_ROOT_PATH.'/kernel/plugins/tinymce/ixprim_api.php');
					echo $title;
					echo ixpGForm::textarea($p_name, $p_name, $p_cols, $p_rows, $p_value);
					break;
				case 'spaw': 
					$fields = $p_name; 
					include(IXP_ROOT_PATH.'/kernel/plugins/tinymce/ixprim_api.php');
					echo $title;
					echo ixpGForm::textarea($p_name, $p_name, $p_cols, $p_rows, $p_value);
					break;
				case 'fckeditor': 
				    echo $title;
				    $p_name_fck  = $p_name;
					$p_value_fck = $p_value;
					$p_width_fck = '100%';
					$p_height_fck = '400';
					include(IXP_ROOT_PATH.'/kernel/plugins/fckeditor2/ixprim_api.php');
					
					break;
				default: //case 'toolbarjs': 
					$fields = $p_name; 
					include(IXP_ROOT_PATH.'/kernel/plugins/jseditor/ixprim_api.php');
					echo $title;
					echo ixpGForm::textarea($p_name, $p_name, $p_cols, $p_rows, $p_value);
					echo toolbar($p_name);
					break;
			}

                  
		
        } else {
        
            switch ($editor) {

				//------------------------------------------------------------
				// TinyMCE
				//------------------------------------------------------------
                case 'tinymce': 
					$fields = 'hometext,bodytext';
					include(IXP_ROOT_PATH.'/kernel/plugins/tinymce/ixprim_api.php');
					echo $title[0];
					echo ixpGForm::textarea($p_name[0], $p_name[0], $p_cols[0], $p_rows[0], nl2null($p_value[0],' '));
					echo $title[1];
					echo ixpGForm::textarea($p_name[1], $p_name[1], $p_cols[1], $p_rows[1], nl2null($p_value[1], ' '));
					break;

				//------------------------------------------------------------
				// fckEditor
				//------------------------------------------------------------
                case 'fckeditor': 

				    echo $title[0];
					$p_name_fck  = $p_name[0];
					$p_value_fck = $p_value[0];
					$p_width_fck = '100%';
					$p_height_fck = '300';
					include(IXP_ROOT_PATH.'/kernel/plugins/fckeditor2/ixprim_api.php');

					echo $title[1];
					$p_name_fck  = $p_name[1];
					$p_value_fck = $p_value[1];
					$p_width_fck = '100%';
					$p_height_fck = '400';
					include(IXP_ROOT_PATH.'/kernel/plugins/fckeditor2/ixprim_api.php');

					break;


				//------------------------------------------------------------
				// SPAW
				//------------------------------------------------------------
                case 'spaw':
                    
					include(IXP_ROOT_PATH.'/kernel/plugins/spaw/ixprim_api.php');
 					
					// Hometext
					echo $title[0];
					echo '<p>';
					$sw = new SPAW_Wysiwyg(
						$p_name[0],             //name
						$p_value[0],            //value
						'fr',                   //language
						'full',                 //toolbar mode
						'',                     //theme
						'100%',                 //width
						'200',                  //height
						'',                     //stylesheet file
						$spaw_dropdown_data     //dropdown data*/
					);
					$sw->show();
					echo "</p>";

					// Bodytext
					echo $title[1];
					echo '<p>';
					$sw = new SPAW_Wysiwyg(
						$p_name[1],             //name
						$p_value[1],              //value
						'fr',                   //language
						'full',                 //toolbar mode
						'',                     //theme
						'100%',                 //width
						'200',                  //height
						'',                     //stylesheet file
						$spaw_dropdown_data    //dropdown data*/
					);
					$sw->show();
					echo "</p>";

					break;

				//------------------------------------------------------------
				// JSEDITOR
				//------------------------------------------------------------
                case 'toolbarjs': 

                    include(IXP_ROOT_PATH.'/kernel/plugins/jseditor/ixprim_api.php');
					
                    echo $title[0];
					echo ixpGForm::textarea($p_name[0], $p_name[0], $p_cols[0], $p_rows[0], br2nl($p_value[0],''));
					echo toolbar($p_name[0]);
					echo $title[1];
					echo ixpGForm::textarea($p_name[1], $p_name[1], $p_cols[1], $p_rows[1], br2nl($p_value[1],''));
					echo toolbar($p_name[1]);
					break;

				//------------------------------------------------------------
				// No editor
				//------------------------------------------------------------
                default:

                    echo $title[0];
					echo ixpGForm::textarea($p_name[0], $p_name[0], $p_cols[0], $p_rows[0], br2nl($p_value[0],''));
					echo $title[1];
					echo ixpGForm::textarea($p_name[1], $p_name[1], $p_cols[1], $p_rows[1], br2nl($p_value[1],''));
					break;

            }
                  

        }

	}

}
?>