<?php
//error_reporting(E_ALL);
##############################################################################
#                                                                            #
#      This file is part of IXPRIM CMS - Content Management System           #
#                       <http:#www.ixprim-cms.org/>                          #
#                                                                            #
#   Copyright (c) 2006 Christophe Deltheil <aka trollix> and contributors.   #
#                      All rights reserved.                                  #
# -------------------------------------------------------------------------- #
# ideas come from :                                                          #
# POSTNUKE Web Portal System - http://postnuke.org/                          #
# XOOPS Web Portal System - http://xoops.org/                                #
# myPHPNUKE Web Portal System - http://myphpnuke.com/                        #
# PHP-NUKE Web Portal System - http://phpnuke.org/                           #
# Thatware - http://thatware.org/                                            #
# dotclear Blog System - http://dotclear.net/                                #
# -------------------------------------------------------------------------- #
#  Ixprim CMS is free software; you can redistribute it and/or modify        #
#  it under the terms of the GNU General Public License as published by      #
#  the Free Software Foundation; either version 2 of the License, or         #
#  (at your option) any later version.                                       #
#                                                                            #
#  Ixprim CMS is distributed in the hope that it will be useful,             #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of            #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
#  GNU General Public License for more details.                              #
#                                                                            #
#  You should have received a copy of the GNU General Public License         #
#  along with this program; if not, write to the Free Software               #
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA  #
##############################################################################
include_once(IXP_ROOT_PATH."/kernel/class/ixpform/form.php");

class ixpTableForm extends ixpForm {

    var $style_td_left = 'test-align:right;font-weight:bold;';
    var $style_td_right = 'test-align:left;';
    var $class_td_left = 'tableformleft';
    var $class_td_right = 'tableformtdright';
    var $class_header = 'tableformheader';
    var $style_header = 'font-weight:bold;text-align:center;';

    var $class_table = 'tableform';
    var $style_table = 'width:97%;';

    var $class_tr = 'tableformtr';
    var $style_tr = 'vertical-align:top;';
    var $star = '&nbsp;<small>(*)</small>';

	function ixpTableForm($title, $name, $action, $method="post", $style='width:97%;', $class='tableform') {
		
        $this->ixpForm($title, $name, $action, $method);
        $this->setExtra("onsubmit='return ixpFormValidate_".$this->getName()."();'");
        $this->class_table = $style;
        $this->style_table = $class;
	}

	function render() {

        $required = $this->getRequired();

		$ret = $this->getTitle()."\n<form name='".$this->getName()."' id='".$this->getName()."' action='".$this->getAction()."' method='".$this->getMethod()."'".$this->getExtra()." style='padding:0;margin:0;'>\n"
        
        .'<table class="'.$this->class_table.'" style="'.$this->style_table.'">'."\n";
		
		foreach ( $this->getElements() as $ele ) {


            if (  array_key_exists($ele->getName(), $this->getRequired())  ) { 
                $star = $this->star;
            } else {
                $star = '';
            }

			if ( !$ele->isHidden() ) {


                if ( $ele->isHeader() ) {
                    $ret .= '<tr class="'.$this->class_tr.'" style="'.$this->style_tr.'">'
                    .'<td colspan="2" class="'.$this->class_header.'" style="'.$this->style_header.'">'.$ele->getCaption().$star.'</td>'
                    ."</tr>\n";
                } else {

				    $ret .= '<tr valign="top">'
                    .'<td class="'.$this->class_td_left.'" style="'.$this->style_td_left.'">'.$ele->getCaption().$star.'</td>'
                    .'<td class="'.$this->class_td_right.'" style="'.$this->style_td_right.'">'.$ele->render().'</td>'
                    ."</tr>\n";
                }

			} else {

				$ret .= $ele->render()."\n";
			}
		}

		

	  $js = "
	  	<script language='javascript'>
		<!--
		function ixpFormValidate_".$this->getName()."(){";
		foreach ( $required as $key => $value ) 
		{
			$js .= "if ( document.".$this->getName().".".$key.".value == \"\" ){alert( \"".sprintf(_FORM_ENTER, $value)."\" );document.".$this->getName().".".$key.".focus();return false;}";
		}
		$js .= "}
		//--->
		</script>";
		
		$ret .= "</table>\n</form>\n";
		$ret = $js.$ret;


		return $ret;
	}

    function set_style_td_left($value) {
        $this->style_td_left = $value;
    }

    function set_style_td_right($value) {
        $this->style_td_right = $value;
    }

    function set_class_td_left($value) {
        $this->class_td_left = $value;
    }

    function set_class_td_right($value) {
        $this->class_td_right = $value;
    }

    function set_class_header($value) {
        $this->class_header = $value;
    }

    function set_style_header($value) {
        $this->style_header = $value;
    }


    function set_class_table($value) {
        $this->class_table = $value;
    }

    function set_style_table($value) {
        $this->style_table = $value;
    }

    function set_class_tr($value) {
        $this->class_tr = $value;
    }

    function set_style_tr($value) {
        $this->style_tr = $value;
    }

    function set_star($value) {
        $this->star = $value;
    }

}
?>