<?php
//error_reporting(E_ALL);
##############################################################################
#                                                                            #
#      This file is part of IXPRIM CMS - Content Management System           #
#                       <http:#www.ixprim-cms.org/>                          #
#                                                                            #
#   Copyright (c) 2006 Christophe Deltheil <aka trollix> and contributors.   #
#                      All rights reserved.                                  #
# -------------------------------------------------------------------------- #
# ideas come from :                                                          #
# POSTNUKE Web Portal System - http://postnuke.org/                          #
# XOOPS Web Portal System - http://xoops.org/                                #
# myPHPNUKE Web Portal System - http://myphpnuke.com/                        #
# PHP-NUKE Web Portal System - http://phpnuke.org/                           #
# Thatware - http://thatware.org/                                            #
# dotclear Blog System - http://dotclear.net/                                #
# -------------------------------------------------------------------------- #
#  Ixprim CMS is free software; you can redistribute it and/or modify        #
#  it under the terms of the GNU General Public License as published by      #
#  the Free Software Foundation; either version 2 of the License, or         #
#  (at your option) any later version.                                       #
#                                                                            #
#  Ixprim CMS is distributed in the hope that it will be useful,             #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of            #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
#  GNU General Public License for more details.                              #
#                                                                            #
#  You should have received a copy of the GNU General Public License         #
#  along with this program; if not, write to the Free Software               #
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA  #
##############################################################################

class ixpModule
{

	var $db;
	var $mid;
	var $name;
	var $dirname;
	var $weight;
	var $isactive;
	var $hasadmin;
	var $hasmain;
	var $hassearch;
	var $haswaiting;
	var $install_time;
	var $hasuserconf;
	var $hasuserfields;
	var $installforall;
	var $modinfo2 = array();	# Tix: pour la traduction: pas de define charge
	var $modvars = array();
	var $errors = array();
	
	// these table cannot be installed nor uninstalled
	// this is a very dirty workaround...may need to find a better method
	var $reservedTables = array('badips', 'badunames', 'badwords', 'config', 'groups', 'groups_users_link', 'groups_modules_link', 'groups_blocks_link', 'metafooter', 'priv_msgs', 'ranks','session', 'smiles', 'users', 'users_lastseen' , 'users_more_config', 'ixpblocks', 'ixpblocks_themes', 'modules', 'registry' );
	
	function ixpModule($mid = -1, $xlanguage="french", $load=true)
	{
		global $ixpdb;

		$this->db =$ixpdb;
		if ($mid != -1) {
            if (is_array($mid) ) {
				$this->makeModule($mid);
			} else {
				$this->getModule(intval($mid));
			}
			
			if ( $load ) {
                if(!isset($GLOBALS['modinfo2'][$this->dirname][$xlanguage])) {  // Eviter plusieurs fois le chargement: qd plus. blocks par ex.
                    $this->loadModInfo2($this->dirname, $xlanguage); # Tix: Traduction
                    $GLOBALS['modinfo2'][$this->dirname][$xlanguage] =& $this->modinfo2;
                } else {
                    $this->modinfo2 =& $GLOBALS['modinfo2'][$this->dirname][$xlanguage];
                }
			}
		}
	}

	# ------------------------------------------------------------------------
	# Tix: comments
	# chargement du fichier contenant les infos du module: "modconf.php"
	# ------------------------------------------------------------------------
	function loadModInfo2($dirname, $language="french") 
	{
		global $myts;

		if ($dirname=='') {
            echo "dirname: < EMPTY > module Not Found!<br />";
            return;
		}

		//--------------------------------------------------------------------
		// Traiter modinfo.php ==> Charger $MI
		//--------------------------------------------------------------------
		// si modinfo_user de ma langue existe: le charger
		if(file_exists(IXP_ROOT_PATH.'/mod/'.$dirname.'/language/'.$language.'/modinfo_user.php')) {
		    include(IXP_ROOT_PATH.'/mod/'.$dirname.'/language/'.$language.'/modinfo_user.php');
		}

		// sinon si modinfo de ma langue existe: le charger
		elseif(file_exists(IXP_ROOT_PATH.'/mod/'.$dirname.'/language/'.$language.'/modinfo.php')) {
		    include(IXP_ROOT_PATH.'/mod/'.$dirname.'/language/'.$language.'/modinfo.php');
		} 

		// sinon si modinfo_user french existe: le charger
		elseif(file_exists(IXP_ROOT_PATH.'/mod/'.$dirname.'/language/french/modinfo_user.php')) {
		    include(IXP_ROOT_PATH.'/mod/'.$dirname.'/language/french/modinfo_user.php');
		}

		// sinon si modinfo french existe: le charger
		elseif(file_exists(IXP_ROOT_PATH.'/mod/'.$dirname.'/language/french/modinfo.php')) {
		    include(IXP_ROOT_PATH.'/mod/'.$dirname.'/language/french/modinfo.php');
		}

		else {
            echo "Module File (modinfo.php) for dirname: $dirname (language: $language) Not Found!<br />";
		    return;
		}

		//--------------------------------------------------------------------
		// Traiter modrewrite.php
		//--------------------------------------------------------------------
		//if ( IXP_ALLOW_MODREWRITE ) { // si mod_rewrite est actif
			
			if(file_exists(IXP_ROOT_PATH."/mod/".$dirname."/conf/modrewrite.php")) { 
			  include(IXP_ROOT_PATH."/mod/".$dirname."/conf/modrewrite.php");
			  $modversion['hasModRewrite'] = 1;
			} 
		//}

		//--------------------------------------------------------------------
		// Traiter modconf.php
		//--------------------------------------------------------------------
		if(file_exists(IXP_ROOT_PATH."/mod/".$dirname."/conf/modconf_user.php")) {
			include(IXP_ROOT_PATH."/mod/".$dirname."/conf/modconf_user.php");
		} elseif(file_exists(IXP_ROOT_PATH."/mod/".$dirname."/conf/modconf.php")) { # voir pkoi include_once marche ici et pas au dessus
			include(IXP_ROOT_PATH."/mod/".$dirname."/conf/modconf.php");
		} else {
			echo "Module File (modconf.php) for $dirname Not Found!";
			return;
		}
		
		$modversion['name'] = $myts->makeTboxData4PreviewInForm($MI['NAME']);
		$modversion['mainmenu'] = ($MI['MAINMENU']=='') ? $modversion['name'] : $myts->makeTboxData4PreviewInForm($MI['MAINMENU']);
		$modversion['description'] = $MI['DESC'];
		

		// Autorisation d'afficher ou non les sous-menus
		$ixp_ixpModuleConfig = $this->modconf();
		if ((isset($ixp_ixpModuleConfig['affsubmenus'])) && ($ixp_ixpModuleConfig['affsubmenus']==TRUE) ) {
		} else {
		    $modversion['sub']=array();
		}

		//print_r($MI);
		#print "lang: $language toto: ".$modversion['name']."<br />";
		#print "lang: $language toto: ".$modversion['sub'][1]['name']."<br />";
		//$tabmodversion[$dirname.$language] =  $modversion;
        //print_r($modversion);//print_r($modversion['blocks']);
		$this->modinfo2 = $modversion;
	}


	function getModule($mid) {	//Fonction uniquement appele ici: locale
	
	  if((!empty($GLOBALS['ixpModule_getModule'][$mid])) && (is_array($GLOBALS['ixpModule_getModule'][$mid] ))) {
	    $this->makeModule($GLOBALS['ixpModule_getModule'][$mid]);
	  } else {
		$sql = 'SELECT * FROM '.TBL_MODULES.' WHERE mid = '.$mid;
		$result = $this->db->sql_query($sql);
		$array = $this->db->sql_fetchrow($result, MYSQL_ASSOC); //fetchArray ->MYSQL_ASSOC car pour traiter makeModule a va plus vite
		$GLOBALS['ixpModule_getModule'][$mid] = $array;         // que MYSQL_BOTH (par dfaut)
		$this->makeModule($array);
		$this->db->sql_freeresult($result);
	  }
	}


	function makeModule($array) {
        if(!empty($array)) {
            foreach($array as $key=>$value)	{
	            $this->$key = $value;
		    }
        }
	}



	function getByDirname($dirname) {

		global $ixpdb; // A voir pour mettre dans $GLOBAL

		$ret = false;
		if (!empty($dirname)) {

		  if (! isset($GLOBALS['getByDirname'.$dirname])) {
				$sql = "SELECT * FROM ".TBL_MODULES." WHERE dirname = '".trim($dirname)."'";
				if ( $result = $ixpdb->sql_query($sql) ) {
					$count = $ixpdb->sql_numrows($result);
					if ( $count == 1 ) {
						$arr = $ixpdb->sql_fetchrow($result);
						$ret = new ixpModule($arr);//print_r($ret);
						$GLOBALS['getByDirname'.$dirname] = $ret;
					}
					$ixpdb->sql_freeresult($result);
				}
		  } else {
			  $ret = $GLOBALS['getByDirname'.$dirname];
		  }

		}
		return $ret;
	}

	function dirname_by_mid($mid) {
		global $ixpdb;

		if((empty($GLOBALS['global_array_mod'][$mid])) || (!is_array($GLOBALS['global_array_mod'][$mid] ))) {
			$sql = "SELECT dirname FROM ".TBL_MODULES." WHERE mid = '".$mid."'";
			list( $dirname ) = $ixpdb->sql_fetchrow( $ixpdb->sql_query($sql) );
			$GLOBALS['global_array_mod'][$mid]['dirname'] = $dirname;
			return  $dirname; 
		} else {
			return $GLOBALS['global_array_mod'][$mid]['dirname'];
		}
	}

    // public can called from outside class
	function mid_by_dirname($dirname) {

		global $ixpdb;

		$sql = "SELECT mid FROM ".TBL_MODULES." WHERE dirname = '".trim($dirname)."'";
		$result = $ixpdb->sql_fetchrow($ixpdb->sql_query($sql), MYSQL_ASSOC);
		return $result['mid'];
	}


	function isActivated() {
		if ( !empty($this->isactive) && $this->isactive == 1 ) {
			return true;
		}
		return false;
	}


	function moduleExists($dirname) {

		global $ixpdb;

		#TiX: COUNT (*) by COUNT(mid)
		$sql = "SELECT COUNT(mid) FROM ".TBL_MODULES." WHERE dirname='$dirname'";
		list($count) = $ixpdb->sql_fetchrow($ixpdb->sql_query($sql)); //fetchRow
        return ($count > 0);

	}


	function currentVersion(){
		if ( isset($this->version) ) {
			$version = round($this->version / 100,2);
		} else {
			$version = $this->version();
		}
		return $version;
	}

	function last_update(){
		return $this->last_update;
	}

	function isactive(){
		return $this->isactive;
	}

	function setWeight($value){
		$this->weight = $value;
	}

	function getWeight(){
		return $this->weight;
	}

	// TiX config SQL
	function modconf()
	{
	
	  if  (IXP_MODECONFIG=='SQL') {

		// Mise en variable globale de modconf pour le module
		if (!isset($GLOBALS[ $this->dirname ]['modconf']))	{
		
		  if (!empty($this->modconf)) {
			$tab = & unserialize(stripslashes($this->modconf));
			  if (!defined('IXPSYS_MODLAYOUT')) {
                  define( 'IXPSYS_MODLAYOUT', $tab['moduleThemeLayout']);
              }
			//}
		    $GLOBALS[ $this->dirname ]['modconf'] = &$tab;
		    return $tab;
		  } else {
				return array();
		  }

		}
		else {
		  return $GLOBALS[ $this->dirname ]['modconf'];
		}


	  } elseif(IXP_MODECONFIG=='FILE') {
          if (file_exists(IXP_ROOT_PATH."/modconf/".$this->get_dirname().".config.php")) {
            include_once( IXP_ROOT_PATH."/modconf/".$this->get_dirname().".config.php"); //load $ixp_ixpnewsConfig
			return ${'ixp_'.$this->get_dirname().'Config'};
		  }
		  return array();
	  }
	}

	function mid(){
		if ( isset($this->mid) ) {
			return $this->mid;
		}
	}

	function hasAdmin(){
		if ( $this->modinfo2['hasAdmin'] ) {
			return true;
		}
		return false;
	}

	function hasMain(){
		if ( $this->modinfo2['hasMain'] ) {
			return true;
		}
		return false;
	}

	#TiX: POur la traduction
	function name2() #TiX: POur la traduction
	{
		if ( isset($this->modinfo2['name']) ) {
			return $this->modinfo2['name'];
		} 
		else {
			return false;
		}
	}
	

	#TiX: Pour les menus dans le block
	function blockstodisplay() {

		if (!empty($GLOBALS['ixpModule_blockstodisplay'][$this->mid])) {
		  return $GLOBALS['ixpModule_blockstodisplay'][$this->mid];
		} else {
		  $sql = "SELECT blockstodisplay FROM ".TBL_MODULES." WHERE mid = '".$this->mid."'";
		  $result = $this->db->sql_query($sql);
		  $array = $this->db->sql_fetchrow($result, MYSQL_ASSOC); //fetchArray 2006
		  $GLOBALS['ixpModule_blockstodisplay'][$this->mid] = $array['blockstodisplay'];
		  $this->db->sql_freeresult($result);
		  return $array['blockstodisplay'];
		}

	}


	function dirname(){
		if (isset($this->modinfo2['dirname']) ) {
			return $this->modinfo2['dirname'];
		} else {
			return false;
		}
	}

	function get_dirname(){
		if (isset($this->modinfo2['dirname']) ) {
			return $this->modinfo2['dirname'];
		} else {
			return false;
		}
	}

	function root_web_dirname(){
		if (isset($this->modinfo2['dirname']) ) {
			return IXP_ROOT_WEB.'/mod/'.$this->modinfo2['dirname'];
		} else {
			return false;
		}
	}

	function root_path_dirname(){
		if (isset($this->modinfo2['dirname']) ) {
			return IXP_ROOT_PATH.'/mod/'.$this->modinfo2['dirname'];
		} else {
			return false;
		}
	}

	function date(){
		if ( isset($this->modinfo2['date']) ) {
			return $this->modinfo2['date'];
		} else {
			return false;
		}
	}

	function version(){
		if ( isset($this->modinfo2['version']) ) {
			return $this->modinfo2['version'];
		} else {
			return false;
		}
	}

	function description(){
		if ( isset($this->modinfo2['description']) ) {
			return $this->modinfo2['description'];
		} else {
			return false;
		}
	}

	function author(){
		if ( isset($this->modinfo2['author']) ) {
			return $this->modinfo2['author'];
		} else {
			return false;
		}
	}

	function credits(){
		if ( isset($this->modinfo2['credits']) ) {
			return $this->modinfo2['credits'];
		} else {
			return false;
		}
	}

	function help(){
		if ( isset($this->modinfo2['help']) ) {
			return $this->modinfo2['help'];
		} else {
			return false;
		}
	}

	function license(){
		if ( isset($this->modinfo2['license']) ) {
			return $this->modinfo2['license'];
		} else {
			return false;
		}
	}

	function official(){
		if ( isset($this->modinfo2['official']) ) {
			return $this->modinfo2['official'];
		} else {
			return 1;
		}
	}

	// renvoie l'image du module
	function image() {
		if ( isset($this->modinfo2['image']) ) {
			return $this->modinfo2['image'];
		} else {
			return false;
		}
	}

	function adminindex(){
		if ( isset($this->modinfo2['adminindex']) ) {
			return $this->modinfo2['adminindex'];
		} else {
			return false;
		}
	}

	function blockFuncFile($func_number){
		return $this->modinfo2['blocks'][$func_number]['file'];
	}

	function blockShowFunc($func_number){
		if ( isset($this->modinfo2['blocks'][$func_number]['show_func']) ){
			return $this->modinfo2['blocks'][$func_number]['show_func'];
		}
		return false;
	}

	function blockEditFunc($func_number){
		if ( isset($this->modinfo2['blocks'][$func_number]['edit_func']) ){
			return $this->modinfo2['blocks'][$func_number]['edit_func'];
		}
		return false;
	}


	function xml() {

		if (!isset($this->modinfo2['hasXml']) || !$this->modinfo2['hasXml'] || !isset($this->modinfo2['xml']['func']) || !isset($this->modinfo2['xml']['file']) || $this->modinfo2['xml']['func'] == "" || $this->modinfo2['xml']['file'] == "" ) {
			return false;
		}
	
		if (file_exists($this->root_path_dirname().'/'.$this->modinfo2['xml']['file']) ) {
			include_once($this->root_path_dirname().'/'.$this->modinfo2['xml']['file']);
		} else {
			return false;
		}
	
		if (function_exists($this->modinfo2['xml']['func'])) {
			$func = $this->modinfo2['xml']['func'];
			$ret = $func($param);
			return $ret;
		} else {
			return false;
		}

	}


	function search($term="", $andor="AND", $limit=0, $offset=0, $userid=0) {
        
		if (!isset($this->modinfo2['hasSearch']) || !$this->modinfo2['hasSearch'] || !isset($this->modinfo2['search']['func']) || !isset($this->modinfo2['search']['file']) || $this->modinfo2['search']['func'] == "" || $this->modinfo2['search']['file'] == "" ) {
			return false;
		}
		
		if (file_exists($this->root_path_dirname().'/'.$this->modinfo2['search']['file']) ) {
			include_once($this->root_path_dirname().'/'.$this->modinfo2['search']['file']);
		} else {
			return false;
		}
		
		if (function_exists($this->modinfo2['search']['func'])) {
			$func = $this->modinfo2['search']['func'];
			$ret = $func($term, $andor, $limit, $offset, $userid);
			return $ret;
		} else {
			return false;
		}

	}


	function userconf($param = 'param_by_default', $uid='') {
			
		if (!isset($this->modinfo2['hasUserconf']) || !$this->modinfo2['hasUserconf'] || !isset($this->modinfo2['userconf']['func']) || !isset($this->modinfo2['userconf']['file']) || $this->modinfo2['userconf']['func'] == "" || $this->modinfo2['userconf']['file'] == "" ) {
			return false;
		}
		
		if (file_exists($this->root_path_dirname().'/'.$this->modinfo2['userconf']['file']) ) {
			include_once($this->root_path_dirname().'/'.$this->modinfo2['userconf']['file']);
		} else {
			return false;
		}
		
		if (file_exists($this->root_path_dirname().'/language/'.IXPGLOBAL___current_language.'/userconf.php')) {
			include_once($this->root_path_dirname().'/language/'.IXPGLOBAL___current_language.'/userconf.php');
		} elseif (@file_exists($this->root_path_dirname().'/language/french/userconf.php') ) {
			include_once($this->root_path_dirname().'/language/french/userconf.php');
		}

		if ( function_exists($this->modinfo2['userconf']['func']) ) {
			$func = $this->modinfo2['userconf']['func'];
			$ret = $func( $param, $uid );
			return $ret;
		} else {
			return false;
		}

	}



	function userconfform() {
        
		if (!isset($this->modinfo2['hasUserconf']) || !$this->modinfo2['hasUserconf'] || !isset($this->modinfo2['userconf']['func']) || !isset($this->modinfo2['userconf']['file']) || $this->modinfo2['userconf']['form'] == "" || $this->modinfo2['userconf']['file'] == "" ) {
			return false;
		}
		
		if (file_exists($this->root_path_dirname().'/'.$this->modinfo2['userconf']['file']) ) {
			include_once($this->root_path_dirname().'/'.$this->modinfo2['userconf']['file']);
		} else {
			return false;
		}
		
		if (file_exists($this->root_path_dirname().'/language/'.IXPGLOBAL___current_language.'/userconf.php')) {
			include_once($this->root_path_dirname().'/language/'.IXPGLOBAL___current_language.'/userconf.php');
		} elseif (@file_exists($this->root_path_dirname().'/language/french/userconf.php') ) {
			include_once($this->root_path_dirname().'/language/french/userconf.php');
		}

		if ( function_exists($this->modinfo2['userconf']['form']) ) {
			$func = $this->modinfo2['userconf']['form'];
			$ret = $func();
			return $ret;
		} else {
			return false;
		}

	}

	function errors(){
		return $this->errors;
	}

	//------------------------------------------------------------------------
	// getHasMainModulesList 
	//	renvoie un tableau avec les modules actifs
	//	modifi pour que les modules sans "hasmain" soient checks
	//  attention: rajout de "mid<>1" pour ne pas afficher le module ixpsystem
	// ex:
	/*  Array
		(
			[5] => iXp Search
			[10] => iXprim News
			[9] => Liens
			[18] => Membres
			[11] => Sondages
			[12] => Stats des Visites
			[8] => Tlchargements
			[6] => Utilisateurs (*)
			[3] => Simple Page
			[4] => Stats Pages Vues
			[2] => Une
			[7] => Contactez nous
		)
	*/
	//------------------------------------------------------------------------
	function getHasMainModulesList($dirname=false) {

		global $ixpdb;

		$ret = array();
		//$result = $ixpdb->sql_query("SELECT mid, name, dirname from ".TBL_MODULES." WHERE isactive=1 AND hasmain=1 ORDER BY name ASC");
		$result = $ixpdb->sql_query("SELECT mid, name, dirname, hasmain from ".TBL_MODULES." WHERE isactive=1 AND mid<>1 ORDER BY weight,name ASC");
		while($myrow=$ixpdb->sql_fetchrow($result)) {
			if (!$myrow['hasmain']) { 
				$l_hasmain=' (*)';
			} else { 
				$l_hasmain='';
			}
			if ( $dirname ) {
				$ret[$myrow['dirname']] = $myrow['name'].$l_hasmain;
			} else {
				$ret[$myrow['mid']] = $myrow['name'].$l_hasmain;
			}
		}
		$ixpdb->sql_freeresult($result);
		return $ret;
	}

	function getHasSearchModulesList($aslist = true)
	{
		global $ixpdb;

		$ret = array();
		$result = $ixpdb->sql_query("SELECT mid, name from ".TBL_MODULES." WHERE isactive=1 AND hassearch=1 ORDER BY weight,name ASC");

		while ( $myrow=$ixpdb->sql_fetchrow($result) ) {
            $ixpModule = new ixpModule($myrow['mid']);
            $ixp_ixpModuleConfig = $ixpModule->modconf();
            
            if (!(isset($ixp_ixpModuleConfig['searchactive']) && $ixp_ixpModuleConfig['searchactive']==false)) {

                if ( $aslist ) {
				    $ret[$myrow['mid']] = $myrow['name'];
			    } else {
				    $ret[] = $myrow['mid'];
			    }
            }
		}
		$ixpdb->sql_freeresult($result);
		return $ret;
	}


	function getHasXmlModulesList($aslist = true)
	{
		global $ixpdb;

		$ret = array();
		$result = $ixpdb->sql_query("SELECT mid, name from ".TBL_MODULES." WHERE isactive=1 AND modconf_mod like '%s:6:\"hasXml\";s:1:\"1\"%' ORDER BY weight,name ASC");

		while ( $myrow=$ixpdb->sql_fetchrow($result) ) {

            //$ixpModule = new ixpModule($myrow['mid']);
            //$ixp_ixpModuleConfig = $ixpModule->modconf();
            
            //if (!(isset($ixp_ixpModuleConfig['searchactive']) && $ixp_ixpModuleConfig['searchactive']==false)) {

                if ( $aslist ) {
				    $ret[$myrow['mid']] = $myrow['name'];
			    } 
			    else {
				    $ret[] = $myrow['mid'];
			    }
            //}
		}
		$ixpdb->sql_freeresult($result);
		return $ret;
	}

	function getHasAdminModulesList($aslist = true)
	{
		global $ixpdb;

		$ret = array();
		$result = $ixpdb->sql_query("SELECT mid,name from ".TBL_MODULES." WHERE isactive=1 AND hasadmin=1 ORDER BY weight, name ASC");
		while ( $myrow=$ixpdb->sql_fetchrow($result, MYSQL_ASSOC) ) {	//fetchArray 200506
			if ($aslist) {
				$ret[$myrow['mid']] = $myrow['name'];
			} else {
				$ret[] = $myrow['mid'];
			}
		}
		$ixpdb->sql_freeresult($result);
		return $ret;
	}


	function getHasUserconfModulesList($aslist = true) {

		global $ixpdb;

		$ret = array();
		$result = $ixpdb->sql_query("SELECT mid, name from ".TBL_MODULES." WHERE isactive=1 AND hasuserconf=1 ORDER BY weight,name ASC");

		while ( $myrow=$ixpdb->sql_fetchrow($result, MYSQL_ASSOC) ) {	//fetchArray 200506
			if ( $aslist ) {
				$ret[$myrow['mid']] = $myrow['name'];
			} else {
				$ret[] = $myrow['mid'];
			}
		}
		$ixpdb->sql_freeresult($result);
		return $ret;

	}



	function getHasUserfieldsModulesList($aslist = true) {

		global $ixpdb;

		$ret = array();
		$result = $ixpdb->sql_query("SELECT mid, name from ".TBL_MODULES." WHERE isactive=1 AND hasuserfields=1 ORDER BY weight,name ASC");

		while ($myrow = $ixpdb->sql_fetchrow($result, MYSQL_ASSOC)) {	// fetchArray 200506
			if ($aslist) {
				$ret[$myrow['mid']] = $myrow['name'];
			} else {
				$ret[] = $myrow['mid'];
			}
		}
		$ixpdb->sql_freeresult($result);
		return $ret;

	}


	/*
	*  static
	*  Get all modules as a list
	*  set $aslist to true for ease of use with class ixpLists
	*  $exclude is an array of module ids that you dont want to get
	*/
	function getInstalledModules($asobject=true) {

		global $ixpdb;

		$ret = array();
		$sql = "SELECT * from ".TBL_MODULES." ORDER BY hasmain, weight, name ";
		$result = $ixpdb->sql_query($sql);
		while ( $myrow = $ixpdb->sql_fetchrow($result, MYSQL_ASSOC) ) {	//fetchArray 200506
			if ( $asobject == true ) {
				$ret[] = new ixpModule($myrow);
			} else {
				$ret[] = $myrow['mid'];
			}
		}
		$ixpdb->sql_freeresult($result);
		return $ret;
	}


	/*
	*  static
	*  Get all modules as a list
	*  set $aslist to true for ease of use with class ixpLists
	*  $exclude is an array of module ids that you dont want to get
	*/
	function getActiveModules($with_ixp_system=false, $asobject=true, $order='ORDER BY weight, hasmain, name') {

		global $ixpdb;

		$ret = array();
		
		if ($with_ixp_system) {
			$sql = "SELECT * from ".TBL_MODULES." WHERE isactive=1 ".$order;
		} else {
			$sql = "SELECT * from ".TBL_MODULES." WHERE isactive=1 and mid<>1 ".$order;
		}

		$result = $ixpdb->sql_query($sql);
		while ( $myrow = $ixpdb->sql_fetchrow($result, MYSQL_ASSOC)) { //fetchArray 200506
			if ( $asobject == true ) {
				$ret[] = new ixpModule($myrow);
			} else {
				$ret[] = $myrow['mid'];
			}
		}
		$ixpdb->sql_freeresult($result);
		return $ret;

	}


    // 20031203: module_config
	// tableau de config: tabconfig['core']->contient les pamamtres module/core
	// tabconfig['mod']-> contient les paramtres module/module ex: xfConfig
	function getModuleConfig($mid) {

		global $ixpdb;
		
		$ret = array();
		if (ctype_digit($mid)) {
			$sql = "SELECT modconf_mod from ".TBL_MODULES." WHERE mid='".$mid."'";
		} else {
			$sql = "SELECT modconf_mod from ".TBL_MODULES." WHERE dirname='".$mid."'";
		}

		$result = $ixpdb->sql_query($sql);
		$myrow = $ixpdb->sql_fetchrow($result);
		if (!empty($myrow['modconf_mod'])) {
			if (get_magic_quotes_gpc()) {
				$ret = unserialize($myrow['modconf_mod']);
				procedure_my_stripslashes($ret);  //in functions.php (par variable)
			} else {
				$ret = unserialize(stripslashes($myrow['modconf_mod']));
			}
		}
		$ixpdb->sql_freeresult($result);
		return $ret;
	}


	// 20031203: modconf_mod
	function addModuleConfig( $mid, $configToAdd ) {

		global $ixpdb;

		if (get_magic_quotes_gpc()) {
			$configToAdd = serialize($configToAdd);
			$configToAdd = addslashes($configToAdd);
		} else {
			$configToAdd = addslashes(serialize($configToAdd));
		}
		if (ctype_digit($mid)) {
			$sql = "UPDATE ".TBL_MODULES." SET modconf_mod='".$configToAdd."' WHERE mid='".$mid."'";
		} else {
			$sql = "UPDATE ".TBL_MODULES." SET modconf_mod='".$configToAdd."' WHERE dirname='".$mid."'";
		}
		$result = $ixpdb->sql_query($sql);

		return $result;
	}


	function saveModuleConfSQL($mid, $tabmodconf) {

		global $ixpdb;

		$tosave = addslashes(serialize($tabmodconf));
		$sql = "UPDATE ".TBL_MODULES." SET modconf='".$tosave."' WHERE mid=".$mid."";
		$result = $ixpdb->sql_query($sql);

		return $result;
	}


	function getModuleConfSQL($mid) {
		
		global $ixpdb;

		$ret = array();
		$sql = "SELECT modconf from ".TBL_MODULES." WHERE mid=".$mid;
		$result = $ixpdb->sql_query($sql);
		list($string) = $ixpdb->sql_fetchrow($result); //fetchArray
		$string = unserialize(stripslashes($string));
		$ixpdb->sql_freeresult($result);
		return $string;
	}

    
	function adminModulelink($ixpuser) {

	    if ($ixpuser) {
            if ($ixpuser->isAdmin($this->mid())) { 
                return '<br /><span class="atext-small"> &nbsp;'
				    .'[ <a class="atext-small" href="'.$this->root_web_dirname().'/admin/index.php">'._ADMINMENU
				    .'&nbsp;<img align="bottom" src="'.IXP_ROOT_WEB.'/images/target_no.gif" /></a>'
				    .'&nbsp;<a href="'.$this->root_web_dirname().'/admin/index.php" target="_blank">'
				    .'<img src="'.IXP_ROOT_WEB.'/images/target_blank.gif" align="bottom" /></a>'
				    .' ]</span><br />';
		    } else {
                return '';
            }

	    } else {
            return '';
        }

	}



	function displayLogoLink($p_display_ok, $p_title_text='', $image='') {

		if ($p_display_ok == 1) {

			if (empty($image)) {

                // image situe dans le thme
                if (file_exists(IXP_ROOT_PATH.'/themes/main/'.ixpts::get_default_theme().'/images/logo_'.$this->get_dirname().'.png')) {
                    $image = IXP_ROOT_WEB.'/themes/main/'.ixpts::get_default_theme().'/images/logo_'.$this->get_dirname().'.png';
                }
                // sinon image situe dans le module (image du logoadmin) 
                else {
                    $image = $this->root_web_dirname().'/'.$this->modinfo2['image'];
                }

                $search  = array( '{URL_LINK}', '{IMAGE_LINK}', '{TEXTE}' );
                $replace = array( 'ixm_'.$this->get_dirname().'.php', '<img src="'.$image.'" align="absmiddle" />', $p_title_text );
                if (file_exists(IXP_ROOT_PATH.'/themes/main/'.ixpts::get_default_theme().'/mod/ixp_system/tpl_display_logo_link.html')) {
                    return str_replace( $search, $replace, file_get_contents(IXP_ROOT_PATH.'/themes/main/'.ixpts::get_default_theme().'/mod/ixp_system/tpl_display_logo_link.html'));
                } else {
                    return str_replace( $search, $replace, file_get_contents(IXP_ROOT_PATH.'/themes/tpl_default/system_tpl/tpl_display_logo_link.html'));
                }

			} else {

                $search  = array( '{URL_LINK}', '{IMAGE_LINK}', '{TEXTE}' );
                $replace = array( 'ixm_'.$this->get_dirname().'.php', '<img src="'.$image.'" align="absmiddle" />', $p_title_text );
                if (file_exists(IXP_ROOT_PATH.'/themes/main/'.ixpts::get_default_theme().'/mod/ixp_system/tpl_display_logo_link.html')) {
                    return str_replace( $search, $replace, file_get_contents(IXP_ROOT_PATH.'/themes/main/'.ixpts::get_default_theme().'/mod/ixp_system/tpl_display_logo_link.html'));
                } else {
                    return str_replace( $search, $replace, file_get_contents(IXP_ROOT_PATH.'/themes/tpl_default/system_tpl/tpl_display_logo_link.html'));
                }
			}

		} elseif ( $p_display_ok == 2 ) {

                $search  = array( '{URL_LINK}', '{IMAGE_LINK}', '{TEXTE}' );
                $replace = array( 'ixm_'.$this->get_dirname().'.php', '', $p_title_text );
                if (file_exists(IXP_ROOT_PATH.'/themes/main/'.ixpts::get_default_theme().'/mod/ixp_system/tpl_display_logo_link.html')) {
                    return str_replace( $search, $replace, file_get_contents(IXP_ROOT_PATH.'/themes/main/'.ixpts::get_default_theme().'/mod/ixp_system/tpl_display_logo_link.html'));
                } else {
                    return str_replace( $search, $replace, file_get_contents(IXP_ROOT_PATH.'/themes/tpl_default/system_tpl/tpl_display_logo_link.html'));
                }

		} elseif ( $p_display_ok == 3 ) {
		
            if (empty($image)) {

                // image situe dans le thme
                if (file_exists(IXP_ROOT_PATH.'/themes/main/'.ixpts::get_default_theme().'/images/logo_'.$this->get_dirname().'.png')) {
                    $image = IXP_ROOT_WEB.'/themes/main/'.ixpts::get_default_theme().'/images/logo_'.$this->get_dirname().'.png';
                }
                // sinon image situe dans le module (image du logoadmin) 
                else {
                    $image = $this->root_web_dirname().'/'.$this->modinfo2['image'];
                }

                $search  = array( '{URL_LINK}', '{IMAGE_LINK}', '{TEXTE}' );
                $replace = array( 'ixm_'.$this->get_dirname().'.php', '<img src="'.$image.'" align="absmiddle" />', '' );
                if (file_exists(IXP_ROOT_PATH.'/themes/main/'.ixpts::get_default_theme().'/mod/ixp_system/tpl_display_logo_link.html')) {
                    return str_replace( $search, $replace, file_get_contents(IXP_ROOT_PATH.'/themes/main/'.ixpts::get_default_theme().'/mod/ixp_system/tpl_display_logo_link.html'));
                } else {
                    return str_replace( $search, $replace, file_get_contents(IXP_ROOT_PATH.'/themes/tpl_default/system_tpl/tpl_display_logo_link.html'));
                }

			} else {

                $search  = array( '{URL_LINK}', '{IMAGE_LINK}', '{TEXTE}' );
                $replace = array( 'ixm_'.$this->get_dirname().'.php', '<img src="'.$image.'" align="absmiddle" />', '' );
                if (file_exists(IXP_ROOT_PATH.'/themes/main/'.ixpts::get_default_theme().'/mod/ixp_system/tpl_display_logo_link.html')) {
                    return str_replace( $search, $replace, file_get_contents(IXP_ROOT_PATH.'/themes/main/'.ixpts::get_default_theme().'/mod/ixp_system/tpl_display_logo_link.html'));
                } else {
                    return str_replace( $search, $replace, file_get_contents(IXP_ROOT_PATH.'/themes/tpl_default/system_tpl/tpl_display_logo_link.html'));
                }
			}
		}
		else {
			return '';
		}
	}


    function adminItemlink($ixpuser, $op) {

	    if ($ixpuser) {

		    if ($ixpuser->isAdmin($this->mid())) { 
			    return '<a href="'.IXP_ROOT_WEB.'/mod/'.$this->get_dirname().'/admin/index.php?'.$op.'"><img src="'.IXP_ROOT_WEB_IMG.'/edit.gif" border="0" alt="'._EDIT.'" align="middle" /></a>  ';
		    } else {
                return '';
            }

	    } else {
            return '';
        }

	}


	function isModuleAdmin($ixpuser, $modulemid=1) {

        if ($ixpuser) {
			if ($ixpuser->isAdmin($modulemid)) { 
				return(TRUE); 
			} else { 
				return(FALSE); 
			}
		} else {
			return(FALSE);
		}

	}

	function isAdmin($moduleid=1) {
		
		global $ixpUser;

		if ( $ixpUser ) { 
			if ( $ixpUser->isAdmin($moduleid) )	{ 
				return TRUE;  
			} else { 
				return FALSE; 
			}
		}
		return FALSE;

	}



	function &dynamictitle($dynamic_title_option ='') {

        if ((trim($dynamic_title_option)!='')) {
            $ret = $dynamic_title_option.' - '.$this->name2().' - ';
        } else {
            $ret = $this->name2().' - ';
        }

        if (isset($GLOBALS[$this->dirname]['modconf']['dynamictitle']) && !empty($GLOBALS[$this->dirname]['modconf']['dynamictitle'])) {
            return($ret . IXPGLOBAL___sitename . ' - '.$GLOBALS[$this->dirname]['modconf']['dynamictitle']);
        } else {
            return($ret . IXPGLOBAL___sitename);
        }

	}



    function init_system_conf_cache_globals($force=false) {

        if ((! file_exists(IXP_ROOT_PATH.'/cache/system/mods.active.php') ) || $force) {

	        // -------------------------------------------------------------------
	        // Cration d'une variable contenant si le module 'dirname' ou 'mid' est install ou pas
	        //--------------------------------------------------------------------
            $is_module_active = array();
	        $active_mods = ixpModule::getActiveModules(false, true);

	        if (is_array( $active_mods )) {
			        foreach ( $active_mods as $module ) {
			        $is_module_active['dirname'][$module->get_dirname()] = true;
			        $is_module_active['mid'][$module->mid] = true;
		        }
	        }

	        // Ecrire dans le fichier mods.active.php
	        if (!$file = fopen( IXP_ROOT_PATH.'/cache/system/mods.active.php', "w")) {
		        echo "!!! Problem on openning file in write_module_conf";
		        return false;
	        }

	        flock( $file, LOCK_EX ); // exclusive lock
	        if ( fwrite($file,serialize( $is_module_active ) ) == -1 ) {
		        echo "!!! Problem on writing file in write_module_conf";
		        flock( $file, LOCK_UN ); // release the lock
		        return false;
	        }
	        flock( $file, LOCK_UN ); // release the lock
	        fclose($file);
  
        } else {
	        $is_module_active = unserialize(file_get_contents( IXP_ROOT_PATH.'/cache/system/mods.active.php' ));
        }

        $GLOBALS['is_module_active'] = $is_module_active;

    }


}
?>