<?php
//error_reporting(E_ALL);
##############################################################################
#                                                                            #
#      This file is part of IXPRIM CMS - Content Management System           #
#                       <http:#www.ixprim-cms.org/>                          #
#                                                                            #
#   Copyright (c) 2006 Christophe Deltheil <aka trollix> and contributors.   #
#                      All rights reserved.                                  #
# -------------------------------------------------------------------------- #
# ideas come from :                                                          #
# POSTNUKE Web Portal System - http://postnuke.org/                          #
# XOOPS Web Portal System - http://xoops.org/                                #
# myPHPNUKE Web Portal System - http://myphpnuke.com/                        #
# PHP-NUKE Web Portal System - http://phpnuke.org/                           #
# Thatware - http://thatware.org/                                            #
# dotclear Blog System - http://dotclear.net/                                #
# -------------------------------------------------------------------------- #
#  Ixprim CMS is free software; you can redistribute it and/or modify        #
#  it under the terms of the GNU General Public License as published by      #
#  the Free Software Foundation; either version 2 of the License, or         #
#  (at your option) any later version.                                       #
#                                                                            #
#  Ixprim CMS is distributed in the hope that it will be useful,             #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of            #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
#  GNU General Public License for more details.                              #
#                                                                            #
#  You should have received a copy of the GNU General Public License         #
#  along with this program; if not, write to the Free Software               #
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA  #
##############################################################################

class ixpPageNav
{
	var $total_pages;
	var $nb_by_page;
	var $current_page;
	var $url;

	function ixpPageNav($total_pages, $nb_by_page, $current_start, $start_name="start", $extra_arg='', $url='')
	{
		global $HTTP_SERVER_VARS;

		$this->url = $url;
		$this->total_pages  = intval($total_pages);
		$this->nb_by_page	= intval($nb_by_page);
		$this->current_page	= intval($current_start);
		$start_name = trim($start_name);

		if ( !empty($extra_arg) && ( substr($extra_arg, -5) != '&amp;' || substr($extra_arg, -1) != '&' ) ) {
			//$extra_arg .= '&amp;';
			$extra_arg .= '&';
		}

		if (empty($this->url)) {
		  $this->url = $HTTP_SERVER_VARS['PHP_SELF'].'?'.$extra_arg.$start_name.'=';
		}
		elseif( substr($this->url, -1)!='&'  ) {
		  $this->url = $this->url.'?'.$extra_arg.$start_name.'=';
		}
		else {
			$this->url = $this->url.$extra_arg.$start_name.'=';
		}

	}

	function affNav($offset = 4, $anchor='', $renderstyle=1) 
	{
		if ( $this->total_pages < $this->nb_by_page ) {
			return;
		}
		if(!empty($this->nb_by_page)) {
            $total_pages = ceil($this->total_pages / $this->nb_by_page);
        }
        else {
            $total_pages = 0;
        }

		if ( $total_pages > 1 ) {
   			$ret = '';
			$prev = $this->current_page - $this->nb_by_page;
			
			$counter = 1;
			$current_page = intval(floor(($this->current_page + $this->nb_by_page) / $this->nb_by_page));

			if ($renderstyle == 1) {
			  if ( $prev >= 0 ) {
				$ret .= '<a class="navlink" href="'.$this->url.$prev.$anchor.'"><u>&laquo;</u></a> ';
			  }
			}

			elseif ($renderstyle == 2) {	
				
				// Added by P.L.B
				$ret .= '<div id="ixppagenav"><table><tr>';
				if ($prev >= 0) {
					$ret .= '<td class="sidel"><a class="navlink" href="'.$this->url.$prev.$anchor.'"><b>&laquo; '._PREVPAGE.'</b></a></td>';
				} else {
					$ret .= '<td class="sidel">&laquo; <i>'._PREVPAGE.'</i></td>';
				}
				$ret .= '<td class="middle">';
			}

			elseif ($renderstyle == 3) {	
				
				// Added by trollix
				$ret .= '<div id="ixppagenav"><table class="ixppagenav_border" cellpadding="0" cellspacing="1" border="0"><tr>'
						.'<td class="ixppagenav_page" style="font-weight:normal">'.sprintf(_GAL_PAGEOF, $current_page, $total_pages).'</td>';

				if ($prev >= 0) {
					$ret .= '<td class="ixppagenav_alt2"><a class="navlink" href="'.$this->url.$prev.$anchor.'"><b>&nbsp;<&nbsp;</b></a></td>';
				} else {
					$ret .= ' ';//'<td class="sidel">&laquo; <i>'._PREVPAGE.'</i></td>';
				}
				$ret .= '<td class="ixppagenav_alt2">';
			}

			while ( $counter <= $total_pages ) {
				if ( $counter == $current_page ) {
					if ($renderstyle == 3) {
						$ret .= '</td><td class="ixppagenav_alt1">&nbsp;<b>'.$counter.'</b>&nbsp;</td><td class="ixppagenav_alt2">';
					} else {
						$ret .= '<b>['.$counter.']</b> ';
					}
				} 
				elseif ( ($counter > $current_page-$offset && $counter < $current_page + $offset ) || $counter == 1 || $counter == $total_pages ) {
					if ( $counter == $total_pages && $current_page < $total_pages - $offset ) {
						$ret .= '... ';
					}
                    $end = $this->url.(($counter - 1) * $this->nb_by_page).$anchor;
					$ret .= '&nbsp;<a class="navlink" href="'.$this->url.(($counter - 1) * $this->nb_by_page).$anchor.'">'.$counter.'</a>&nbsp;';
					if ( $counter == 1 && $current_page > 1 + $offset ) {
						$ret .= '... ';
					}
				}
				$counter++;
			}
			$next = $this->current_page + $this->nb_by_page;
			
			if ($renderstyle == 1) {
			  if ( $this->total_pages > $next ) {
				$ret .= '&nbsp;<a class="navlink" href="'.$this->url.$next.$anchor.'"><u>&raquo;</u></a> ';
			  }

			} elseif ($renderstyle == 2) {

				if ( $this->total_pages > $next ) {
					$ret .= '<td class="sider"><a class="navlink" href="'.$this->url.$next.$anchor.'"><b>'._NEXT.' &raquo;</b></a></td>';
				} else {
					$ret .= '<td class="sider"><i>'._NEXT.'</i> &raquo;</td>';
				}
				$ret .= '</tr></table></div>';
			
			} elseif ($renderstyle == 3) {

				if ( $this->total_pages > $next ) {
					$ret .= '<td class="ixppagenav_alt2">&nbsp;<a class="navlink" href="'.$this->url.$next.$anchor.'">></a>&nbsp;</td><td class="ixppagenav_alt2">&nbsp;<a class="navlink" href="'.$end.'">&raquo;</a>&nbsp;</td>';
				} else {
					$ret .= '';//'<td class="ixppagenav_alt1"><i>'._NEXT.'</i> &raquo;</td>';
				}
				$ret .= '</tr></table></div>';
			}

		  }
		return $ret;
	}

}

class ixpPageNavPP extends ixpPageNav
{
	var $total_items;
	var $nb_by_page;
	var $url;

	function ixpPageNavPP($total_items, $nb_by_page, $current_start, $start_name="start", $extra_arg='', $url='')
	{
		global $HTTP_SERVER_VARS;

		$this->url = $url;
		$this->total_items  = intval($total_items);
		$this->nb_by_page	= intval($nb_by_page);
		$this->current_page	= intval($current_start);
		$start_name = trim($start_name);

		if ( !empty($extra_arg) && ( substr($extra_arg, -5) != '&amp;' || substr($extra_arg, -1) != '&' ) ) {
			//$extra_arg .= '&amp;';
			$extra_arg .= '&';
		}

		if (empty($this->url)) {
			$this->url = $HTTP_SERVER_VARS['PHP_SELF'].'?'.$extra_arg.$start_name.'=';
		} elseif( substr($this->url, -1)!='&'  ) {
			$this->url = $this->url.'?'.$extra_arg.$start_name.'=';
		}else {
			$this->url = $this->url.$extra_arg.$start_name.'=';
		}

	}


	function affNav($offset = 4, $anchor='', $renderstyle=1) 
	{
		if ( $this->total_items < $this->nb_by_page ) {
			return;
		}
		if(!empty($this->nb_by_page)) {
            $total_pages = ceil($this->total_items / $this->nb_by_page);
        }
        else {
            $total_pages = 0;
        }

		if ( $total_pages > 1 ) {
   			$ret = '';
			$prev = ($this->current_page<=2) ? 1 : $this->current_page - 1; 
			//print ' current_page:'.$this->current_page.' nb_by_page:'.$this->nb_by_page.' total_pages:'.$total_pages.','.$this->total_items.' prev:'.$prev;
			
			$counter = 1;

			if ($renderstyle == 1) {
			  if ($this->current_page > 1) {
				$ret .= '<a class="navlink" href="'.$this->url.$prev.$anchor.'"><u>&laquo;</u></a> ';
			  }
			}

			elseif ($renderstyle == 2) {	
				
				// Added by P.L.B
				$ret .= '<div id="ixppagenav"><table><tr>';
				if ($this->current_page > 1) {
					$ret .= '<td class="sidel"><a class="navlink" href="'.$this->url.$prev.$anchor.'"><b>&laquo; '._PREVPAGE.'</b></a></td>';
				} else {
					$ret .= '<td class="sidel">&laquo; <i>'._PREVPAGE.'</i></td>';
				}
				$ret .= '<td class="middle">';
			}

			elseif ($renderstyle == 3) {	
				
				// Added by trollix
				$ret .= '<div id="ixppagenav"><table class="ixppagenav_border" cellpadding="0" cellspacing="1" border="0"><tr>'
						.'<td class="ixppagenav_page" style="font-weight:normal">'.sprintf(_GAL_PAGEOF, $this->current_page, $total_pages).'</td>';

				if ($this->current_page > 1) {
					$ret .= '<td class="ixppagenav_alt2"><a class="navlink" href="'.$this->url.$prev.$anchor.'"><b>&nbsp;<small><</small>&nbsp;</b></a></td>';
				} else {
					$ret .= ' ';//'<td class="sidel">&laquo; <i>'._PREVPAGE.'</i></td>';
				}
				$ret .= '<td class="ixppagenav_alt2">';
			}

			while ( $counter <= $total_pages ) {
				
				if ( $counter == $this->current_page ) {
					if ($renderstyle == 3) {
						$ret .= '</td><td class="ixppagenav_alt1">&nbsp;<b>'.$counter.'</b>&nbsp;</td><td class="ixppagenav_alt2">';
					} else {
						$ret .= '<b>['.$counter.']</b> ';
					}
				} 
				
				elseif ( ($counter > $this->current_page-$offset+1+(($offset+1)%2) && $counter < $this->current_page + $offset-1 ) || $counter == 1 || $counter == $total_pages ) {
					if ( $counter == $total_pages && $this->current_page < $total_pages - $offset ) {
						$ret .= '... ';
					}
                    $end = $this->url.$counter.$anchor;
					$ret .= '&nbsp;<a class="navlink" href="'.$this->url.$counter.$anchor.'">'.$counter.'</a>&nbsp;';
					if ( $counter == 1 && $this->current_page > 1 + $offset ) {
						$ret .= '... ';
					}
				}
				$counter++;

			}

			$next = $this->current_page + 1; //print ' next:'.$next;
			
			if ($renderstyle == 1) {
			  if ( $total_pages >= $next ) {
				$ret .= '&nbsp;<a class="navlink" href="'.$this->url.$next.$anchor.'"><u>&raquo;</u></a> ';
			  }

			} elseif ($renderstyle == 2) {

				if ( $total_pages >= $next ) {
					$ret .= '<td class="sider"><a class="navlink" href="'.$this->url.$next.$anchor.'"><b>'._NEXT.' &raquo;</b></a></td>';
				} else {
					$ret .= '<td class="sider"><i>'._NEXT.'</i> &raquo;</td>';
				}
				$ret .= '</tr></table></div>';
			
			} elseif ($renderstyle == 3) {

				if ( $total_pages >= $next ) {
					$ret .= '<td class="ixppagenav_alt2">&nbsp;<a class="navlink" href="'.$this->url.$next.$anchor.'"><small>></small></a>&nbsp;</td><td class="ixppagenav_alt2">&nbsp;<a class="navlink" href="'.$end.'">&raquo;</a>&nbsp;</td>';
				} else {
					$ret .= '';//'<td class="ixppagenav_alt1"><i>'._NEXT.'</i> &raquo;</td>';
				}
				$ret .= '</tr></table></div>';
			}

		  }
		return $ret;
	}


}

?>