<?php
//error_reporting(E_ALL);
##############################################################################
#                                                                            #
#      This file is part of IXPRIM CMS - Content Management System           #
#                       <http:#www.ixprim-cms.org/>                          #
#                                                                            #
#   Copyright (c) 2006 Christophe Deltheil <aka trollix> and contributors.   #
#                      All rights reserved.                                  #
# -------------------------------------------------------------------------- #
# ideas come from :                                                          #
# POSTNUKE Web Portal System - http://postnuke.org/                          #
# XOOPS Web Portal System - http://xoops.org/                                #
# myPHPNUKE Web Portal System - http://myphpnuke.com/                        #
# PHP-NUKE Web Portal System - http://phpnuke.org/                           #
# Thatware - http://thatware.org/                                            #
# dotclear Blog System - http://dotclear.net/                                #
# -------------------------------------------------------------------------- #
#  Ixprim CMS is free software; you can redistribute it and/or modify        #
#  it under the terms of the GNU General Public License as published by      #
#  the Free Software Foundation; either version 2 of the License, or         #
#  (at your option) any later version.                                       #
#                                                                            #
#  Ixprim CMS is distributed in the hope that it will be useful,             #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of            #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
#  GNU General Public License for more details.                              #
#                                                                            #
#  You should have received a copy of the GNU General Public License         #
#  along with this program; if not, write to the Free Software               #
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA  #
##############################################################################

/* Initial code by
	table v.1.0.0b
	Class for easy composing of complex tables
	By Lloren Herrera [lha@hexoplastia.com]
	Please do not remove this credits

	Rewritten by trollix for ixprim CMS
*/

class table_cell
{
	var $content = '';
	var $colspan = 0;
	var $rowspan = 0;
	var $css_class = "table_cell";
    var $id = '';
    var $css_style = '';
    var $all_td_css_style = '';
	var $all_td_css_class = '';
	var $highlight = '';
	var $highlight_class = 'table_highlighted';
	var $nobr = false;
		
	function table_cell ($content='', $colspan='', $rowspan='', $id='', $css_class='', $css_style='', $all_td_css_style='', $all_td_css_class='', $highlight='', $nobr=true) {

		$this->content = $content;
        $this->id = $id;
		$this->colspan = $colspan;
		$this->rowspan = $rowspan;
		$this->css_class = $css_class;
        $this->css_style = $css_style;
		$this->all_td_css_style = $all_td_css_style;
		$this->all_td_css_class = $all_td_css_class;
		$this->nobr = $nobr;
		$this->highlight = $highlight;
	}
		
	function render_td ($td='td') {
            
		$ret = '';
		// empty: car 0 ou vide
        $colspan = (empty($this->colspan)) ? '' : ' colspan="'.$this->colspan.'"';
		$rowspan = (empty($this->rowspan)) ? '' : ' rowspan="'.$this->rowspan.'"';
        $id      = (empty($this->id))      ? '' : ' id="'.$this->id.'"';

		if ($this->all_td_css_style != '') {
			$css_style = ' style="'.$this->all_td_css_style.'"';
		} else {
			$css_style =    ($this->css_style != '' ? ' style="'.$this->css_style.'"' : '');
		}

		if ($this->all_td_css_class != '') {
			$css_class = ' class="'.$this->all_td_css_class.'"';
		} else {
			$css_class =    ($this->css_class != '' ? ' class="'.$this->css_class.'"' : '');
		}

        if ($td=='td') {
            $ret .= "\t".'<td '.$id.$css_class.$colspan.$rowspan.$css_style.'>';
		    $ret .= $this->get_content ();
		    $ret .= "</td>\n";
        } else {
            $ret .= "\t".'<th '.$id.$css_class.$colspan.$rowspan.$css_style.'>';
		    $ret .= $this->get_content ();
		    $ret .= "</th>\n";
        }
		return $ret;

	}
		
	function get_content () {
		return ($this->highlight != "" ? $this->highlight ($this->content, $this->highlight) : $this->returnisnobr ());
	}
		
	function returnisnobr () {
		return ($this->nobr ? str_replace (" ", "&nbsp;", $this->content) : $this->content);
	}
		
	function highlight ($string, $tohighlight) {
		return str_replace ($tohighlight, "<span class=\"".$this->highlight_class."\">".$tohighlight."</span>", $string);
	}

}
	

class table_row {

	var $cells;
	var $css_class = '';
    var $css_style = '';
    var $td='td';
		
	function table_row ($cells, $css_class, $css_style, $td='td') {
		$this->cells = $cells;
		if ($css_class != "") $this->css_class = $css_class;
        if ($css_style != "") $this->css_style = $css_style;
        $this->td=$td;
	}
		
	function addcell($cell) {
		$this->cells[] = $cell;
	}
		
	function render_tr() {
        $css_style = ($this->css_style != '' ? ' style="'.$this->css_style.'"' : '');
		$css_class = ($this->css_class != '' ? ' class="'.$this->css_class.'"' : '');

		$ret = '<tr'.$css_class.$css_style.'>'."\n";
		while (list (, $cell) = each ($this->cells)) {
			$ret .= $cell->render_td($this->td);
        }
		$ret .= "</tr>\n";
		return $ret;
	}
}
	
class ixptablemaker	{

	var $width = "100%";
	var $css_class = "table_class";
    var $css_style = "";
	var $all_td_css_style = "";
	var $all_td_css_class = "";
    var $id='table';
	var $cellpadding = 3;
	var $cellspacing = 0;
	var $alternatecolors = false;
	var $rowstyles = array ("table_row1", "table_row2");
	var $rowstyles_counter = 0;
	var $rows;
    var $active_th = false;
    var $header_css_style='';
    var $header_css_class='';
	var $use_div=false;

	function ixptablemaker ($width='100%', $id='', $css_class='') {
		if ($width != "") $this->width = $width;
		if ($css_class != "") $this->css_class = $css_class;
        if ($id != "") $this->id = $id;
	}
		
	function add_row ($row)	{
		$this->rows[] = $row;
	}
		
	function set_cellspacing($value) {
		$this->cellspacing = $value;
	}
		
	function set_active_th( $value=true, $header_css_style='' ) {
		$this->active_th = $value;
        $this->header_css_style = $header_css_style;
	}

	function set_header_css_style( $value=true ) {
		$this->header_css_style = $value;
	}

	function set_header_css_class( $value=true ) {
		$this->header_css_class = $value;
	}

	function set_css_style( $value='' ) {
		$this->css_style = $value;
	}

	function set_css_class( $value='' ) {
		$this->css_class = $value;
	}

	function set_all_td_css_style( $value='' ) {
		$this->all_td_css_style = $value;
	}

	function set_all_td_css_class( $value='' ) {
		$this->all_td_css_class = $value;
	}

	function use_div( $value=true ) {
		$this->use_div = $value;
	}

	function set_id( $value='' ) {
		$this->id = $value;
	}

	function set_alternatecolors( $value=true ) {
		$this->alternatecolors = $value;
	}

    function dump($data) {
		foreach($data as $akey=>$avalue) {
            foreach( $avalue as $key=>$value  ) {
                echo $akey.'|'.$key.'|'.$value['data'].'<br>';
                echo $akey.'|'.$key.'|'.$value['colspan'].'<br>';
				echo $akey.'|'.$key.'|'.$value['rowspan'].'<br>';
                echo $akey.'|'.$key.'|'.$value['css_class'].'<br>';
                echo $akey.'|'.$key.'|'.$value['css_style'].'<br>';
                echo $akey.'|'.$key.'|'.$value['highlight'].'<br>';
                echo $akey.'|'.$key.'|'.$value['nobr'].'<br>';
            }
        }
    }

    function add_data($data) {

        $i=0;
    
		foreach($data as $akey=>$avalue) {
			$item=array();
            foreach( $avalue as $key=>$value  ) {					
                if ($i==0 && $this->active_th) {       //TH
                    $item[] = new table_cell (
					isset($value['data']) ? $value['data'] : '',  
					isset($value['colspan']) ? $value['colspan'] : '', 
					isset($value['rowspan']) ? $value['rowspan'] : '', 
					isset($value['id']) ? $value['id'] : '', 
					isset($value['css_class']) ? $value['css_class'] : '', 
					isset($value['css_style']) ? $value['css_style'] : '', 
					$this->header_css_style, 
					$this->header_css_class, 
					isset($value['highlight']) ? $value['highlight'] : '',
					isset($value['nobr']) ? $value['nobr'] : ''
					);
                } else {    //TD
                    $item[] = new table_cell (
					isset($value['data']) ? $value['data'] : '', 
					isset($value['colspan']) ? $value['colspan'] : '', 
					isset($value['rowspan']) ? $value['rowspan'] : '', 
					isset($value['id']) ? $value['id'] : '', 
					isset($value['css_class']) ? $value['css_class'] : '', 
					isset($value['css_style']) ? $value['css_style'] : '', 
					$this->all_td_css_style, 
					$this->all_td_css_class, 
					isset($value['highlight']) ? $value['highlight'] : '',
					isset($value['nobr']) ? $value['nobr'] : ''						
					);
                }
            }
                
            if ($i==0 && $this->active_th) {
                $this->add_row( new table_row ( $item, '', '', 'th' ) );
            } else {
                $this->add_row( new table_row ( $item,'', '', 'td' ) );
            }
            $i++;
        }
    }


	function render () {
		
		if($this->use_div) {
            $ret = '<div id="'.$this->id.'" class="'.$this->css_class.'" style="'.$this->css_style.'">'."\n";
        } else {
            $cellspacing = ($this->cellspacing >0) ? ' cellspacing="'.$this->cellspacing.'"' : ' cellspacing="0"';
            $ret = '<table border="0" id="'.$this->id.'" width="'.$this->width.'" class="'.$this->css_class.'" style="'.$this->css_style.'"'.$cellspacing.'>'."\n";
        }

		while (list (, $row) = each ($this->rows)) {
			if ($this->alternatecolors) {
				$row->css_class = $this->rowstyles [$this->rowstyles_counter];
				$this->rowstyles_counter ++;
				if ($this->rowstyles_counter >= sizeof ($this->rowstyles))
					$this->rowstyles_counter = 0;
			}
			$ret .= $row->render_tr();
		}

		if($this->use_div) {
            $ret .= "</div>\n";
        } else {
            $ret .= "</table>\n";
        }
		return $ret;
	}
	
}
?>