<?php
//error_reporting(E_ALL);
##############################################################################
#                                                                            #
#      This file is part of IXPRIM CMS - Content Management System           #
#                       <http:#www.ixprim-cms.org/>                          #
#                                                                            #
#   Copyright (c) 2006 Christophe Deltheil <aka trollix> and contributors.   #
#                      All rights reserved.                                  #
# -------------------------------------------------------------------------- #
# ideas come from :                                                          #
# POSTNUKE Web Portal System - http://postnuke.org/                          #
# XOOPS Web Portal System - http://xoops.org/                                #
# myPHPNUKE Web Portal System - http://myphpnuke.com/                        #
# PHP-NUKE Web Portal System - http://phpnuke.org/                           #
# Thatware - http://thatware.org/                                            #
# dotclear Blog System - http://dotclear.net/                                #
# -------------------------------------------------------------------------- #
#  Ixprim CMS is free software; you can redistribute it and/or modify        #
#  it under the terms of the GNU General Public License as published by      #
#  the Free Software Foundation; either version 2 of the License, or         #
#  (at your option) any later version.                                       #
#                                                                            #
#  Ixprim CMS is distributed in the hope that it will be useful,             #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of            #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
#  GNU General Public License for more details.                              #
#                                                                            #
#  You should have received a copy of the GNU General Public License         #
#  along with this program; if not, write to the Free Software               #
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA  #
##############################################################################


class ixpTree
{
	var $table;     //table with parent-child structure
	var $id;    //name of unique id for records in table $table
	var $pid;     // name of parent id used in table $table
	var $order;    //specifies the order of query results
	var $title;     // name of a field in table $table which will be used when  selection box and paths are generated
	var $db;

        // given by PLB (Pascal le Bousteller)
	var $pidcid = array();
	var $cidpid = array();

	//constructor of class ixpTree
	//sets the names of table, unique id, and parend id
	function ixpTree($table_name, $id_name, $pid_name, $preset_pid=0)
	{
		global $ixpdb;

		$this->db = $ixpdb;
		$this->table = $table_name;
		$this->id = $id_name;
		$this->pid = $pid_name;
		$this->preset_pid = $preset_pid;
	}	


	// returns an array of first child objects for a given id($sel_id)
	function getFirstChild($sel_id, $order='')
	{
		$arr =array();
		$sql = "SELECT * FROM ".$this->table." WHERE ".$this->pid."=".$sel_id."";
		if ( $order != '' ) {
			$sql .= " ORDER BY $order";
		}
		$result = $this->db->sql_query($sql);
		$count = $this->db->sql_numrows($result);
		if ( $count==0 ) {
			return $arr;
		}
		while ( $myrow=$this->db->sql_fetchrow($result) ) //fetchArray
		{
			array_push($arr, $myrow);
		}
		return $arr;
	}

	// returns an array of all FIRST child ids of a given id($sel_id)
	function getFirstChildId($sel_id){
		$idarray =array();
		$result = $this->db->sql_query("SELECT ".$this->id." FROM ".$this->table." WHERE ".$this->pid."=".$sel_id."");
		$count = $this->db->sql_numrows($result);
		if ( $count == 0 ) {
			return $idarray;
		}
		while ( list($id) = $this->db->sql_fetchrow($result) ) //fetchRow
		{
			array_push($idarray, $id);
		}
		return $idarray;
	}

	
	
	
function getAllChildId($sel_id, $order='', $idarray = array(), $title='title') {

    if ( empty($this->pidcid) ) {
	    $this->loadtree( $title );
    }

    $ele = $this->pidcid[$sel_id];

    if (!empty($ele)) {
	    foreach ($ele as $key => $value) {
		    array_push($idarray, $key);
		    $idarray = $this->getAllChildId($key,$order,$idarray, $title);
	    }
    }

    return $idarray;
}
	
	
function loadtree($title='title') {
    global $myts;

    $sql    = 'SELECT '.$this->pid.', '.$this->id.', '.$title.' FROM '.$this->table.'';
    if ( $order != '' ) {
        $sql .= " ORDER BY $order";
	}
    $result = $this->db->sql_query($sql);

    while (list($pid, $cid, $name) = $this->db->sql_fetchrow($result)) {
	    $this->pidcid[$pid][$cid] = $myts->makeTboxData4Show($name);
	    $this->cidpid[$cid][$pid] = $myts->makeTboxData4Show($name);
    }
}	
		
	
	
	
	
/*
	//returns an array of ALL child ids for a given id($sel_id)
	function getAllChildId($sel_id, $order='', $idarray = array())
	{
		$sql = "SELECT ".$this->id." FROM ".$this->table." WHERE ".$this->pid."=".$sel_id."";
		
		if ( $order != '' ) {
			$sql .= " ORDER BY $order";
		}
		$result=$this->db->sql_query($sql);
		$count = $this->db->sql_numrows($result);
		if ( $count==0 ) {
			return $idarray;
		}
		while ( list($r_id) = $this->db->sql_fetchrow($result) ) //fetchRow
		{
			array_push($idarray, $r_id);
			$idarray = $this->getAllChildId($r_id,$order,$idarray);
		}
		return $idarray;
	}
*/


	//returns an array of ALL parent ids for a given id($sel_id)
	function getAllParentId($sel_id,$order='',$idarray = array()){
		$sql = "SELECT ".$this->pid." FROM ".$this->table." WHERE ".$this->id."=".$sel_id."";
		if ( $order != '' ) {
			$sql .= " ORDER BY $order";
		}
		$result=$this->db->sql_query($sql);
		list($r_id) = $this->db->sql_fetchrow($result);//fetchRow
		if ( $r_id == 0 ) {
			return $idarray;
		}
		array_push($idarray, $r_id);
		$idarray = $this->getAllParentId($r_id,$order,$idarray);
		return $idarray;
	}

	//returns an array of ALL parent ids for a given id($sel_id)
	function parentId($sel_id) {
        if ($sel_id!='') {
            $sql = "SELECT ".$this->pid." FROM ".$this->table." WHERE ".$this->id."=".$sel_id."";

		    $result=$this->db->sql_query($sql);
		    list($p_id) = $this->db->sql_fetchrow($result);//fetchRow
		    return $p_id;
        } else {
            return 0;
        }
	}

	//generates path from the root id to a given id($sel_id)
	// the path is delimetered with "/"
	function getPathFromId($sel_id, $title, $path=""){
		$result = $this->db->sql_query("SELECT ".$this->pid.", ".$title." FROM ".$this->table." WHERE ".$this->id."=$sel_id");
		if ( $this->db->sql_numrows($result) == 0 ) {
			return $path;
		}
		list($parentid,$name) = $this->db->sql_fetchrow($result);//fetchRow
		$myts =& MyTextSanitizer::getInstance();
		$name = $myts->makeTboxData4Show($name);
		$path = "/".$name.$path."";
		if ( $parentid == 0 ) {
			return $path;
		}
		$path = $this->getPathFromId($parentid, $title, $path);
		return $path;
	}



	//makes a nicely ordered selection box
	//$preset_id is used to specify a preselected item
	//set $none to 1 to add a option with value 0
	function makeSelectBox($title, $order='', $preset_id=0, $none=0, $sel_name="", $onchange="")
	{
		
        if ( $sel_name == "" ) {
			$sel_name = $this->id;
		}
		
        $myts =& MyTextSanitizer::getInstance();
		
        echo "<select name='".$sel_name."'";
		if ( $onchange != "" ) {
			echo " onchange='".$onchange."'";
		}
		echo ">\n";
		$sql = "SELECT ".$this->id.", ".$title." FROM ".$this->table." WHERE ".$this->pid."=".$this->preset_pid;
		if ( $order != '' ) {
			$sql .= " ORDER BY $order";
		}
		$result = $this->db->sql_query($sql);
		if ( $none ) {
			echo "<option value='0'>----</option>\n";
		}

		while ( list($catid, $name) = $this->db->sql_fetchrow($result) ) //fetchRow
		{
			if ( $catid == $preset_id ) {
				$sel = " selected='selected'";
			}
			echo "<option value='$catid'$sel>$name</option>\n";
			$sel = "";
			$arr = $this->getChildTreeArray($catid, $order);
			
            foreach ( $arr as $option ) {
				$option['prefix'] = str_replace(".","--",$option['prefix']);
				$catpath = $option['prefix']."&nbsp;".$myts->makeTboxData4Show($option[$title]);
				if ( $option[$this->id] == $preset_id ) {
					$sel = " selected='selected'";
				}
				echo "<option value='".$option[$this->id]."'$sel>$catpath</option>\n";
				$sel = "";
			}
		}
		echo "</select>\n";
	}


	function makeSelectBoxStr($title, $order='', $preset_id=0, $none=0, $sel_name='', $onchange='')
	{
        global $myts;

        $tempStr = '';

		if ( empty($sel_name) ) {
			$sel_name = $this->id;
		}

		$tempStr .= '<select name="'.$sel_name.'"';
		if ( !empty($onchange)) {
			$tempStr .= ' onchange="'.$onchange.'"';
		}
		$tempStr .= '>';

		$sql = "SELECT ".$this->id.", ".$title." FROM ".$this->table." WHERE ".$this->pid."=".$this->preset_pid;
		if ( $order != '' ) {
			$sql .= " ORDER BY $order";
		}
		$result = $this->db->sql_query($sql);
		
        if ( $none ) {
			$tempStr .= '<option value="0">----</option>';
		}

		while ( list($catid, $name) = $this->db->sql_fetchrow($result) ) {  //fetchRow
		
			if ( $catid == $preset_id ) {
				$sel = ' selected="selected"';
			}

			$tempStr .= '<option value="'.$catid.'" '.$sel.'>'.$name.'</option>';
			$sel = '';
			
            $arr = $this->getChildTreeArray($catid, $order);  //recherche des arbres fils de chaque cat dont pid=0 (ie main cat)

			foreach ( $arr as $option ) {
				
                $option['prefix'] = str_replace('.','--',$option['prefix']);
				$catpath = $option['prefix'].'&nbsp;'.$myts->makeTboxData4Show($option[$title]);
				if ( $option[$this->id] == $preset_id ) {
					$sel = " selected='selected'";
				}
				$tempStr .= '<option value="'.$option[$this->id].'" '.$sel.'>'.$catpath.'</option>';
				$sel = '';
			}

            
		}
		$tempStr .= "</select>\n";

		return $tempStr;
	}


	//generates nicely formatted linked path from the root id to a given id
	function getNicePathFromId($sel_id, $title, $funcURL, $path="", $class="")
	{
		if (!empty($class)) { $class2='class="'.$class.'" '; }

		$sql = "SELECT ".$this->pid.", ".$title." FROM ".$this->table." WHERE ".$this->id."=$sel_id";
		$result = $this->db->sql_query($sql);
		if ( $this->db->sql_numrows($result) == 0 ) {
			return $path;
		}
		list($parentid,$name) = $this->db->sql_fetchrow($result);//fetchRow
		$myts =& MyTextSanitizer::getInstance();
		$name = $myts->makeTboxData4Show($name);

		if ($path != '') {
			$path = '<a '.$class2.' href="'.$funcURL.'&'.$this->id.'='.$sel_id.'">'.$name.'</a>&nbsp;:&nbsp;'.$path;
		}
		else {
			$path = '<a '.$class2.' href="'.$funcURL.'&'.$this->id.'='.$sel_id.'">'.$name.'</a>';
		}		
		$path = str_replace('&&', '&', $path); 
		if ( $parentid == 0 ) {
			return $path;
		}
		$path = $this->getNicePathFromId($parentid, $title, $funcURL, $path, $class);
		return $path;
	}

	//generates id path from the root id to a given id
	// the path is delimetered with "/"
	function getIdPathFromId($sel_id, $path=""){
		$result = $this->db->sql_query("SELECT ".$this->pid." FROM ".$this->table." WHERE ".$this->id."=$sel_id");
		if ( $this->db->sql_numrows($result) == 0 ) {
			return $path;
		}
		list($parentid) = $this->db->sql_fetchrow($result);//fetchRow
		$path = "/".$sel_id.$path."";
		if ( $parentid == 0 ) {
			return $path;
		}
		$path = $this->getIdPathFromId($parentid, $path);
		return $path;
	}


	function getAllChild($sel_id=0, $order='', $parray = array())
	{
		$sql = "SELECT * FROM ".$this->table." WHERE ".$this->pid."=".$sel_id."";
		if ( $order != '' ) {
			$sql .= " ORDER BY $order";
		}
		$result = $this->db->sql_query($sql);
		$count = $this->db->sql_numrows($result);
		if ( $count == 0 ) {
			return $parray;
		}
		while ( $row = $this->db->sql_fetchrow($result) ) //fetchArray
			{
			array_push($parray, $row);
			$parray=$this->getAllChild($row[$this->id],$order,$parray);
		}
		return $parray;
	}

	function getChildTreeArray($sel_id=0, $order='',$parray = array(),$r_prefix='') {
		
		$sql = "SELECT * FROM ".$this->table." WHERE ".$this->pid."=".$sel_id."";
		if ( $order != '' ) {
			$sql .= " ORDER BY $order";
		}
		$result = $this->db->sql_query($sql);
		$count = $this->db->sql_numrows($result);
		if ( $count == 0 ) {
			return $parray;
		}
		while ( $row = $this->db->sql_fetchrow($result) ) {	//fetchArray
			$row['prefix'] = $r_prefix.".";
			array_push($parray, $row);
			$parray = $this->getChildTreeArray($row[$this->id],$order,$parray,$row['prefix']);
		}
		return $parray;

	}

    
	// by PLB - pascal le Boustouller
	//makes a nicely ordered selection box
	//$preset_id is used to specify a preselected item
	//set $none to 1 to add a option with value 0
	function makeMapSelBox($title,$order="",$preset_id=0, $none=0, $sel_name="", $onchange=""){
		
		global $ixpdb, $myts;
	
		if ( $sel_name == "" ) {
			$sel_name = $this->id;
		}

        $indent0 = '<img src="'.IXP_ROOT_WEB_IMG.'/indent0.gif" />';
        $indent1 = '<img src="'.IXP_ROOT_WEB_IMG.'/indent1.gif" />';
        $indent_ = '<img src="'.IXP_ROOT_WEB_IMG.'/indent_.gif" />';
		$sql = "SELECT ".$this->id.", ".$title." FROM ".$this->table." WHERE ".$this->pid."=".$this->preset_pid;
		if ( $order != '' ) {
			$sql .= " ORDER BY $order";
		}
		$result = $ixpdb->sql_query($sql);

        $return_str = '';
		while ( list($catid, $name) = $ixpdb->sql_fetchrow($result) ) {

			$return_str .= '<br /><p style="display:inline;"><a href="index.php?op=addSubCat&cid='.$catid.'" title="'._GALAD_ADD_SUB_CAT.'"><img src="'.IXP_ROOT_WEB_IMG.'/plus.gif" alt="'._GALAD_ADD_SUB_CAT.'"></a>&nbsp;<a href="index.php?op=modCat&cid='.$catid.'" title="'._GALAD_MOD_MAIN_CAT.'"><strong>'.$name.'</strong></a> <br />';
			$arr = $this->getChildTreeMapArray($catid, title);
			
            foreach ( $arr as $option ) {
				
                $option['prefix'] = $indent0.str_replace(".", $indent1, $option['prefix']).$indent_;

				$return_str .= $option['prefix']
                    .'&nbsp;<a href="index.php?op=addSubCat&cid='.$option[$this->id].'" title="'._GALAD_ADD_SUB_CAT.'"><img src="'.IXP_ROOT_WEB_IMG.'/plus.gif" alt="'._GALAD_ADD_SUB_CAT.'"></a>'
                   
                    .'&nbsp;'.myTextFormWithImage('index.php?op=delCat&cid='.$option[$this->id].'&ok=1', _GALAD_DEL_SUB_CAT, IXP_ROOT_WEB_IMG.'/moins.gif', _GALAD_DEL_SUB_CAT.': '.$myts->makeTboxData4Show($option[$title]).' ?', 'margin:0;padding:0;background-color:#fff;display:inline;')

                    .'&nbsp;<a href="index.php?op=modCat&cid='.$option[$this->id].'" title="'._GALAD_ADD_SUB_CAT.'">'.$myts->makeTboxData4Show($option[$title]).'</a> <br />';
			}
		}
        return $return_str;
		
	}

	
	
		function getChildTreeMapArray($sel_id=0,$order="",$parray = array(),$r_prefix=""){
		global $ixpdb;
		$sql = "SELECT * FROM ".$this->table." WHERE ".$this->pid."=".$sel_id."";
		if ( $order != '' ) {
			$sql .= " ORDER BY $order";
		}
		$result = $ixpdb->sql_query($sql);
		$count = $ixpdb->sql_numrows($result);
		if ( $count == 0 ) {
			return $parray;
		}
		while ( $row = $ixpdb->sql_fetchrow($result) ) {
			$row['prefix'] = $r_prefix.".";
			array_push($parray, $row);
			$parray = $this->getChildTreeMapArray($row[$this->id],$order,$parray,$row['prefix']);
		}
		return $parray;
	}
	
	function setDb($value) {
		$this->db = $value;
	}
	
	function getDb($value) {
		return($this->db);
	}	
}
?>