<?php
//error_reporting(E_ALL);
##############################################################################
#                                                                            #
#      This file is part of IXPRIM CMS - Content Management System           #
#                       <http:#www.ixprim-cms.org/>                          #
#                                                                            #
#   Copyright (c) 2006 Christophe Deltheil <aka trollix> and contributors.   #
#                      All rights reserved.                                  #
# -------------------------------------------------------------------------- #
# ideas come from :                                                          #
# POSTNUKE Web Portal System - http://postnuke.org/                          #
# XOOPS Web Portal System - http://xoops.org/                                #
# myPHPNUKE Web Portal System - http://myphpnuke.com/                        #
# PHP-NUKE Web Portal System - http://phpnuke.org/                           #
# Thatware - http://thatware.org/                                            #
# dotclear Blog System - http://dotclear.net/                                #
# -------------------------------------------------------------------------- #
#  Ixprim CMS is free software; you can redistribute it and/or modify        #
#  it under the terms of the GNU General Public License as published by      #
#  the Free Software Foundation; either version 2 of the License, or         #
#  (at your option) any later version.                                       #
#                                                                            #
#  Ixprim CMS is distributed in the hope that it will be useful,             #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of            #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
#  GNU General Public License for more details.                              #
#                                                                            #
#  You should have received a copy of the GNU General Public License         #
#  along with this program; if not, write to the Free Software               #
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA  #
##############################################################################
include_once( IXP_ROOT_PATH.'/kernel/class/files.class.php' );
class ixpts
{
	var $theme;
	var $ixp_root_path;
	var $ixp_root_web;
	var $theme_root_web;
	
	/*
	* Constructor of this class
	*/
	function ixpts( $p_theme = '' ){
		if ($p_theme=='') {
			$this->theme = ixpts::get_default_theme();
		}
		else {
			$this->theme = $p_theme;
		}
		$this->root_path = IXP_ROOT_PATH;
		$this->root_web = IXP_ROOT_WEB;
		$this->theme_root_web = IXP_ROOT_WEB.'/themes/main/';
	}

	function &getInstance()
	{
		global $ixpdb;

		if ( isset($GLOBALS['ixpts']) && strtolower(get_class($GLOBALS['ixpts'])) == "ixpts" ) {
			return $GLOBALS['ixpts'];
		}
		return new ixpts();
	}

	function get_default_theme() 
	{
		if (defined('IXPGLOBAL___default_theme')) {
			return IXPGLOBAL___default_theme;
		}
		else {
			return 'NO_DEFAULT_THEME';
		}
	}
		
	function get_current_language() {
		return IXPGLOBAL___current_language;
	}

	function is_multilingual() {
		if (defined('IXPGLOBAL___multilingual')) {
			return IXPGLOBAL___multilingual;
		}
		else {
			return '0';
		}
	}

	function multilingual_drapeaux() {
		$drapeaux = '';
		if ( IXPGLOBAL___multilingual ) {
			$drapeaux = '<img src="'.IXP_ROOT_WEB_IMG.'/pixtr.gif" height="1" width="3" alt="" />';
			$tab_lang = unserialize(IXPGLOBAL___multilingual_drapeaux);
			foreach ( $tab_lang as $lang ) {
				$drapeaux .= '<a href="'.IXP_ROOT_WEB.'/to'.$lang.'.php"><img src="'.IXP_ROOT_WEB_IMG.'/flags/'.$lang.'.gif" alt="'.$lang.'" /></a>';
			}
		}
		return $drapeaux;
	}


	function &get_template( $position, $type_layout=0 )
	{
		global $SYSADMIN;
		
		$param = 'ixp.'.ixpts::get_current_language().'.'._MOD_DISPLAYED;

		switch ($position) {

			#----------------------------------------------------
			# sidebarleft
			#----------------------------------------------------
			case 'sidebarleft' :
				if ($type_layout==3 || $type_layout==1) {
					
					if (IXPGLOBAL___cache && IXPGLOBAL___cacheTime_sidebarleft >0) { // dans prfrences gnrales
						$cachetime = ($SYSADMIN ? 0 : IXPGLOBAL___cacheTime_sidebarleft);
						$iXcIDX =& new iXcache_class( $cachetime, IXP_ROOT_PATH."/cache", $param, $position);
						$r =& $iXcIDX->applyCacheStrFuncArray( array('ixpts','make_blocks'), array( IXP_SIDEBLOCKS_LEFT, _MOD_DISPLAYED));
						return $r;
					}
					else {
						$r = & ixpts::make_blocks( IXP_SIDEBLOCKS_LEFT, _MOD_DISPLAYED );
						return $r;
					}
				}
				else {
					return '' ;
				}
				break;

			#----------------------------------------------------
			# sidebarright
			#----------------------------------------------------
			case 'sidebarright' :
				if ($type_layout==3 || $type_layout==2) {

					if (IXPGLOBAL___cache && IXPGLOBAL___cacheTime_sidebarright >0) { // dans prfrences gnrales
						$cachetime = ($SYSADMIN ? 0 : IXPGLOBAL___cacheTime_sidebarright);
						$iXcIDX =& new iXcache_class( $cachetime, IXP_ROOT_PATH."/cache", $param, $position);
						$r =& $iXcIDX->applyCacheStrFuncArray( array('ixpts','make_blocks'), array( IXP_SIDEBLOCKS_RIGHT, _MOD_DISPLAYED));
						return $r;
					}
					else {
						$r =& ixpts::make_blocks( IXP_SIDEBLOCKS_RIGHT, _MOD_DISPLAYED ); 
						return $r; 
					}
				}
				else {
					return '';
				}
				break;

			#----------------------------------------------------
			# sidebarright
			#----------------------------------------------------
			case 'cblockstop' :
				if (IXPGLOBAL___cache && IXPGLOBAL___cacheTime_cblockstop >0) { // dans prfrences gnrales
					
					$cachetime = ($SYSADMIN ? 0 : IXPGLOBAL___cacheTime_cblockstop);
					$iXcIDX =& new iXcache_class( $cachetime, IXP_ROOT_PATH."/cache", $param, $position);
				    $r = & $iXcIDX->applyCacheStrFuncArray( array('ixpts','make_centerblocks'), array(_MOD_DISPLAYED, 'top'));
					return $r;
				}
				else {
				    $r =& ixpts::make_centerblocks( _MOD_DISPLAYED, 'top' );
					return $r;
				}
				break;

			#----------------------------------------------------
			# sidebarright
			#----------------------------------------------------
			case 'cblocksbottom' :
				if (IXPGLOBAL___cache && IXPGLOBAL___cacheTime_cblocksbottom >0) {  // dans prfrences gnrales
					
					$cachetime = ($SYSADMIN ? 0 : IXPGLOBAL___cacheTime_cblocksbottom);
				    $iXcIDX =& new iXcache_class( $cachetime, IXP_ROOT_PATH."/cache", $param, $position);
				    $r =& $iXcIDX->applyCacheStrFuncArray( array('ixpts','make_centerblocks'), array(_MOD_DISPLAYED, 'bottom'));
					return $r;
				}
				else {
				    $r =& ixpts::make_centerblocks( _MOD_DISPLAYED, 'bottom' );
					return $r;
				}
				break;

			#----------------------------------------------------
			# freeblock
			#----------------------------------------------------
			case 'freeblock' :
				$i = $type_layout; // POur rutiliser le mme paramtre
				if (IXPGLOBAL___cache && IXPGLOBAL___cacheTime_freeblocks >0 ) {
    
					$cachetime = ($SYSADMIN ? 0 : IXPGLOBAL___cacheTime_freeblocks);
					$iXcIDX =& new iXcache_class( $cachetime, IXP_ROOT_PATH."/cache", $param, 'freeblock'.$i);
					$r =& $iXcIDX->applyCacheStrFuncArray( array('ixpts','make_blocks'), array( constant('IXP_FREEBLOCKS_'.$i), _MOD_DISPLAYED));
					return $r;

				}
				else {
					$r =& ixpts::make_blocks( constant('IXP_FREEBLOCKS_'.$i), _MOD_DISPLAYED ); 
					return $r;
				}
				break;

			#----------------------------------------------------
			# simpleblock
			#----------------------------------------------------
			case 'simpleblock' :

				if (IXPGLOBAL___cache && IXPGLOBAL___cacheTime_freeblocks >0 ) {
    
					$cachetime = ($SYSADMIN ? 0 : IXPGLOBAL___cacheTime_freeblocks);
					$iXcIDX =& new iXcache_class( $cachetime, IXP_ROOT_PATH."/cache", $param, 'freeblock'.$i);
					$r =& $iXcIDX->applyCacheStrFuncArray( array('ixpts','make_blocks'), array( constant('IXP_FREEBLOCKS_'.$i), _MOD_DISPLAYED));
					return $r;

				}
				else {
					$r =& ixpts::make_blocks( constant('IXP_FREEBLOCKS_'.$i), _MOD_DISPLAYED ); 
					return $r;
				}
				break;

		}

	}


	// #################### Block functions from here ##################

	/*
	 * Purpose : Builds the blocks on both sides
	 * Input   : $side = On wich side should the block are displayed?
	 *             0, l, left : On the left side
	 *             1, r, right: On the right side
	 *             other:   Only on one side (
	 *                          Call from theme.php makes all blocks on the left side
	 *                          and from theme.php for the right site)
	 */
	function &make_blocks($side, $moduleName='') 
	{
		global $ixpUser, $ixpdb;

		$toreturn = '';
		$ixpblock = new ixpBlock();
		$arr = array();			#$tabModBlocks = array("3", "5", "11", "12");
				
		$moduleEC = ixpModule::getByDirname( $moduleName );  //moduleEC : Module En Cours (celui qui appelle le bloc)
		
		if (empty($moduleEC->dirname) or $moduleName =='onlymain') 
		{ 
			$moduleName = IXPGLOBAL___startpage; 
			$moduleEC = ixpModule::getByDirname( $moduleName );
		}
        if (empty($moduleName)) return '';
		
		//$sql = "SELECT mid, dirname, blockstodisplay FROM ".TBL_MODULES." WHERE dirname = '".$moduleName."' ";
		//$result = $ixpdb->sql_query($sql);
		//$array = $ixpdb->sql_fetchrow($result);//fetchArray
		//$tabModBlocks = unserialize(stripslashes($array['blockstodisplay']));
		$tabModBlocks = unserialize(stripslashes($moduleEC->blockstodisplay()));
		if (empty($tabModBlocks)) return '';  // on quite si aucun bloc
		
		if ( is_object($ixpUser) ) {    // on recup tous les blocs auquel le user a droit
			$arr = $ixpblock->getAllBlocksByGroupByModule($ixpUser->groups(), $tabModBlocks, true, $side, IXP_BLOCK_VISIBLE);
		} else {
			$arr = $ixpblock->getAllBlocksByGroupByModule(ixpGroup::getByType("Anonymous"), $tabModBlocks, true, $side, IXP_BLOCK_VISIBLE);
		}
		//print_r( $arr);
		
			
		$tempstr = '';
		$bid_of_mainmenu = 3;	// Bloc id du mainmenu - ne change jamais ==> 3
		foreach ( $arr as $myblock ) 
		{
			//print $myblock->getvar('cachetime');
			//print_r( $ixpUser->groups());

		  
			$bidEC = $myblock->getvar('bid'); // Block ID en Cours

			if ( (IXPGLOBAL___cache) && ($bidEC != $bid_of_mainmenu)) {

			###############################################################
			# CACHE
			  $param = IXPGLOBAL___current_language.$bidEC;
			  $prefix = 'b.'.$side;  
			  $SYSADMIN = ixpModule::isAdmin($myblock->getvar('mid')); 
			  $cachetime = ($SYSADMIN ? 0 : $myblock->getvar('cachetime'));
			  $iXcIDX = new iXcache_class( $cachetime , IXP_ROOT_PATH."/cache", $param, $prefix);
			  $block = $iXcIDX->applyCacheStrMethod( array($myblock, 'buildBlock') );
			# END CACHE
			##############################################################
		  
		  } else {
			$block = $myblock->buildBlock();
		  }
			
		  if ( ($block) && !strstr($block['content'], 'IXPSYS_NODISPLAYBLOCK') )
		  {
			#ici on teste le type de bloc pour le language -> qui s'applique qu'aux blocs personnaliss 'C'
			if ($block['type'] != 'C')
			{   			  
			  $tempstr .= themesideboxStr($block['title'],$block['content'], $block['themeblock'], $block['weightblock'], $block['spaceblock'], $bidEC );
			}
			elseif ($block['ixp_language'] == IXPGLOBAL___current_language || empty($block['ixp_language']))
			{
			  $tempstr .= themesideboxStr($block['title'],$block['content'], $block['themeblock'], $block['weightblock'], $block['spaceblock'], $bidEC );
			}
	      }
			
			#unset($myblock);
			#unset($block);
		}
	  return $tempstr;
	}

	/*
	 * Function to display center block
	 */
	function &make_centerblocks( $moduleName='', $pos='top' ) 
	{
		global $ixpUser, $ixpdb;
		
		$toreturn = '';

		$ixpblock = new ixpBlock();
		
		$arr = array();

		$moduleEC = ixpModule::getByDirname( $moduleName );
		if (empty($moduleEC->dirname) or $moduleName =='onlymain') 
		{ 
			$moduleName = IXPGLOBAL___startpage; 
			$moduleEC = ixpModule::getByDirname( $moduleName );
		}
        if (empty($moduleName)) return '';

		$tabModBlocks = unserialize(stripslashes($moduleEC->blockstodisplay()));
		if (empty($tabModBlocks)) return '';  // on quite si aucun bloc

		if ($pos=='top')
		{
			$IXP_CENTERBLOCKS_ALL	 = IXP_CENTERBLOCKS_ALL;
			$IXP_CENTERBLOCKS_CENTER = IXP_CENTERBLOCKS_CENTER;
			$IXP_CENTERBLOCKS_LEFT	 = IXP_CENTERBLOCKS_LEFT;
		}
		elseif($pos=='bottom')
		{
			$IXP_CENTERBLOCKS_ALL	= IXP_CENTERBLOCKS2_ALL;
			$IXP_CENTERBLOCKS_CENTER = IXP_CENTERBLOCKS2_CENTER;
			$IXP_CENTERBLOCKS_LEFT	= IXP_CENTERBLOCKS2_LEFT;
		}

		if ( is_object($ixpUser) ) {
		    $arr = $ixpblock->getAllBlocksByGroupByModule($ixpUser->groups(), $tabModBlocks, true, $IXP_CENTERBLOCKS_ALL, IXP_BLOCK_VISIBLE);
		} else {
		    $arr = $ixpblock->getAllBlocksByGroupByModule(ixpGroup::getByType("Anonymous"), $tabModBlocks, true, $IXP_CENTERBLOCKS_ALL, IXP_BLOCK_VISIBLE);
		}

		if ( count($arr) > 0 )
		{
		  
		  $cc_block_h = $cc_block_b = $cl_block = $cr_block = "";

		  foreach ( $arr as $myblock )
		  {
			$block = array();
			$bidEC = $myblock->getvar('bid'); // Block ID en Cours
			
			if (IXPGLOBAL___cache) {
				###############################################################
				# CACHE
				$param = 'centerblock'.IXPGLOBAL___current_language.$bidEC;
				$prefix = 'block';
				$SYSADMIN = ixpModule::isAdmin( $myblock->getvar('mid') ); 
				$cachetime = ($SYSADMIN ? 0 : $myblock->getvar('cachetime'));
				$iXcIDX = new iXcache_class( $cachetime, IXP_ROOT_PATH."/cache", $param, $prefix);
				// avec call_user_method $block = $iXcIDX->applyCacheStrMethod( buildBlock, $myblock );
				//			call_user_method($func, $obj, "method", "args", "go", "here"); 
				// new way:	call_user_func(array(&$obj, "method"), "method", "args", "go", "here"); 
				$block = $iXcIDX->applyCacheStrMethod( array($myblock, 'buildBlock'));
				# END CACHE
				##################################
			} else {
				$block = $myblock->buildBlock();
			}

			if ( ($block) && !strstr($block['content'], 'IXPSYS_NODISPLAYBLOCK') )
			{
			  $tempblock = $myblock->getVar("side");
			  $weight = $myblock->getVar("weight");

			  if ( $IXP_CENTERBLOCKS_CENTER == $tempblock ) 
			  {
				$tempcenter='';
				if ($block['type'] != 'C')
			    {
				  $tempcenter .= '<tr valign="top"><td colspan="2" width="100%">';
				  $tempcenter .= themesideboxStr($block['title'], $block['content'],  $block['themeblock'], $block['weightblock'], $block['spaceblock'], $bidEC);
				  $tempcenter .= '</td></tr>';
				}
				elseif ($block['ixp_language'] == IXPGLOBAL___current_language || empty($block['ixp_language']))
			    {
				  $tempcenter .= '<tr valign="top"><td colspan="2" width="100%">';
				  $tempcenter .= themesideboxStr($block['title'], $block['content'],  $block['themeblock'], $block['weightblock'], $block['spaceblock'], $bidEC);
				  $tempcenter .= '</td></tr>';
				}
				  if ($weight<100)	{ $cc_block_h .= $tempcenter; }
				  else				{ $cc_block_b .= $tempcenter; }
			  } 
			  elseif ( $IXP_CENTERBLOCKS_LEFT == $tempblock ) 
			  {
			    
				if ($block['type'] != 'C')
			    {  
                  $cl_block .= themesideboxStr($block['title'], $block['content'],  $block['themeblock'], $block['weightblock'], $block['spaceblock'], $bidEC);
				}
				elseif ($block['ixp_language'] == IXPGLOBAL___current_language || empty($block['ixp_language']))
			    {
                  $cl_block .= themesideboxStr($block['title'], $block['content'],  $block['themeblock'], $block['weightblock'], $block['spaceblock'], $bidEC);
				}

			  } 
			  else 
			  {

				if ($block['type'] != 'C')
			    {
				  $cr_block .= themesideboxStr($block['title'], $block['content'],  $block['themeblock'], $block['weightblock'], $block['spaceblock'], $bidEC);
				}
				elseif ($block['ixp_language'] == IXPGLOBAL___current_language || empty($block['ixp_language']))
			    {
				  $cr_block .= themesideboxStr($block['title'], $block['content'],  $block['themeblock'], $block['weightblock'], $block['spaceblock'], $bidEC);
				}

			  }
			}
			
			unset($myblock);
			unset($block);
		  }
		  

		$toreturn = '<table cellspacing="0" cellpadding="0" width="100%" border="0">'
			.$cc_block_h
			.'<tr valign="top">'
			.'  <td width="50%" height="100%">'.$cl_block.'</td>'
			.'  <td width="50%" height="100%">'.$cr_block.'</td>'
			.'</tr>'
			.$cc_block_b
			.'</table>';

	  }
	  return $toreturn;
	}


    function &make_theme_block($title, $content,  $p_themeblock="default", $width='100%', $space='1px1px1px1px') {

        $space = ($space=='') ? '1px' : $space;

        $search  = array( 
	        '{WIDTH}', 
	        '{TITLE}', 
	        '{CONTENT}' 
        );
        $replace = array( 
	        $width, 
	        $title, 
	        $content 
        );


        // le thme n'est pas encore cr
        if (! file_exists(IXP_ROOT_PATH.'/cache/themes/'.$p_themeblock.'.index.html')) {

        if (isset($ixpModule)) {
            $modname = $ixpModule->get_dirname();
        }

		// TiX: Make cache block layout
		 if (! file_exists(IXP_ROOT_PATH.'/mod/'.$modname.'/tpl/blocks/'.$p_themeblock.'.index.html')) {
			$l_layoutfile_src	= IXP_ROOT_PATH.'/mod/'.$modname.'/tpl/blocks/'.$p_themeblock.'.index.html';
			$l_layoutfile_dest	= IXP_ROOT_PATH.'/cache/themes/' .$p_themeblock.'.index.html';
			$l_images_path		= IXP_ROOT_PATH.'/mod/'.$modname.'/tpl/blocks/'.$p_themeblock;

            $theme_ok = $p_themeblock;
		}
		if (file_exists( IXP_ROOT_PATH.'/themes/main/'.ixpts::get_default_theme().'/blocks/'.$p_themeblock.'/index.html' )) {
			$l_layoutfile_src	= IXP_ROOT_PATH.'/themes/main/'.ixpts::get_default_theme().'/blocks/'.$p_themeblock.'/index.html';
			$l_layoutfile_dest	= IXP_ROOT_PATH.'/cache/themes/' .$p_themeblock.'.index.html';
			$l_images_path		= IXP_ROOT_WEB.'/themes/main/'.ixpts::get_default_theme().'/blocks/' .$p_themeblock;

            $theme_ok = $p_themeblock;
		}
		elseif (file_exists( IXP_ROOT_PATH.'/themes/tpl_default/system_blocks/'.$p_themeblock.'/index.html' )) {
			$l_layoutfile_src	= IXP_ROOT_PATH.'/themes/tpl_default/system_blocks/'.$p_themeblock.'/index.html';
			$l_layoutfile_dest	= IXP_ROOT_PATH.'/cache/themes/' .$p_themeblock.'.index.html';
			$l_images_path		= IXP_ROOT_WEB.'/themes/tpl_default/system_blocks/' .$p_themeblock;

            $theme_ok = $p_themeblock;
		}
		else {
			$l_layoutfile_src	= IXP_ROOT_PATH.'/themes/tpl_default/system_blocks/sys_default/index.html';
			$l_layoutfile_dest	= IXP_ROOT_PATH.'/cache/themes/sys_default.index.html';
			$l_images_path		= IXP_ROOT_WEB.'/themes/tpl_default/system_blocks/sys_default';

            $theme_ok = 'sys_default';
		}
		ixpts::_make_cache_layout($l_layoutfile_src, $l_layoutfile_dest, $l_images_path);

        }
        else {
            $theme_ok = $p_themeblock;
        }


        return '<table style="margin:'.preg_replace('#(\d+)#', '\\1px', $space).';padding:0px;border:0px;border-collapse:collapse;width:100%"><tr><td style="margin:0px;padding:0px;border:0px;">'.str_replace( $search, $replace, file_get_contents(IXP_ROOT_PATH.'/cache/themes/'.$theme_ok.'.index.html')).'</td></tr></table>'; 
    }

  function _make_cache_layout( $p_layoutfile_src, $p_layoutfile_dest, $p_images_path)
  {

	$pathimg2points = preg_match( '/(.+)((\/[a-z_.]+){1,2})/i', $p_images_path, $bibi );

	$l_search  = array( 
		
		'/="{IXP_ROOT_WEB}/i',		//isoler les tags ixprim {IXP_ROOT_WEB} et {IXP_URL}
		'/="{IXP_ROOT_THISBLOCK}/i',		//isoler les tags ixprim {IXP_ROOT_WEB} et {IXP_URL}
		'/src="http/i',		//isoler le src="http
		
		'/url\("\.\.\/([a-z_.]+?\/)/i',
		'/src="/i', 
		'/url\("/i',
		'/background="/i',
		'/media="all" href="/i',
		'/background:url\(/i',

		'/urltemp/',
		'/__SRCHTTP__/',	// on repasse dans l'autre sens
		'/__IXP_ROOT_THISBLOCK__/',	// on repasse dans l'autre sens
		'/__EGALE_IXP_ROOT_WEB__/',	// on repasse dans l'autre sens

		);
	$l_replace = array( 
		
		'__EGALE_IXP_ROOT_WEB__',
		'__IXP_ROOT_THISBLOCK__',
		'__SRCHTTP__',		// en le remplaant par un tag
		
		'urltemp("'.$bibi[1]."/\$1",
		'src="'.$p_images_path.'/',
		'url("'.$p_images_path.'/',
		'background="'.$p_images_path.'/',
		'media="all" href="'.$p_images_path.'/',
		'background:url('.$p_images_path.'/',

		'url',
		'src="http',		// on repasse dans l'autre sens
		'="'.$p_images_path.'/',		// on repasse dans l'autre sens
		'="'.IXP_ROOT_WEB,		// on repasse dans l'autre sens
		);

	//$contentfile = implode('',file($fileLayoutSrc));
	$l_contentfile = implode('', files::get_file_in_array( $p_layoutfile_src )); 
	$l_contentfile = preg_replace( $l_search, $l_replace, $l_contentfile );

	if ( file_exists($p_layoutfile_src) ) {
		if ($l_file = fopen($p_layoutfile_dest, "w")) {
			fwrite($l_file, $l_contentfile);
			fclose($l_file);
		}
	}

  }


  function render_array_tpl( $array_data, $moule) {
    return preg_replace('/{([\w]+)}/e', "\$array_data['\\1']", $moule );
  }
  function render_array_tpl_from_file( $array_data, $file) {
    return preg_replace('/{([\w]+)}/e', "\$array_data['\\1']", file_get_contents($file) );
  }

  function make_tpl_from_cache($p_layoutfile_src, $p_layoutfile_dest, $p_images_path) {
    ixpts::_make_cache_layout( 
            $p_layoutfile_src,  // file src
            $p_layoutfile_dest, // file dest
            $p_images_path      // images path
        );
    return file_get_contents($p_layoutfile_dest);
  }

  function create_tpl_file_in_cache($p_layoutfile_src, $p_layoutfile_dest, $p_images_path) {
    ixpts::_make_cache_layout( 
            $p_layoutfile_src,  // file src
            $p_layoutfile_dest, // file dest
            $p_images_path      // images path
        );
  }


	function create_file_in_cache($p_file_src, $p_file_dest) {

		$search  = array( '{IXP_ROOT_WEB}', '{IXP_URL}' );
		$replace = array( IXP_ROOT_WEB, IXP_URL);

		file_put_contents($p_file_dest, str_replace($search, $replace, file_get_contents($p_file_src)));
  }

	function render_tpl_from_cache($p_layoutfile_src, $p_layoutfile_dest, $p_images_path, $search, $replace, $type='str') {
    
		ixpts::_make_cache_layout( 
            $p_layoutfile_src,  // file src
            $p_layoutfile_dest, // file dest
            $p_images_path      // images path
		);
    
		if($type=='str') {
			return str_replace($search, $replace, file_get_contents($p_layoutfile_dest));
		} elseif ($type=='regex') {
			return preg_replace($search, $replace, file_get_contents($p_layoutfile_dest));
		} else {
			die('Error from templating');
		}

	}

	function &get_tpl( $p_template ) {
		
		if ( ! file_exists( $p_template )) {
			
			// make template
			include_once(IXP_ROOT_PATH."/kernel/class/admin.ixpts.class.php");

			// Regnrer les caches statiques des templates
			$a = & a_ixpts::getInstance();
			$a->theme = ixpts::get_default_theme();
			$a->refresh_all_static_cache();
		}
		
		return file_get_contents( $p_template );
	}

	function &render_tpl_from_file( &$search, &$replace, $p_template, $type='str') {
        
		if($type=='str') {
			return str_replace($search, $replace, ixpts::get_tpl($p_template) );
		} elseif ($type=='regex') {
			return preg_replace($search, $replace, ixpts::get_tpl($p_template) );
		} else {
			die('Error from templating');
		}

	}


  function set_template_path_bycontent($fileLayoutSrcContent, $new_path='') {

    // gestion des ../../rep 
	// ex de pathimg: /ixprimtest/themes/main/ixprim_portail_soft/layouts/articles
	// enlever les deux derniers repertoires du $pathimg pour mettre  la place de ../../rep

	$pathimg2points = preg_match( '/(.+)((\/[a-z_.]+){2})/i', $pathimg, $bibi );

	$search  = array( 
		//"'([\r\n])[\s]+'",  // Supprime les espaces
		"'([\r])'",  // Supprime les espaces
		

		'/src="\.\.\/\.\.\/([a-z_.]+?\/)/i',
		'/background="\.\.\/\.\.\/([a-z_.]+?\/)/i',
		'/media="all" href="\.\.\/\.\.\/([a-z_.]+?)\/([a-z_.]+?)/i',
		'/url\("\.\.\/\.\.\/([a-z_.]+?\/)/i',
			
		'/="{IXP_ROOT_WEB}/i',		//isoler les tags ixprim {IXP_ROOT_WEB} et {IXP_URL}
		'/src="http/i',	//isoler le src="http
		'/src="/i',
		'/url\("/i',
		'/background="/',
		'/media="all" href="/i',
		'/background:url\(/i',

		'/srctemp/',
		'/backgroundtemp/',
		'/mediatemp/',
		'/urltemp/',

		'/__SRCHTTP__/',	// on repasse dans l'autre sens
		'/__EGALE_IXP_ROOT_WEB__/',	// on repasse dans l'autre sens

		);

	$replace = array( 
		'',
		
	    'srctemp="'.$bibi[1]."/\$1",
		'backgroundtemp="'.$bibi[1]."/\$1",
		
        'mediatemp="all" href="'.$new_path."\$2",
		'urltemp("'.$bibi[1]."/\$1",

		'__EGALE_IXP_ROOT_WEB__',
		'__SRCHTTP__',		// en le remplaant par un tag
		'src="'.$new_path.'/',
		'url("'.$new_path.'/',
		'background="'.$new_path.'/',
		'media="all" href="'.$new_path,
		'background:url('.$new_path.'/',

		'src',
		'background',
		'media',
		'url',

		'src="http',	// on repasse dans l'autre sens
		'="'.IXP_ROOT_WEB,		// on repasse dans l'autre sens
		);

	return(preg_replace($search, $replace, $fileLayoutSrcContent));

  }

	// Not a static class
	function set_template_path_byfile($fileName, $templateName='default') {
		return( $this->set_template_path_bycontent(file_get_contents($this->root_path.'/themes/main/'.$this->theme.'/layouts/'.$templateName.'/'.$fileName), $this->root_web.'/themes/main/'.$this->theme.'/layouts/'.$templateName.'/'));
	}

}
?>