<?php
//error_reporting(E_ALL);
##############################################################################
#                                                                            #
#      This file is part of IXPRIM CMS - Content Management System           #
#                       <http:#www.ixprim-cms.org/>                          #
#                                                                            #
#   Copyright (c) 2006 Christophe Deltheil <aka trollix> and contributors.   #
#                      All rights reserved.                                  #
# -------------------------------------------------------------------------- #
# ideas come from :                                                          #
# POSTNUKE Web Portal System - http://postnuke.org/                          #
# XOOPS Web Portal System - http://xoops.org/                                #
# myPHPNUKE Web Portal System - http://myphpnuke.com/                        #
# PHP-NUKE Web Portal System - http://phpnuke.org/                           #
# Thatware - http://thatware.org/                                            #
# dotclear Blog System - http://dotclear.net/                                #
# -------------------------------------------------------------------------- #
#  Ixprim CMS is free software; you can redistribute it and/or modify        #
#  it under the terms of the GNU General Public License as published by      #
#  the Free Software Foundation; either version 2 of the License, or         #
#  (at your option) any later version.                                       #
#                                                                            #
#  Ixprim CMS is distributed in the hope that it will be useful,             #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of            #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
#  GNU General Public License for more details.                              #
#                                                                            #
#  You should have received a copy of the GNU General Public License         #
#  along with this program; if not, write to the Free Software               #
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA  #
##############################################################################

/*!
Example

  include_once 'ixpupload.php';
  
  $mime_types = array('image/gif', 'image/jpeg', 'image/pjpeg', 'image/x-png');
  $max_file_size = 50000;
  $max_file_width = 120;
  $max_file_height = 120;
  
  $my_upload = new ixpUpload( IXP_ROOT_PATH, $mime_types, $max_file_size, $max_file_width, $max_file_height);
  
  if ( $my_upload->process_file($_POST['upload_file_name'])) 
  {
    if (!$my_upload->upload_file()) 
	{
       echo $my_upload->get_errors();
    } 
	else 
	{
       echo '<h4>File uploaded successfully!</h4>'
       echo 'Saved as: ' . $my_upload->get_saved_file_name() . '<br />';
       echo 'Full path: ' . $my_upload->get_saved_destination();
    }
  } 
  else 
  {
    echo $uploader->get_errors();
  }
 
 */

class ixpUpload
{
    var $upload_file_name;
    var $upload_file_type;
    var $upload_file_size;
    var $upload_file_XxY;
    var $upload_file_temp_name;
    var $upload_file_error;

    var $upload_directory = '';
    var $upload_allowed_mime_type = array();

    var $upload_max_file_size = 0;
    var $upload_max_file_width;
    var $upload_max_file_height;
    var $upload_target_file_name;
    var $upload_file_prefix;

    var $upload_errors_tab = array();
    var $upload_saved_destination;
    var $upload_saved_file_name;
	var $upload_saved_file_ext;


	/*-----------------------------------------------------------------------*/
	/* Public Constructor
	/*-----------------------------------------------------------------------*/
    function ixpUpload (

		$upload_directory,				// Upload Directory
		$upload_allowed_mime_type,		// Types mimes autoriss
		$upload_max_file_size,			// Taille max en ko max du fichier
		$upload_max_file_width=null,	// Taille max de l'image (largeur)
		$upload_max_file_height=null	// Taille max de l'image (largeur)
	)
    
	{
        
		if (is_array($upload_allowed_mime_type)) 
		{
            $this->upload_allowed_mime_type =& $upload_allowed_mime_type;
        }
        $this->upload_directory = $upload_directory;
        $this->upload_max_file_size = intval($upload_max_file_size);
        
		if(isset($upload_max_file_width)) 
		{
            $this->upload_max_file_width = intval($upload_max_file_width);
        }
        
		if(isset($upload_max_file_height)) 
		{
            $this->upload_max_file_height = intval($upload_max_file_height);
        }

    }

	/*-----------------------------------------------------------------------*/
	/* Public process_file function
	/*-----------------------------------------------------------------------*/
    function process_file($file_name, $index = null)
    {

		if (!isset($_FILES[$file_name])) 
		{
			$this->set_errors( _IXPUPLOAD_FILENOTFOUND );
			return false;
		} 
		elseif (is_array($_FILES[$file_name]['name']) && isset($index)) 
		{
            $index = intval($index);
            $this->upload_file_name = $_FILES[$file_name]['name'][$index];
            $this->upload_file_type = $_FILES[$file_name]['type'][$index];
            $this->upload_file_size = $_FILES[$file_name]['size'][$index];
            $this->upload_file_temp_name = $_FILES[$file_name]['tmp_name'][$index];
            $this->upload_file_error = !empty($_FILES[$file_name]['error'][$index]) ? $_FILES[$file_name]['error'][$index] : 0;
		} 
		else 
		{
            $file_name =& $_FILES[$file_name];
            $this->upload_file_name = $file_name['name'];
            $this->upload_file_type = $file_name['type'];
            $this->upload_file_size = $file_name['size'];
            $this->upload_file_temp_name = $file_name['tmp_name'];
            $this->upload_file_error = !empty($file_name['error']) ? $file_name['error'] : 0;
        }

        $this->upload_errors_tab = array();
        

if (is_uploaded_file($this->upload_file_temp_name)) {
  
  //include code to copy tmp file to final location here...
  
}else{
  switch($file_name['error']){
   case 0: //no error; possible file attack!
     $this->set_errors( "There was a problem with your upload.");
     break;
   case 1: //uploaded file exceeds the upload_max_filesize directive in php.ini
     $this->set_errors( "The file you are trying to upload is too big.");
     break;
   case 2: //uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the html form
     $this->set_errors( "The file you are trying to upload is too big.");
     break;
   case 3: //uploaded file was only partially uploaded
     $this->set_errors( "The file you are trying upload was only partially uploaded.");
     break;
   case 4: //no file was uploaded
     $this->set_errors( "You must select an image for upload.");
     break;
   default: //a default error, just in case!  :)
     $this->set_errors( "There was a problem with your upload.");
     break;
}
}

		if (intval($this->upload_file_size) < 0) 
		{
            $this->set_errors( _IXPUPLOAD_INVALIDSIZEFILE );
            return false;
        }
        
		if ($this->upload_file_name == '') 
		{
            $this->set_errors( _IXPUPLOAD_INVALIDFILENAME );
            return false;
        }
        
		if ($this->upload_file_temp_name == 'none' || !is_uploaded_file($this->upload_file_temp_name)) 
		{
            $this->set_errors( _IXPUPLOAD_NOFILEUPLOADED );
            return false;
        }
        
		if ($this->upload_file_error > 0) 
		{
            $this->set_errors(_IXPUPLOAD_ERRORS.': '.$this->upload_file_error);
            return false;
        }
        
		if (isset($this->upload_max_file_width) || isset($this->upload_max_file_height)) 
		{
            if (false === ($this->upload_file_XxY = getimagesize($this->upload_file_temp_name))) 
			{
				$this->set_errors( _IXPUPLOAD_INVALIDIMAGEFILE );
				return false;
			}
        }
		
		$this->set_file_dest_ext( $this->upload_file_name );

        return true;
    }

    function set_target_file_name($value)
	{
        $this->upload_target_file_name = strval(trim($value));
    }

    function set_prefix($value)
	{
        $this->upload_file_prefix = strval(trim($value));
    }

    function get_file_name()
    {
        return $this->upload_file_name;
    }

    function get_file_type()
    {
        return $this->upload_file_type;
    }

    function get_file_size()
    {
        return $this->upload_file_size;
    }

    function get_file_temp_name()
    {
        return $this->upload_file_temp_name;
    }

    /**
     * Get the Dimensions ( X x Y )of the uploaded file
     * 
     * Returns an array with 4 elements. Index 0 contains the width of the image in pixels. Index 1 contains the height. Index 2 is a flag indicating the type of the image: 1 = GIF, 2 = JPG, 3 = PNG, 4 = SWF, 5 = PSD, 6 = BMP, 7 = TIFF(intel byte order), 8 = TIFF(motorola byte order), 9 = JPC, 10 = JP2, 11 = JPX, 12 = JB2, 13 = SWC, 14 = IFF. These values correspond to the IMAGETYPE constants that were added in PHP 4.3. Index 3 is a text string with the correct height="yyy" width="xxx" string that can be used directly in an IMG tag.  
     **/
    function get_file_XxY()
    {
        return $this->upload_file_XxY;
    }

    
	function get_saved_file_name()
	{
        return $this->upload_saved_file_name;
    }


    function get_saved_destination(){
        return $this->upload_saved_destination;
    }


	function get_saved_file_ext()
	{
        return $this->upload_saved_file_ext;
    }

    function upload_file()
    {
        
		if ($this->upload_directory == '') 
		{
            $this->set_errors( _IXPUPLOAD_UPLOADDIRNOTSET );
            return false;
        }
        
		if (!is_dir($this->upload_directory)) 
		{
            $this->set_errors(_IXPUPLOAD_FAILEDOPENDIR.': '.$this->upload_directory);
        }
        
		if (!is_writeable($this->upload_directory)) 
		{
            $this->set_errors(_IXPUPLOAD_FAILEDWRITE.': '.$this->upload_directory);
        }
        
		if (!$this->check_max_file_size()) 
		{
            $this->set_errors(_IXPUPLOAD_TOOLARGE.':'.$this->upload_file_size);
        }
        
		if (!$this->check_max_file_width()) 
		{
            $this->set_errors( _IXPUPLOAD_WIDTH_TOOLARGE.$this->upload_file_XxY[0]);
        }
        
		if (!$this->check_max_file_height()) 
		{
            $this->set_errors( _IXPUPLOAD_HEIGHT_TOOLARGE.$this->upload_file_XxY[1]);
        }
        
		if (!$this->check_file_mime_type()) 
		{
            $this->set_errors(_IXPUPLOAD_MIMETYPENOTALLOWED.': '.$this->upload_file_type);
        }
        
		if (count($this->upload_errors_tab) > 0) 
		{
            return false;
        }
        
		if (!$this->copy_file()) 
		{
            $this->set_errors( _IXPUPLOAD_ERRORS .': '.$this->upload_file_name);
            return false;
        }
        return true;
    }


    function copy_file()
    {
        
		$matched = array();
        
		if (!preg_match("/\.([a-zA-Z0-9]+)$/", $this->upload_file_name, $matched)) 
		{
            return false;
        }
        
		if (isset($this->upload_target_file_name)) 
		{
            $this->upload_saved_file_name = $this->upload_target_file_name;
        } 
		elseif (isset($this->upload_file_prefix)) 
		{
            $this->upload_saved_file_name = uniqid($this->upload_file_prefix).'.'.strtolower($matched[1]);
        } 
		else 
		{
            $this->upload_saved_file_name = strtolower($this->upload_file_name);
        }
        
		// Calcuol de la destination de sauvegarde puis chmd
		$this->upload_saved_destination = $this->upload_directory.'/'.$this->upload_saved_file_name;
        
		if (!move_uploaded_file($this->upload_file_temp_name, $this->upload_saved_destination)) 
		{
            return false;
        }

        @chmod($this->upload_saved_destination, 0644);

        return true;
    }


    function check_max_file_size()
    {
        if ($this->upload_file_size > $this->upload_max_file_size) 
		{
            return false;
        }
		else
		{
          return true;
		}
    }


    function check_max_file_width()
    {
        if (!isset($this->upload_max_file_width)) 
		{
            return true;
        }
        
		if ($this->upload_file_XxY[0] > $this->upload_max_file_width) 
		{
            return false;
        }
        
		return true;
    }

    function check_max_file_height()
    {
        if (!isset($this->upload_max_file_height)) {
            return true;
        }
        if ($this->upload_file_XxY[1] > $this->upload_max_file_height) {
            return false;
        }
        return true;
    }


    function check_file_mime_type()
    {
        if (count($this->upload_allowed_mime_type) > 0 && !in_array($this->upload_file_type, $this->upload_allowed_mime_type)) {
            return false;
        } else {
            return true;
        }
    }


    function set_errors($error)
    {
        $this->upload_errors_tab[] = trim($error);
    }


    function &get_errors($ashtml = true)
    {
        if (!$ashtml) 
		{
            return $this->upload_errors_tab;
        } 
		else 
		{
            $ret = '';
            if (count($this->upload_errors_tab) > 0) 
			{
                $ret = '<h4>'._IXPUPLOAD_ERRORS.'</h4>';
                foreach ($this->upload_errors_tab as $error) 
				{
                    $ret .= $error.'<br />';
                }
            }
            return $ret;
        }
    }

function set_file_dest_ext( $file_name ) 
{
	$this->upload_saved_file_ext = $this->ext_from_mime( $file_name );
}


function ext_from_mime( $file_name ) 
{

  $mimes = array(
	'application/msword'			=> '.doc',
	'application/octet-stream'		=> array(
									0 => '.php',
									1 => '.ini',
									2 => '.bin',
									3 => '.lha',
									4 => '.lzh',
									5 => '.exe',
									6 => '.class',
									7 => '.so',
									8 => '.dll'
									),
	'application/pdf'				=> '.pdf',
	'application/postscript'		=> '.ps',
	'application/vnd.ms-excel'		=> '.xls',
	'application/vnd.ms-powerpoint'	=> '.ppt',
	'application/x-gzip'			=> '.gz',
	'application/x-gzip-compressed'	=> '.tar.gz',
	'application/rar'				=> '.rar',
	'application/x-rar-compressed'  => '.rar',
	'application/x-javascript'		=> '.js',
	'application/x-latex'			=> '.latex',
	'application/x-sh'			=> '.sh',
	'application/x-shockwave-flash'	=> '.swf',
	'application/x-stuffit'			=> '.sit',
	'application/x-tar'			=> '.tar',
	'application/x-tcl'			=> '.tcl',
	'application/x-tex'			=> '.tex',
	'application/x-texinfo'			=> '.texinfo',
	'application/x-troff-man'		=> '.man',
	'application/x-ustar'			=> '.ustar',
	'application/zip'				=> '.zip',
	'application/x-zip-compressed'	=> '.zip',
	'audio/basic'				=> '.au',
	'audio/midi'				=> '.mid',
	'audio/mpeg'				=> '.mp3',
	'audio/x-aiff'				=> '.aiff',
	'audio/x-pn-realaudio'			=> '.ram',
	'audio/x-pn-realaudio-plugin'		=> '.rpm',
	'audio/x-realaudio'			=> '.ra',
	'audio/x-wav'				=> '.wav',
	'audio/wav'					=> '.wav',
	'image/bmp'					=> '.bmp',
	'image/gif'					=> '.gif',
	'image/ief'					=> '.ief',
	'image/jpeg'				=> '.jpg',
	'image/pjpeg'				=> '.jpg',
	'image/png'					=> '.png',
	'image/x-png'				=> '.png',
	'image/tiff'				=> '.tiff',
	'image/vnd.wap.wbmp'			=> '.wbmp',
	'image/x-portable-anymap'		=> '.pnm',
	'image/x-portable-bitmap'		=> '.pbm',
	'image/x-portable-graymap'		=> '.pgm',
	'image/x-portable-pixmap'		=> '.ppm',
	'image/x-xbitmap'				=> '.xbm',
	'image/x-xpixmap'				=> '.xpm',
	'model/vrml'				=> '.vrml',
	'text/css'					=> '.css',
	'text/html'					=> '.html',
	'text/plain'				=> array(
									0 => '.txt',
									1 => '.php'
									),
	'text/richtext'				=> '.rtf',
	'text/rtf'					=> '.rtf',
	'text/sgml'					=> '.sgml',
	'text/vnd.wap.wml'			=> '.wml',
	'text/vnd.wap.wmlscript'		=> '.wmls',
	'text/xml'					=> array(
									0 => '.xml',
									1 => '.xsl',
									2 => '.html',
									3 => '.htm',
									4 => '.shtml'
									),
	'video/mpeg'				=> '.mpeg',
	'video/quicktime'				=> array(
									0 => '.mov',
									1 => '.qt'
									),
	'video/x-msvideo'				=> '.avi',
	'video/x-sgi-movie'			=> '.movie'
	);
	
	foreach ($mimes as $type => $extension) 
	{
		if ($this->upload_file_type == $type) 
		{
			if ( is_array($extension) ) 
			{
				foreach ($extension as $ext) 
				{
					if ( preg_match("'".preg_quote($ext)."$'i", $this->upload_file_type) ) 
					{
						return $ext;
						break;
					}
				}
			} 
			else 
			{
				return $extension;
				break;
			}
		}
	}
}


function safe_ext( $p_ext ) 
{
	if ( preg_match("'[a-z0-9.*]'i", $p_ext)  ) 
	{
		if ( substr($p_ext, 0, 1) != '.' ) 
		{
			$p_ext = '.' . $p_ext;
		}
		return strtolower($p_ext);
	}
}



}
?>