<?php
//error_reporting(E_ALL);
##############################################################################
#                                                                            #
#      This file is part of IXPRIM CMS - Content Management System           #
#                       <http:#www.ixprim-cms.org/>                          #
#                                                                            #
#   Copyright (c) 2006 Christophe Deltheil <aka trollix> and contributors.   #
#                      All rights reserved.                                  #
# -------------------------------------------------------------------------- #
# ideas come from :                                                          #
# POSTNUKE Web Portal System - http://postnuke.org/                          #
# XOOPS Web Portal System - http://xoops.org/                                #
# myPHPNUKE Web Portal System - http://myphpnuke.com/                        #
# PHP-NUKE Web Portal System - http://phpnuke.org/                           #
# Thatware - http://thatware.org/                                            #
# dotclear Blog System - http://dotclear.net/                                #
# -------------------------------------------------------------------------- #
#  Ixprim CMS is free software; you can redistribute it and/or modify        #
#  it under the terms of the GNU General Public License as published by      #
#  the Free Software Foundation; either version 2 of the License, or         #
#  (at your option) any later version.                                       #
#                                                                            #
#  Ixprim CMS is distributed in the hope that it will be useful,             #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of            #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
#  GNU General Public License for more details.                              #
#                                                                            #
#  You should have received a copy of the GNU General Public License         #
#  along with this program; if not, write to the Free Software               #
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA  #
##############################################################################

include_once(IXP_ROOT_PATH."/kernel/class/ixpgroup.class.php");
include_once(IXP_ROOT_PATH."/kernel/class/ixpobject.class.php");

class ixpUserSession
{

	var $sessionID;
	var $cookie;
	var $expiretime;
	var $db;
	var $hash;
	var $uid;

	function ixpUserSession($sessionid='') {
        
        global $ixpdb;

		$this->db =& $ixpdb;
		$this->cookie = IXPGLOBAL___sessioncookie;
		$this->expiretime = IXPGLOBAL___sessionexpire;
		if($sessionid != '') {
			$this->sessionID = $sessionid;
		}
	}

	/*
	* creates new session for user 
	* and sets a cookie containing the session id
	*/
	function store() {

        $this->hash = md5(uniqid(rand()));
        if (IXP_ONLY_ONE_UID_ALLOWED) {
            $this->db->sql_query("DELETE FROM ".$this->db->prefix("session")." WHERE uid=".$this->uid." AND ip='".$GLOBALS['run__remote_addr']."'");
        }
	    $okinsert = $this->db->sql_query("INSERT INTO ".$this->db->prefix("session")." (uid, time, ip, hash) VALUES ($this->uid, ".time().", '".$GLOBALS['run__remote_addr']."', '$this->hash')");

	    if (!$okinsert) {
	        return false;
	    }
	    else {
	        setcookie($this->cookie, $this->hash, time()+360000, "/",  "", 0);
	        return true;
	    }
	}

	//-----------------------------------------------------
	// Affectation de la valeur de l'uid
	//-----------------------------------------------------
	function setUid($value) {
		$this->uid = $value;
	}

	function uid() {
		return $this->uid;
	}

	function isValid() {
		unset($uid);
		$mintime = time() - $this->expiretime;
        $this->db->sql_query("DELETE FROM ".$this->db->prefix("session")." WHERE time < $mintime");
		$sql = "SELECT uid FROM ".$this->db->prefix("session")." WHERE hash='".$this->sessionID."'";
    	if ( !$result = $this->db->sql_query($sql) ) {
			return false;
		}
    	list($uid) = $this->db->sql_fetchrow($result);
		if (!empty($uid)) {
		  $this->uid = $uid;
    	  return true;
    	}
    	return false;
	}

	/*
	* updates the session table
	*/
	function update(){
		$this->db->sql_query("UPDATE ".$this->db->prefix("session")." SET time=".time()." WHERE uid=".$this->uid." AND ip='".$GLOBALS['run__remote_addr']."'");
	}
}


Class ixpUser extends ixpObject{

	var $inactive = false;
	var $groups = array();

	function ixpUser($id=NULL)
	{
		$this->ixpObject();
		$this->initVar("uid", "int", NULL, false);
		$this->initVar("name", "textbox", NULL, false, 60, true);
		$this->initVar("uname", "textbox", NULL, true, 25, false);
		$this->initVar("email", "textbox", NULL, true, 60, false);
		$this->initVar("url", "textbox", NULL, false, 100, false);
		$this->initVar("user_avatar", "textbox", NULL, false, 30);
		$this->initVar("user_regdate", "int", NULL, false);


		$this->initVar("user_sig", "textarea", NULL, false, NULL, true);
		$this->initVar("user_viewemail", "int", 0, false);
		$this->initVar("actkey", "other", NULL, false);

		$this->initVar("pass", "textbox", NULL, false, 32, false);
		$this->initVar("posts", "int", NULL, false);
		$this->initVar("attachsig", "int", 0, false);
		$this->initVar("rank", "int", NULL, false);
		$this->initVar("level", "int", 0, false);
		$this->initVar("timezone_offset", "other", NULL, false);
		$this->initVar("last_login", "int", 0, false);
		$this->initVar("umode", "other", NULL, false);
		$this->initVar("uroder", "int", 1, false);


        //-------------------------------------------------------------------------------------
	    $result = $this->db->sql_query("SELECT field, length FROM ".$this->db->prefix("users_more_config") );
	    while(list($field, $length) = $this->db->sql_fetchrow($result)) 
	    {
          $this->initVar( $field, "textbox", NULL, false, $length, true);
	    }
	    //-------------------------------------------------------------------------------------

		if ( !empty($id) ) {
			if ( is_array($id) ) {
				$this->set($id);
			} else {
				$this->load(intval($id));
			}
		}
	}

	function login($uname, $pass)
	{
		$myts =& MyTextSanitizer::getInstance();
		
		$uname = $myts->makeTboxData4Save($uname);
		$result = $this->db->sql_query("SELECT uid, pass, level FROM ".$this->db->prefix("users")." WHERE uname='".$uname."'");
		
		if ( $this->db->sql_numrows($result) == 1 ) 
		{
			$convert = false;
			$passed = false;
			$myrow = $this->db->sql_fetchrow($result); //fetchArray
			if ( $myrow['level'] == 0 && !empty($myrow['uid']) ) 
			{
			  $this->inactive = true;
			  return false;
			}
			
			if ($myrow['uid'] != 0) 
			{
				if ($pass == $myrow['pass']) 
				{
					$convert =true;
					$passed=true;
				}
				if (function_exists('crypt')) 
				{
					if (crypt($pass,substr($myrow['pass'],0,2))== $myrow['pass'] ) 
					{
						$convert = true;
						$passed=true;
					}
				}

				if ($myrow['pass']==md5($pass)) 
				{
					$passed=true;
				}
				
				if ( $convert ) 
				{
					$newpass = md5($pass);
					$this->db->sql_query("UPDATE ".$this->db->prefix("users")." SET pass = '$newpass' WHERE uname = '$uname'");
				}
				
				if ( $passed ) 
				{
					$session = new ixpUserSession;
					$session->setUid($myrow['uid']);
					if (!$session->store()) 
					{
						return false;
					}
					$this->db->sql_query("UPDATE ".$this->db->prefix("users")." SET last_login=".time()." WHERE uid=".$myrow['uid']."");
					return $myrow['uid'];
				} 
				else 
				{
					return false;
				}
			} 
			else 
			{
				return false;
			}
		} 
		else 
		{
			return false;
		}
	}

	/*
	* Logs out user
	* removes user session from session table 
	*/
	function logout()  { 
        
        global $session;

        if (IXP_ONLY_ONE_UID_ALLOWED) {
            $this->db->sql_query("DELETE FROM ".TBL_SESSION." WHERE uid=".$this->getVar('uid'));
        } else {
            $this->db->sql_query("DELETE FROM ".TBL_SESSION." WHERE uid=".$this->getVar('uid')." AND hash='".$session->sessionID."'");
        }
        
        if (IXP_ONLY_ONE_UID_ALLOWED) {
            $this->db->sql_query("UPDATE ".$this->db->prefix("users_lastseen")." SET online=0 WHERE uid=".$this->getVar('uid'));
        } else {
            $sql = "SELECT COUNT(uid) FROM ".$this->db->prefix("users_lastseen")." WHERE uid=".$this->getVar("uid");
            $result = $this->db->sql_query( $sql );
            list($nbcount) = $this->db->sql_fetchrow($result);
            if ($nbcount==1) {
                $this->db->sql_query("UPDATE ".$this->db->prefix("users_lastseen")." SET online=0 WHERE uid=".$this->getVar('uid'));
            } else {
                //$this->db->sql_query("UPDATE ".$this->db->prefix("users_lastseen")." SET online=0 WHERE uid=".$this->getVar('uid'));
            }
        }
	}

	function load($id)
	{
	  $sql = "SELECT * FROM ".$this->db->prefix("users")." WHERE uid=".$id."";
	  if ( !$result = $this->db->sql_query($sql) ) {
          die("ERROR");
	  }
	  
	  //echo $sql;
	  $numrows = $this->db->sql_numrows($result);
	  if ( $numrows == 1 ) {
          $myrow = $this->db->sql_fetchrow($result);
		    $this->set($myrow);
		    if ( $this->getVar('level') == 0 ) {
		        $this->inactive = true;
		    }
	    } elseif ( $numrows == 0 )	{ 
            $this->inactive = true;
        } else { 
            die("Duplicate User Entries!"); 
        }
	}


	function store(){
		if ( !$this->isCleaned() ) {
			if ( !$this->cleanVars() ) {
				return false;
			}
		}
		foreach ( $this->cleanVars as $k=>$v ) {
			$$k = $v;
		}
		if ( empty($uid) ) 
		{

          //-------------------------------------------------------------------------------------
		  $tempsqlres1 = "";
		  $tempsqlres2 = "";
	      $result = $this->db->sql_query("SELECT field FROM ".$this->db->prefix("users_more_config") );
	      while(list($newfield) = $this->db->sql_fetchrow($result)) //fetchRow
	      {
			$tempsqlres1 .= ", ".$newfield;
			$tempsqlres2 .= ", '".$$newfield."'";
	      }
	      //-------------------------------------------------------------------------------------

			$uid = $this->db->sql_genId($this->db->prefix("users")."_uid_seq");
			$sql = "INSERT INTO ".$this->db->prefix("users")." (uid, uname, name, email, url, user_avatar, user_regdate, user_sig, user_viewemail, actkey, pass, posts, attachsig, rank, level, timezone_offset, last_login, umode, uorder".$tempsqlres1.") VALUES ($uid, '$uname', '$name', '$email', '$url', '$user_avatar', ".time().",  '$user_sig', '$user_viewemail', '$actkey', '$pass', '$posts', '$attachsig', '$rank', '$level', '$timezone_offset', 0, 'flat', '1'".$tempsqlres2.")";
		}  
		else 
		{

          //-------------------------------------------------------------------------------------
		  $tempsqlres = "";
	      $result = $this->db->sql_query("SELECT field FROM ".$this->db->prefix("users_more_config") );
	      while(list($newfield) = $this->db->sql_fetchrow($result)) //fetchRow
	      {
			$tempsqlres .= $newfield."='".$$newfield."'";
			if (!empty($tempsqlres)) { $tempsqlres .= ", "; }
	      }
	      //-------------------------------------------------------------------------------------

		  $sql ="UPDATE ".$this->db->prefix("users")." SET ".$tempsqlres." uname='$uname', name='$name', email='$email', url='$url', user_avatar='$user_avatar',  user_sig='$user_sig', user_viewemail='$user_viewemail', pass='$pass', attachsig='$attachsig', rank='$rank', timezone_offset='$timezone_offset', umode='$umode', uorder='$uorder' WHERE uid=$uid";
		}
		//echo $sql;
		if ( !$result = $this->db->sql_query($sql) ) {
			$this->setErrors("Could not store data in database.");
			return false;
		}
		if ( empty($uid) ) {
			$uid = $this->db->sql_nextid();
		}
		return $uid;
	}

	function delete()
	{
	  if ( $this->getVar('uid') > 0 ) 
	  {
	    $sql = "DELETE FROM ".$this->db->prefix("users")." WHERE uid=".$this->getVar("uid");
		if ( !$result = $this->db->sql_query($sql) ) { return false; }
		
		//0.968 $stat_mod = ixpModule::getByDirname("ixplinks");
        //0.968 if ( $stat_mod && $stat_mod->isActivated() ) 
		if ($GLOBALS['is_module_active']['dirname']['ixplinks']) { 
		    $this->db->sql_query("DELETE FROM ".$this->db->prefix("groups_users_link")." WHERE uid=".$this->getVar("uid"));
		}
		
	    $this->db->sql_query("DELETE FROM ".$this->db->prefix("priv_msgs")." WHERE to_userid=".$this->getVar("uid"));
		
		$this->logout();
	  }
	  return true;
	}

	function activate(){
		$sql = "UPDATE ".$this->db->prefix("users")." SET level=1 WHERE uid=".$this->getVar("uid")." AND actkey='".$this->getVar("actkey")."'";
		if ( !$result = $this->db->sql_query($sql) ) {
			return false;
		}
		return true;
	}
		
	function isActive(){
		if ( $this->inactive == true) {
			return false;
		} else {
			return true;
		}
	}

	function isAdmin($moduleid=1) {

		$groups = $this->groups(); //print_r($groups);
		foreach( $groups as $key=>$value) {
			if ( ixpGroup::checkRight("module", $moduleid, $value, "A") ) {
				return true;
			} else {
				//return false;
			}			
		}
		return false;
	}


	// user a-t-il accs au module N moduleid ?
	function hasModuleAccessByMid($moduleid=0)
	{
	  $groups = $this->groups();
	  if ( ixpGroup::checkRight("module", $moduleid, $groups, "R") ) 
	  {
	    return true;
	  }
	  else
	  {
	    return false;
	  }
	}

	// user a-t-il accs au module module_name ?
	function hasModuleAccessByName($module_name='ixp_system')
	{
	  $groups = $this->groups();
	  
	  //0.968 if ( ixpModule::moduleExists( $module_name ))
	  if ($GLOBALS['is_module_active']['dirname'][ $module_name ]) {
		    if ( ixpGroup::checkRight("module", ixpModule::mid_by_dirname( $module_name ) , $groups, "R") ) {
                return true;
		    } else {
			    return false;
		    }
	  } else {
			return false;
	  }
	}

	// boucle sur les modules actifs et cherche si l'user est admin d'un des modules
	// si oui, renvoie la valeur id du premier module dont il est admin
    function isCoweb() {    /* admin of a group which is not ixp_system */
	
	    $tab_active_modules = ixpModule::getHasMainModulesList(); //print_r($tab_active_modules);
	
	    foreach($tab_active_modules as $mod_id => $mod_name) {
            if ($this->isAdmin($mod_id)) {
                return $mod_id;
	        }
	    }
	    return false;
	}


	function rank($astitle=true){
		if ( $astitle ) {
			return $this->getRank();
		} else {
			return $this->getVar("rank");
		}
	}

	function getRank() {

		$myts =& MyTextSanitizer::getInstance();
		
        if ( $this->getVar("rank") != 0 ) {
        		$sql = "SELECT rank_title AS title, rank_image AS image FROM ".$this->db->prefix("ranks")." WHERE rank_id = ".$this->getVar("rank")."";
		} else {
			$sql = "SELECT rank_title AS title, rank_image AS image FROM ".$this->db->prefix("ranks")." WHERE rank_min <= " . $this->getVar("posts") . " AND rank_max >= " . $this->getVar("posts") . " AND rank_special = 0";
		}
		
        $result = $this->db->sql_query($sql);
        $myrow = $this->db->sql_fetchrow($result, MYSQL_ASSOC);	//fetchArray 200506
		$myrow['title'] = $myts->makeTboxData4Show($myrow['title']);
		$myrow['id'] = $this->getVar("rank");
		return $myrow;
	}

	/*
	*  returns an array of group ids this user belongs
	*/
	function groups(){
		$this->groups = ixpGroup::getByUser($this);
		return $this->groups;
	}

	//-------------------------------------------------------------------------
	// Function to get user name from a certain user id
	//-------------------------------------------------------------------------
	function getUnameFromId($userid) 
	{
		global $ixpdb, $myts;

	    if (empty($GLOBALS['userid'.$userid])) {
            $sql = "SELECT uname FROM ".$ixpdb->prefix("users")." WHERE uid = $userid";
		    if ( !$result = $ixpdb->sql_query($sql) ) {
                return false;
		    }
            if ( !$arr = $ixpdb->sql_fetchrow($result) ) {
                return false;
		    }

		    $uname = $myts->makeTboxData4Show($arr['uname']);
		    $GLOBALS['userid'.$userid] = $uname;
		    return $uname;
		}
		else return $GLOBALS['userid'.$userid];
	}

	//-------------------------------------------------------------------------
	// Function to get user name from a certain user id
	//-------------------------------------------------------------------------
	function getIdFromUname($uname) 
	{
		global $ixpdb, $myts;

	    if (empty($GLOBALS['uname'.$uname])) {
            $sql = "SELECT uid FROM ".$ixpdb->prefix("users")." WHERE uname = '$uname'";
		    if ( !$result = $ixpdb->sql_query($sql) ) {
                return false;
		    }
            if ( !$arr = $ixpdb->sql_fetchrow($result) ) {
                return false;
		    }

		    $uid = $myts->makeTboxData4Show($arr['uid']);
		    $GLOBALS['uname'.$uname] = $uid;
		    return $uid;
		}
		else return $GLOBALS['uname'.$uname];
	}

	function getPosts($uid) {

		global $ixpdb;

        $sql = "SELECT posts FROM ".$ixpdb->prefix("users")." WHERE uid = $uid";
        $result = $ixpdb->sql_query($sql);

		list($posts) = $ixpdb->sql_fetchrow($result);
        return $posts;
	}

	function incrementPost($uid, $inc=1) {
		
        global $ixpdb;
		
		$inc = ($inc=='') ? 0 : $inc;
		$sql = "UPDATE ".$ixpdb->prefix("users")." SET posts=posts+".$inc." WHERE uid='".$uid."'";
		$result = $ixpdb->sql_query($sql);
	}

	function decrementPost($uid, $inc=1) {
		
        global $ixpdb;

		$inc = ($inc=='') ? 0 : $inc;
		$sql = "UPDATE ".$ixpdb->prefix("users")." SET posts=posts-".$inc." WHERE uid=".$uid."";
		$result = $ixpdb->sql_query($sql);
	}

	function isOnline() {
        
        $sql = "SELECT COUNT(uid) FROM ".$this->db->prefix("users_lastseen")." WHERE uid=".$this->getVar("uid")." AND online=1";
		if ( !$result = $this->db->sql_query($sql) ) {
            return false;
		}
		list($count) = $this->db->sql_fetchrow($result);
		if ( $count > 0 ) {
			return true;
		}
		return false;
	}

	function getAllUsers($criteria=array(), $asobject=false, $orderby="uid ASC", $limit=0, $start=0)
	{
		global $ixpdb;

		$ret = array();
		$where_query = "";
		
        if ( is_array($criteria) && count($criteria) > 0 ) {
			$where_query = " WHERE";
			foreach ( $criteria as $c ) {
				$where_query .= " $c AND";
			}
			$where_query = substr($where_query, 0, -4);
		}
		
        if ( !$asobject ) {
			$sql = "SELECT uid FROM ".$ixpdb->prefix("users")."$where_query ORDER BY $orderby";
			$result = $ixpdb->sql_query($sql,$limit,$start);
			while ( $myrow = $ixpdb->sql_fetchrow($result) ) {
				$ret[] = $myrow['uid'];
			}
		} 
        else {
			$sql = "SELECT * FROM ".$ixpdb->prefix("users")."".$where_query." ORDER BY $orderby";
			$result = $ixpdb->sql_query($sql,$limit,$start);
			while ( $myrow = $ixpdb->sql_fetchrow($result) ) {
				$ret[] = new ixpUser($myrow);
			}
		}
		return $ret;
	}

	function countAllUsers($criteria=array())
	{
		global $ixpdb;

		$where_query = "";
		if ( is_array($criteria) && count($criteria) > 0 ) {
			$where_query = " WHERE";
			foreach ( $criteria as $c ) {
				$where_query .= " $c AND";
			}
			$where_query = substr($where_query, 0, -4);
		}
		#TiX: COUNT (*) by COUNT(uid)
		$sql = "SELECT COUNT(uid) FROM ".$ixpdb->prefix("users")."".$where_query."";
		$result = $ixpdb->sql_query($sql);
		list($ret) = $ixpdb->sql_fetchrow($result);//fetchRow
		return $ret;
	}



	function saveUserConfSQL($tabuserconf )
	{
		global $ixpdb;

		$tosave = addslashes(serialize($tabuserconf));
		$sql = "UPDATE ".$ixpdb->prefix("users")." SET userconf='".$tosave."' WHERE uid=".$this->getVar('uid');
		$result = $ixpdb->sql_query($sql);

		return $result;
	}

	function getUserConfSQL()
	{
		global $ixpdb;

        if ($this->getVar('uid')!=0) {
		    $sql = "SELECT userconf from ".$ixpdb->prefix("users")." WHERE uid=".$this->getVar('uid');
		    $result = $ixpdb->sql_query($sql);
		    list($string) = $ixpdb->sql_fetchrow($result); //fetchArray
		    $ixpdb->sql_freeresult($result);
            return( unserialize(stripslashes($string)) );
        }
        else {
            return '';
        }
	}

	function getUserAvatarImg($avec_root_web=true) {
		if ( ($this->getVar("user_avatar")=='') || (!file_exists(IXP_ROOT_PATH.'/images/avatar/'.$this->getVar("user_avatar"))))  {
			$l_avatar = 'blank.gif';
		} else {
			$l_avatar = $this->getVar("user_avatar");
		}

		if ($avec_root_web) {
			return IXP_ROOT_WEB.'/images/avatar/'.$l_avatar;
		} else {
			return $l_avatar;
		}

	}

}
?>