<?php
//error_reporting(E_ALL);
##############################################################################
#                                                                            #
#      This file is part of IXPRIM CMS - Content Management System           #
#                       <http:#www.ixprim-cms.org/>                          #
#                                                                            #
#   Copyright (c) 2006 Christophe Deltheil <aka trollix> and contributors.   #
#                      All rights reserved.                                  #
# -------------------------------------------------------------------------- #
# ideas come from :                                                          #
# POSTNUKE Web Portal System - http://postnuke.org/                          #
# XOOPS Web Portal System - http://xoops.org/                                #
# myPHPNUKE Web Portal System - http://myphpnuke.com/                        #
# PHP-NUKE Web Portal System - http://phpnuke.org/                           #
# Thatware - http://thatware.org/                                            #
# dotclear Blog System - http://dotclear.net/                                #
# -------------------------------------------------------------------------- #
#  Ixprim CMS is free software; you can redistribute it and/or modify        #
#  it under the terms of the GNU General Public License as published by      #
#  the Free Software Foundation; either version 2 of the License, or         #
#  (at your option) any later version.                                       #
#                                                                            #
#  Ixprim CMS is distributed in the hope that it will be useful,             #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of            #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
#  GNU General Public License for more details.                              #
#                                                                            #
#  You should have received a copy of the GNU General Public License         #
#  along with this program; if not, write to the Free Software               #
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA  #
##############################################################################

if (!defined("IXP_XMLRSS_INCLUDED")) 
{
  define("IXP_XML_RSSINCLUDED", 1);


  require(IXP_ROOT_PATH.'/kernel/class/rss/xmlwriterclass.php');
  require(IXP_ROOT_PATH.'/kernel/class/rss/rss_writer_class.php');

  class ixpXMLRSS 
  {

	var $channelTitle;
	var $channelLink;
	var $channelDesc;

	var $imgTitle;
	var $imgUrl;
	var $imgLink;
	var $imgDesc;
	var $imgHeight;
	var $imgWidth;
    
	var $nbItems;
	var $maxItems=10;
	var $longueurItemDesc;

	var $XMLRSSFile;
    var $XMLRSSWriterObject;


  function ixpXMLRSS($XMLRSSFile, $specif='1.0') {

	$this->XMLRSSFile			= $XMLRSSFile;
	if (empty($this->channelTitle))	$this->channelTitle = IXPGLOBAL___sitename.'::'.IXPGLOBAL___slogan;
	$this->channelLink		= IXP_URL . "/";
	if (empty($this->channelDesc)) $this->channelDesc	= IXPGLOBAL___sitename.'::'.IXPGLOBAL___slogan;
	$this->imgTitle		= $meta['title'];
	$this->imgUrl			= IXP_URL . "/images/button.gif";
	$this->imgLink			= IXP_URL . "/";
	$this->imgDesc	= IXPGLOBAL___slogan;
	$this->imgHeight		=  31;
	$this->imgWidth		=  88;
	//$this->maxItems			=  10;
	//$this->longueurItemDesc	= 200;
	$this->XMLRSSWriterObject=new rss_writer_class;

 	//-----------------------------------------------------------------------------
	// Begin RSS parsing
	//-----------------------------------------------------------------------------
	

	$this->XMLRSSWriterObject->specification=$specif;
	$this->XMLRSSWriterObject->generatedcomment='Generated by iXprim CMS XML/RDF';
	$this->XMLRSSWriterObject->inputencoding= _CHARSET ;
	$this->XMLRSSWriterObject->outputencoding= _CHARSET ;
	$this->XMLRSSWriterObject->about =	IXP_URL.'/xml/'.basename($this->XMLRSSFile);
	//$this->ss_writer_object->stylesheet = IXP_URL.'/xml/rss/rss2html.xsl';
	$this->XMLRSSWriterObject->rssnamespaces["dc"] = 'http://purl.org/dc/elements/1.1/';

	//---------------------------------------------------------------
	// Channel properties
	//---------------------------------------------------------------
	$properties=array();
	
	$properties['title'] = $this->cleanStr($this->channelTitle);
	$properties['link']	= $this->channelLink;
	$properties['description'] = $this->cleanStr($this->channelDesc);
	if ($this->XMLRSSWriterObject->specification=='1.0')
	{
	  $properties['dc:date'] = strftime("%Y-%m-%dT%TZ");#'2002-05-06T00:00:00Z';
	}
	else
	{
	  $properties['language'] = IXPGLOBAL___current_language;
	  //$properties['date'] = strftime("%Y-%m-%dT%TZ");#'2002-05-06T00:00:00Z';
	}
	
	$this->XMLRSSWriterObject->addchannel($properties);

	//---------------------------------------------------------------
	// Channel Logo image if any (rss 1.0 specification)
	//---------------------------------------------------------------
	$properties=array();
	
	$properties["title"] = $this->cleanStr($this->imgTitle).' Logo';
	$properties["link"] = $this->imgUrl;
	$properties["url"] = $this->imgUrl;
	$properties["description"] = $this->cleanStr($this->imgDesc);

	$this->XMLRSSWriterObject->addimage($properties);

  }

//-----------------------------------------------------------------------------
// Save XMLRSS in file
//-----------------------------------------------------------------------------
function saveXMLRSS() 
{

  //---------------------------------------------------------------
  // RSS generation
  //---------------------------------------------------------------
  if(!$this->XMLRSSWriterObject->writerss($output))
  {
    $output = $this->XMLRSSWriterObject->error;
  }


  if ( $fp = @fopen($this->XMLRSSFile, "w") ) 
  {
	fwrite($fp, $output);
	fclose($fp);
  } 
  else 
  {
    return false;
  }

return true;
}

//-----------------------------------------------------------------------------
// build XMLRSS 
//-----------------------------------------------------------------------------
function makeXMLRSS($title, $link, $desc='', $timestamp=0) 
{

  if ($this->nbItems < $this->maxItems) 
  {

	if ( !empty($desc) ) 
	{
	  $description = $this->cleanStr($desc, $this->longueurItemDesc);
	}

	$properties=array();
	$properties["title"] = $this->cleanStr($title);
	$properties["link"] = $link;
	$properties["description"] = $description;
	
	if ($this->XMLRSSWriterObject->specification=='1.0')
	{
	  if (empty($timestamp)) $timestamp=time();
	  $properties['dc:date'] = strftime("%Y-%m-%dT%TZ", $timestamp );#'2002-05-06T00:00:00Z';
	}
	//$properties["dc:date"] = strftime("%Y-%m-%dT%TZ", $dateline );#"2002-05-06T00:00:00Z";
	$this->XMLRSSWriterObject->additem($properties);

	$this->nbItems++;
  }
}

//-----------------------------------------------------------------------------
// cleanStr : nettoie la string 
//-----------------------------------------------------------------------------
function cleanStr($text, $trim=100) 
{
    global $myts;

	$clean = stripslashes($text);
	$clean = $myts->sanitizeForDisplay($clean,1,0,1);
	$clean = strip_tags($clean);
	$clean = substr($clean, 0, $trim);
	$clean = htmlspecialchars($clean, ENT_QUOTES);

return $clean;
}


} 


}
?>
